/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Register Bank Source Fragments                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_REGBANK_DECLARATIONS
#undef GET_REGBANK_DECLARATIONS
namespace llvm {
namespace M68k {
enum : unsigned {
  InvalidRegBankID = ~0u,
  GPRRegBankID = 0,
  NumRegisterBanks,
};
} // end namespace M68k
} // end namespace llvm
#endif // GET_REGBANK_DECLARATIONS

#ifdef GET_TARGET_REGBANK_CLASS
#undef GET_TARGET_REGBANK_CLASS
private:
  static const RegisterBank *RegBanks[];
  static const unsigned Sizes[];

public:
  const RegisterBank &getRegBankFromRegClass(const TargetRegisterClass &RC, LLT Ty) const override;
protected:
  M68kGenRegisterBankInfo(unsigned HwMode = 0);

#endif // GET_TARGET_REGBANK_CLASS

#ifdef GET_TARGET_REGBANK_IMPL
#undef GET_TARGET_REGBANK_IMPL
namespace llvm {
namespace M68k {
const uint32_t GPRRegBankCoverageData[] = {
    // 0-31
    (1u << (M68k::XR32RegClassID - 0)) |
    (1u << (M68k::XR16RegClassID - 0)) |
    (1u << (M68k::SPILLRegClassID - 0)) |
    (1u << (M68k::SPILL_RRegClassID - 0)) |
    (1u << (M68k::AR32RegClassID - 0)) |
    (1u << (M68k::AR16RegClassID - 0)) |
    (1u << (M68k::AR32_NOSPRegClassID - 0)) |
    (1u << (M68k::AR32_TCRegClassID - 0)) |
    (1u << (M68k::SPCRegClassID - 0)) |
    (1u << (M68k::DR32RegClassID - 0)) |
    (1u << (M68k::DR8RegClassID - 0)) |
    (1u << (M68k::DR16RegClassID - 0)) |
    (1u << (M68k::DR32_TCRegClassID - 0)) |
    (1u << (M68k::XR32_TCRegClassID - 0)) |
    0,
};

constexpr RegisterBank GPRRegBank(/* ID */ M68k::GPRRegBankID, /* Name */ "AnyGPR", /* CoveredRegClasses */ GPRRegBankCoverageData, /* NumRegClasses */ 26);
} // end namespace M68k

const RegisterBank *M68kGenRegisterBankInfo::RegBanks[] = {
    &M68k::GPRRegBank,
};

const unsigned M68kGenRegisterBankInfo::Sizes[] = {
    // Mode = 0 (Default)
    32,
};

M68kGenRegisterBankInfo::M68kGenRegisterBankInfo(unsigned HwMode)
    : RegisterBankInfo(RegBanks, M68k::NumRegisterBanks, Sizes, HwMode) {
  // Assert that RegBank indices match their ID's
#ifndef NDEBUG
  for (auto RB : enumerate(RegBanks))
    assert(RB.index() == RB.value()->getID() && "Index != ID");
#endif // NDEBUG
}
const RegisterBank &
M68kGenRegisterBankInfo::getRegBankFromRegClass(const TargetRegisterClass &RC, LLT) const {
  constexpr uint32_t InvalidRegBankID = uint32_t(M68k::InvalidRegBankID) & 1;
  static const uint32_t RegClass2RegBank[1] = {
    (uint32_t(M68k::GPRRegBankID) << 0) | // DR8RegClassID
    (uint32_t(InvalidRegBankID) << 1) |
    (uint32_t(M68k::GPRRegBankID) << 2) | // XR16RegClassID
    (uint32_t(M68k::GPRRegBankID) << 3) | // AR16RegClassID
    (uint32_t(M68k::GPRRegBankID) << 4) | // DR16RegClassID
    (uint32_t(InvalidRegBankID) << 5) |
    (uint32_t(InvalidRegBankID) << 6) |
    (uint32_t(InvalidRegBankID) << 7) |
    (uint32_t(InvalidRegBankID) << 8) |
    (uint32_t(M68k::GPRRegBankID) << 9) | // SPILLRegClassID
    (uint32_t(M68k::GPRRegBankID) << 10) | // SPILL_RRegClassID
    (uint32_t(M68k::GPRRegBankID) << 11) | // XR32RegClassID
    (uint32_t(M68k::GPRRegBankID) << 12) | // AR32RegClassID
    (uint32_t(M68k::GPRRegBankID) << 13) | // DR32RegClassID
    (uint32_t(InvalidRegBankID) << 14) |
    (uint32_t(M68k::GPRRegBankID) << 15) | // AR32_NOSPRegClassID
    (uint32_t(M68k::GPRRegBankID) << 16) | // XR32_TCRegClassID
    (uint32_t(InvalidRegBankID) << 17) |
    (uint32_t(M68k::GPRRegBankID) << 18) | // AR32_TCRegClassID
    (uint32_t(M68k::GPRRegBankID) << 19) | // DR32_TCRegClassID
    (uint32_t(InvalidRegBankID) << 20) |
    (uint32_t(InvalidRegBankID) << 21) |
    (uint32_t(InvalidRegBankID) << 22) |
    (uint32_t(M68k::GPRRegBankID) << 23) // SPCRegClassID
  };
  const unsigned RegClassID = RC.getID();
  if (LLVM_LIKELY(RegClassID < 24)) {
    unsigned RegBankID = (RegClass2RegBank[RegClassID / 32] >> ((RegClassID % 32) * 1)) & 1;
    if (RegBankID != InvalidRegBankID)
      return getRegBank(RegBankID);
  }
  llvm_unreachable(llvm::Twine("Target needs to handle register class ID 0x").concat(llvm::Twine::utohexstr(RegClassID)).str().c_str());
}
} // end namespace llvm
#endif // GET_TARGET_REGBANK_IMPL
