/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * M68k Disassembler                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable80[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 0, 105, 10, 0, // Skip to: 2673
/* 8 */       MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11 */      MCD::OPC_FilterValue, 0, 65, 0, 0, // Skip to: 81
/* 16 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 19 */      MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 35
/* 24 */      MCD::OPC_CheckField, 24, 8, 0, 133, 59, 0, // Skip to: 15268
/* 31 */      MCD::OPC_Decode, 151, 4, 0, // Opcode: BTST32di
/* 35 */      MCD::OPC_FilterValue, 5, 18, 0, 0, // Skip to: 58
/* 40 */      MCD::OPC_CheckField, 24, 8, 0, 117, 59, 0, // Skip to: 15268
/* 47 */      MCD::OPC_CheckField, 3, 1, 0, 110, 59, 0, // Skip to: 15268
/* 54 */      MCD::OPC_Decode, 217, 10, 1, // Opcode: XOR8di
/* 58 */      MCD::OPC_FilterValue, 6, 101, 59, 0, // Skip to: 15268
/* 63 */      MCD::OPC_CheckField, 24, 8, 0, 94, 59, 0, // Skip to: 15268
/* 70 */      MCD::OPC_CheckField, 3, 1, 0, 87, 59, 0, // Skip to: 15268
/* 77 */      MCD::OPC_Decode, 253, 4, 2, // Opcode: CMP8di
/* 81 */      MCD::OPC_FilterValue, 1, 158, 0, 0, // Skip to: 244
/* 86 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 89 */      MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 112
/* 94 */      MCD::OPC_CheckField, 24, 8, 0, 63, 59, 0, // Skip to: 15268
/* 101 */     MCD::OPC_CheckField, 3, 1, 0, 56, 59, 0, // Skip to: 15268
/* 108 */     MCD::OPC_Decode, 202, 9, 3, // Opcode: OR8ji
/* 112 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 135
/* 117 */     MCD::OPC_CheckField, 24, 8, 0, 40, 59, 0, // Skip to: 15268
/* 124 */     MCD::OPC_CheckField, 3, 1, 0, 33, 59, 0, // Skip to: 15268
/* 131 */     MCD::OPC_Decode, 226, 3, 3, // Opcode: AND8ji
/* 135 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 158
/* 140 */     MCD::OPC_CheckField, 24, 8, 0, 17, 59, 0, // Skip to: 15268
/* 147 */     MCD::OPC_CheckField, 3, 1, 0, 10, 59, 0, // Skip to: 15268
/* 154 */     MCD::OPC_Decode, 197, 10, 3, // Opcode: SUB8ji
/* 158 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 181
/* 163 */     MCD::OPC_CheckField, 24, 8, 0, 250, 58, 0, // Skip to: 15268
/* 170 */     MCD::OPC_CheckField, 3, 1, 0, 243, 58, 0, // Skip to: 15268
/* 177 */     MCD::OPC_Decode, 182, 3, 3, // Opcode: ADD8ji
/* 181 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 221
/* 186 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 189 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 205
/* 194 */     MCD::OPC_CheckField, 24, 8, 0, 219, 58, 0, // Skip to: 15268
/* 201 */     MCD::OPC_Decode, 157, 4, 3, // Opcode: BTST8ji
/* 205 */     MCD::OPC_FilterValue, 1, 210, 58, 0, // Skip to: 15268
/* 210 */     MCD::OPC_CheckField, 24, 8, 0, 203, 58, 0, // Skip to: 15268
/* 217 */     MCD::OPC_Decode, 161, 4, 3, // Opcode: BTST8oi
/* 221 */     MCD::OPC_FilterValue, 6, 194, 58, 0, // Skip to: 15268
/* 226 */     MCD::OPC_CheckField, 24, 8, 0, 187, 58, 0, // Skip to: 15268
/* 233 */     MCD::OPC_CheckField, 3, 1, 0, 180, 58, 0, // Skip to: 15268
/* 240 */     MCD::OPC_Decode, 131, 5, 4, // Opcode: CMP8ji
/* 244 */     MCD::OPC_FilterValue, 2, 158, 0, 0, // Skip to: 407
/* 249 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 252 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 275
/* 257 */     MCD::OPC_CheckField, 24, 8, 0, 156, 58, 0, // Skip to: 15268
/* 264 */     MCD::OPC_CheckField, 3, 1, 1, 149, 58, 0, // Skip to: 15268
/* 271 */     MCD::OPC_Decode, 204, 9, 5, // Opcode: OR8pi
/* 275 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 298
/* 280 */     MCD::OPC_CheckField, 24, 8, 0, 133, 58, 0, // Skip to: 15268
/* 287 */     MCD::OPC_CheckField, 3, 1, 1, 126, 58, 0, // Skip to: 15268
/* 294 */     MCD::OPC_Decode, 228, 3, 5, // Opcode: AND8pi
/* 298 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 321
/* 303 */     MCD::OPC_CheckField, 24, 8, 0, 110, 58, 0, // Skip to: 15268
/* 310 */     MCD::OPC_CheckField, 3, 1, 1, 103, 58, 0, // Skip to: 15268
/* 317 */     MCD::OPC_Decode, 199, 10, 5, // Opcode: SUB8pi
/* 321 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 344
/* 326 */     MCD::OPC_CheckField, 24, 8, 0, 87, 58, 0, // Skip to: 15268
/* 333 */     MCD::OPC_CheckField, 3, 1, 1, 80, 58, 0, // Skip to: 15268
/* 340 */     MCD::OPC_Decode, 184, 3, 5, // Opcode: ADD8pi
/* 344 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 384
/* 349 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 352 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 368
/* 357 */     MCD::OPC_CheckField, 24, 8, 0, 56, 58, 0, // Skip to: 15268
/* 364 */     MCD::OPC_Decode, 153, 4, 3, // Opcode: BTST8ei
/* 368 */     MCD::OPC_FilterValue, 1, 47, 58, 0, // Skip to: 15268
/* 373 */     MCD::OPC_CheckField, 24, 8, 0, 40, 58, 0, // Skip to: 15268
/* 380 */     MCD::OPC_Decode, 163, 4, 5, // Opcode: BTST8pi
/* 384 */     MCD::OPC_FilterValue, 6, 31, 58, 0, // Skip to: 15268
/* 389 */     MCD::OPC_CheckField, 24, 8, 0, 24, 58, 0, // Skip to: 15268
/* 396 */     MCD::OPC_CheckField, 3, 1, 1, 17, 58, 0, // Skip to: 15268
/* 403 */     MCD::OPC_Decode, 133, 5, 6, // Opcode: CMP8pi
/* 407 */     MCD::OPC_FilterValue, 3, 39, 1, 0, // Skip to: 707
/* 412 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 415 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 445
/* 420 */     MCD::OPC_CheckField, 40, 4, 8, 249, 57, 0, // Skip to: 15268
/* 427 */     MCD::OPC_CheckField, 24, 8, 0, 242, 57, 0, // Skip to: 15268
/* 434 */     MCD::OPC_CheckField, 3, 1, 0, 235, 57, 0, // Skip to: 15268
/* 441 */     MCD::OPC_Decode, 200, 9, 7, // Opcode: OR8fi
/* 445 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 475
/* 450 */     MCD::OPC_CheckField, 40, 4, 8, 219, 57, 0, // Skip to: 15268
/* 457 */     MCD::OPC_CheckField, 24, 8, 0, 212, 57, 0, // Skip to: 15268
/* 464 */     MCD::OPC_CheckField, 3, 1, 0, 205, 57, 0, // Skip to: 15268
/* 471 */     MCD::OPC_Decode, 224, 3, 7, // Opcode: AND8fi
/* 475 */     MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 505
/* 480 */     MCD::OPC_CheckField, 40, 4, 8, 189, 57, 0, // Skip to: 15268
/* 487 */     MCD::OPC_CheckField, 24, 8, 0, 182, 57, 0, // Skip to: 15268
/* 494 */     MCD::OPC_CheckField, 3, 1, 0, 175, 57, 0, // Skip to: 15268
/* 501 */     MCD::OPC_Decode, 195, 10, 7, // Opcode: SUB8fi
/* 505 */     MCD::OPC_FilterValue, 3, 25, 0, 0, // Skip to: 535
/* 510 */     MCD::OPC_CheckField, 40, 4, 8, 159, 57, 0, // Skip to: 15268
/* 517 */     MCD::OPC_CheckField, 24, 8, 0, 152, 57, 0, // Skip to: 15268
/* 524 */     MCD::OPC_CheckField, 3, 1, 0, 145, 57, 0, // Skip to: 15268
/* 531 */     MCD::OPC_Decode, 180, 3, 7, // Opcode: ADD8fi
/* 535 */     MCD::OPC_FilterValue, 4, 73, 0, 0, // Skip to: 613
/* 540 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 543 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 566
/* 548 */     MCD::OPC_CheckField, 40, 4, 8, 121, 57, 0, // Skip to: 15268
/* 555 */     MCD::OPC_CheckField, 24, 8, 0, 114, 57, 0, // Skip to: 15268
/* 562 */     MCD::OPC_Decode, 155, 4, 7, // Opcode: BTST8fi
/* 566 */     MCD::OPC_FilterValue, 1, 105, 57, 0, // Skip to: 15268
/* 571 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 574 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 590
/* 579 */     MCD::OPC_CheckField, 24, 8, 0, 90, 57, 0, // Skip to: 15268
/* 586 */     MCD::OPC_Decode, 165, 4, 8, // Opcode: BTST8qi
/* 590 */     MCD::OPC_FilterValue, 3, 81, 57, 0, // Skip to: 15268
/* 595 */     MCD::OPC_CheckField, 40, 4, 8, 74, 57, 0, // Skip to: 15268
/* 602 */     MCD::OPC_CheckField, 24, 8, 0, 67, 57, 0, // Skip to: 15268
/* 609 */     MCD::OPC_Decode, 159, 4, 9, // Opcode: BTST8ki
/* 613 */     MCD::OPC_FilterValue, 6, 58, 57, 0, // Skip to: 15268
/* 618 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 621 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 644
/* 626 */     MCD::OPC_CheckField, 40, 4, 8, 43, 57, 0, // Skip to: 15268
/* 633 */     MCD::OPC_CheckField, 24, 8, 0, 36, 57, 0, // Skip to: 15268
/* 640 */     MCD::OPC_Decode, 130, 5, 10, // Opcode: CMP8fi
/* 644 */     MCD::OPC_FilterValue, 1, 27, 57, 0, // Skip to: 15268
/* 649 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 652 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 668
/* 657 */     MCD::OPC_CheckField, 24, 8, 0, 12, 57, 0, // Skip to: 15268
/* 664 */     MCD::OPC_Decode, 250, 4, 11, // Opcode: CMP8bi
/* 668 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 684
/* 673 */     MCD::OPC_CheckField, 24, 8, 0, 252, 56, 0, // Skip to: 15268
/* 680 */     MCD::OPC_Decode, 134, 5, 12, // Opcode: CMP8qi
/* 684 */     MCD::OPC_FilterValue, 3, 243, 56, 0, // Skip to: 15268
/* 689 */     MCD::OPC_CheckField, 40, 4, 8, 236, 56, 0, // Skip to: 15268
/* 696 */     MCD::OPC_CheckField, 24, 8, 0, 229, 56, 0, // Skip to: 15268
/* 703 */     MCD::OPC_Decode, 132, 5, 13, // Opcode: CMP8ki
/* 707 */     MCD::OPC_FilterValue, 4, 51, 0, 0, // Skip to: 763
/* 712 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 715 */     MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 731
/* 720 */     MCD::OPC_CheckField, 24, 8, 0, 205, 56, 0, // Skip to: 15268
/* 727 */     MCD::OPC_Decode, 236, 3, 0, // Opcode: BCHG32di
/* 731 */     MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 747
/* 736 */     MCD::OPC_CheckField, 3, 1, 0, 189, 56, 0, // Skip to: 15268
/* 743 */     MCD::OPC_Decode, 213, 10, 14, // Opcode: XOR16di
/* 747 */     MCD::OPC_FilterValue, 6, 180, 56, 0, // Skip to: 15268
/* 752 */     MCD::OPC_CheckField, 3, 1, 0, 173, 56, 0, // Skip to: 15268
/* 759 */     MCD::OPC_Decode, 226, 4, 15, // Opcode: CMP16di
/* 763 */     MCD::OPC_FilterValue, 5, 123, 0, 0, // Skip to: 891
/* 768 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 771 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 787
/* 776 */     MCD::OPC_CheckField, 3, 1, 0, 149, 56, 0, // Skip to: 15268
/* 783 */     MCD::OPC_Decode, 175, 9, 16, // Opcode: OR16ji
/* 787 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 803
/* 792 */     MCD::OPC_CheckField, 3, 1, 0, 133, 56, 0, // Skip to: 15268
/* 799 */     MCD::OPC_Decode, 199, 3, 16, // Opcode: AND16ji
/* 803 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 819
/* 808 */     MCD::OPC_CheckField, 3, 1, 0, 117, 56, 0, // Skip to: 15268
/* 815 */     MCD::OPC_Decode, 162, 10, 16, // Opcode: SUB16ji
/* 819 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 835
/* 824 */     MCD::OPC_CheckField, 3, 1, 0, 101, 56, 0, // Skip to: 15268
/* 831 */     MCD::OPC_Decode, 147, 3, 16, // Opcode: ADD16ji
/* 835 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 875
/* 840 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 843 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 859
/* 848 */     MCD::OPC_CheckField, 24, 8, 0, 77, 56, 0, // Skip to: 15268
/* 855 */     MCD::OPC_Decode, 242, 3, 3, // Opcode: BCHG8ji
/* 859 */     MCD::OPC_FilterValue, 1, 68, 56, 0, // Skip to: 15268
/* 864 */     MCD::OPC_CheckField, 24, 8, 0, 61, 56, 0, // Skip to: 15268
/* 871 */     MCD::OPC_Decode, 244, 3, 3, // Opcode: BCHG8oi
/* 875 */     MCD::OPC_FilterValue, 6, 52, 56, 0, // Skip to: 15268
/* 880 */     MCD::OPC_CheckField, 3, 1, 0, 45, 56, 0, // Skip to: 15268
/* 887 */     MCD::OPC_Decode, 233, 4, 17, // Opcode: CMP16ji
/* 891 */     MCD::OPC_FilterValue, 6, 123, 0, 0, // Skip to: 1019
/* 896 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 899 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 915
/* 904 */     MCD::OPC_CheckField, 3, 1, 1, 21, 56, 0, // Skip to: 15268
/* 911 */     MCD::OPC_Decode, 177, 9, 18, // Opcode: OR16pi
/* 915 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 931
/* 920 */     MCD::OPC_CheckField, 3, 1, 1, 5, 56, 0, // Skip to: 15268
/* 927 */     MCD::OPC_Decode, 201, 3, 18, // Opcode: AND16pi
/* 931 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 947
/* 936 */     MCD::OPC_CheckField, 3, 1, 1, 245, 55, 0, // Skip to: 15268
/* 943 */     MCD::OPC_Decode, 164, 10, 18, // Opcode: SUB16pi
/* 947 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 963
/* 952 */     MCD::OPC_CheckField, 3, 1, 1, 229, 55, 0, // Skip to: 15268
/* 959 */     MCD::OPC_Decode, 149, 3, 18, // Opcode: ADD16pi
/* 963 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1003
/* 968 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 971 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 987
/* 976 */     MCD::OPC_CheckField, 24, 8, 0, 205, 55, 0, // Skip to: 15268
/* 983 */     MCD::OPC_Decode, 238, 3, 3, // Opcode: BCHG8ei
/* 987 */     MCD::OPC_FilterValue, 1, 196, 55, 0, // Skip to: 15268
/* 992 */     MCD::OPC_CheckField, 24, 8, 0, 189, 55, 0, // Skip to: 15268
/* 999 */     MCD::OPC_Decode, 246, 3, 5, // Opcode: BCHG8pi
/* 1003 */    MCD::OPC_FilterValue, 6, 180, 55, 0, // Skip to: 15268
/* 1008 */    MCD::OPC_CheckField, 3, 1, 1, 173, 55, 0, // Skip to: 15268
/* 1015 */    MCD::OPC_Decode, 235, 4, 19, // Opcode: CMP16pi
/* 1019 */    MCD::OPC_FilterValue, 7, 191, 0, 0, // Skip to: 1215
/* 1024 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1027 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1050
/* 1032 */    MCD::OPC_CheckField, 40, 4, 8, 149, 55, 0, // Skip to: 15268
/* 1039 */    MCD::OPC_CheckField, 3, 1, 0, 142, 55, 0, // Skip to: 15268
/* 1046 */    MCD::OPC_Decode, 173, 9, 20, // Opcode: OR16fi
/* 1050 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1073
/* 1055 */    MCD::OPC_CheckField, 40, 4, 8, 126, 55, 0, // Skip to: 15268
/* 1062 */    MCD::OPC_CheckField, 3, 1, 0, 119, 55, 0, // Skip to: 15268
/* 1069 */    MCD::OPC_Decode, 197, 3, 20, // Opcode: AND16fi
/* 1073 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1096
/* 1078 */    MCD::OPC_CheckField, 40, 4, 8, 103, 55, 0, // Skip to: 15268
/* 1085 */    MCD::OPC_CheckField, 3, 1, 0, 96, 55, 0, // Skip to: 15268
/* 1092 */    MCD::OPC_Decode, 160, 10, 20, // Opcode: SUB16fi
/* 1096 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1119
/* 1101 */    MCD::OPC_CheckField, 40, 4, 8, 80, 55, 0, // Skip to: 15268
/* 1108 */    MCD::OPC_CheckField, 3, 1, 0, 73, 55, 0, // Skip to: 15268
/* 1115 */    MCD::OPC_Decode, 145, 3, 20, // Opcode: ADD16fi
/* 1119 */    MCD::OPC_FilterValue, 4, 25, 0, 0, // Skip to: 1149
/* 1124 */    MCD::OPC_CheckField, 40, 4, 8, 57, 55, 0, // Skip to: 15268
/* 1131 */    MCD::OPC_CheckField, 24, 8, 0, 50, 55, 0, // Skip to: 15268
/* 1138 */    MCD::OPC_CheckField, 3, 1, 0, 43, 55, 0, // Skip to: 15268
/* 1145 */    MCD::OPC_Decode, 240, 3, 7, // Opcode: BCHG8fi
/* 1149 */    MCD::OPC_FilterValue, 6, 34, 55, 0, // Skip to: 15268
/* 1154 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1157 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1173
/* 1162 */    MCD::OPC_CheckField, 40, 4, 8, 19, 55, 0, // Skip to: 15268
/* 1169 */    MCD::OPC_Decode, 232, 4, 21, // Opcode: CMP16fi
/* 1173 */    MCD::OPC_FilterValue, 1, 10, 55, 0, // Skip to: 15268
/* 1178 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1181 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1190
/* 1186 */    MCD::OPC_Decode, 224, 4, 22, // Opcode: CMP16bi
/* 1190 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1199
/* 1195 */    MCD::OPC_Decode, 236, 4, 23, // Opcode: CMP16qi
/* 1199 */    MCD::OPC_FilterValue, 3, 240, 54, 0, // Skip to: 15268
/* 1204 */    MCD::OPC_CheckField, 40, 4, 8, 233, 54, 0, // Skip to: 15268
/* 1211 */    MCD::OPC_Decode, 234, 4, 24, // Opcode: CMP16ki
/* 1215 */    MCD::OPC_FilterValue, 8, 51, 0, 0, // Skip to: 1271
/* 1220 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1223 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 1239
/* 1228 */    MCD::OPC_CheckField, 24, 8, 0, 209, 54, 0, // Skip to: 15268
/* 1235 */    MCD::OPC_Decode, 248, 3, 0, // Opcode: BCLR32di
/* 1239 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 1255
/* 1244 */    MCD::OPC_CheckField, 3, 1, 0, 193, 54, 0, // Skip to: 15268
/* 1251 */    MCD::OPC_Decode, 215, 10, 25, // Opcode: XOR32di
/* 1255 */    MCD::OPC_FilterValue, 6, 184, 54, 0, // Skip to: 15268
/* 1260 */    MCD::OPC_CheckField, 3, 1, 0, 177, 54, 0, // Skip to: 15268
/* 1267 */    MCD::OPC_Decode, 239, 4, 26, // Opcode: CMP32di
/* 1271 */    MCD::OPC_FilterValue, 9, 123, 0, 0, // Skip to: 1399
/* 1276 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1279 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1295
/* 1284 */    MCD::OPC_CheckField, 3, 1, 0, 153, 54, 0, // Skip to: 15268
/* 1291 */    MCD::OPC_Decode, 189, 9, 27, // Opcode: OR32ji
/* 1295 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1311
/* 1300 */    MCD::OPC_CheckField, 3, 1, 0, 137, 54, 0, // Skip to: 15268
/* 1307 */    MCD::OPC_Decode, 213, 3, 27, // Opcode: AND32ji
/* 1311 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1327
/* 1316 */    MCD::OPC_CheckField, 3, 1, 0, 121, 54, 0, // Skip to: 15268
/* 1323 */    MCD::OPC_Decode, 184, 10, 27, // Opcode: SUB32ji
/* 1327 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1343
/* 1332 */    MCD::OPC_CheckField, 3, 1, 0, 105, 54, 0, // Skip to: 15268
/* 1339 */    MCD::OPC_Decode, 169, 3, 27, // Opcode: ADD32ji
/* 1343 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1383
/* 1348 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1351 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1367
/* 1356 */    MCD::OPC_CheckField, 24, 8, 0, 81, 54, 0, // Skip to: 15268
/* 1363 */    MCD::OPC_Decode, 254, 3, 3, // Opcode: BCLR8ji
/* 1367 */    MCD::OPC_FilterValue, 1, 72, 54, 0, // Skip to: 15268
/* 1372 */    MCD::OPC_CheckField, 24, 8, 0, 65, 54, 0, // Skip to: 15268
/* 1379 */    MCD::OPC_Decode, 128, 4, 3, // Opcode: BCLR8oi
/* 1383 */    MCD::OPC_FilterValue, 6, 56, 54, 0, // Skip to: 15268
/* 1388 */    MCD::OPC_CheckField, 3, 1, 0, 49, 54, 0, // Skip to: 15268
/* 1395 */    MCD::OPC_Decode, 246, 4, 28, // Opcode: CMP32ji
/* 1399 */    MCD::OPC_FilterValue, 10, 123, 0, 0, // Skip to: 1527
/* 1404 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1407 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1423
/* 1412 */    MCD::OPC_CheckField, 3, 1, 1, 25, 54, 0, // Skip to: 15268
/* 1419 */    MCD::OPC_Decode, 191, 9, 29, // Opcode: OR32pi
/* 1423 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1439
/* 1428 */    MCD::OPC_CheckField, 3, 1, 1, 9, 54, 0, // Skip to: 15268
/* 1435 */    MCD::OPC_Decode, 215, 3, 29, // Opcode: AND32pi
/* 1439 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1455
/* 1444 */    MCD::OPC_CheckField, 3, 1, 1, 249, 53, 0, // Skip to: 15268
/* 1451 */    MCD::OPC_Decode, 186, 10, 29, // Opcode: SUB32pi
/* 1455 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1471
/* 1460 */    MCD::OPC_CheckField, 3, 1, 1, 233, 53, 0, // Skip to: 15268
/* 1467 */    MCD::OPC_Decode, 171, 3, 29, // Opcode: ADD32pi
/* 1471 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1511
/* 1476 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1479 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1495
/* 1484 */    MCD::OPC_CheckField, 24, 8, 0, 209, 53, 0, // Skip to: 15268
/* 1491 */    MCD::OPC_Decode, 250, 3, 3, // Opcode: BCLR8ei
/* 1495 */    MCD::OPC_FilterValue, 1, 200, 53, 0, // Skip to: 15268
/* 1500 */    MCD::OPC_CheckField, 24, 8, 0, 193, 53, 0, // Skip to: 15268
/* 1507 */    MCD::OPC_Decode, 130, 4, 5, // Opcode: BCLR8pi
/* 1511 */    MCD::OPC_FilterValue, 6, 184, 53, 0, // Skip to: 15268
/* 1516 */    MCD::OPC_CheckField, 3, 1, 1, 177, 53, 0, // Skip to: 15268
/* 1523 */    MCD::OPC_Decode, 248, 4, 30, // Opcode: CMP32pi
/* 1527 */    MCD::OPC_FilterValue, 11, 191, 0, 0, // Skip to: 1723
/* 1532 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1535 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1558
/* 1540 */    MCD::OPC_CheckField, 56, 4, 8, 153, 53, 0, // Skip to: 15268
/* 1547 */    MCD::OPC_CheckField, 3, 1, 0, 146, 53, 0, // Skip to: 15268
/* 1554 */    MCD::OPC_Decode, 187, 9, 31, // Opcode: OR32fi
/* 1558 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1581
/* 1563 */    MCD::OPC_CheckField, 56, 4, 8, 130, 53, 0, // Skip to: 15268
/* 1570 */    MCD::OPC_CheckField, 3, 1, 0, 123, 53, 0, // Skip to: 15268
/* 1577 */    MCD::OPC_Decode, 211, 3, 31, // Opcode: AND32fi
/* 1581 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1604
/* 1586 */    MCD::OPC_CheckField, 56, 4, 8, 107, 53, 0, // Skip to: 15268
/* 1593 */    MCD::OPC_CheckField, 3, 1, 0, 100, 53, 0, // Skip to: 15268
/* 1600 */    MCD::OPC_Decode, 182, 10, 31, // Opcode: SUB32fi
/* 1604 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1627
/* 1609 */    MCD::OPC_CheckField, 56, 4, 8, 84, 53, 0, // Skip to: 15268
/* 1616 */    MCD::OPC_CheckField, 3, 1, 0, 77, 53, 0, // Skip to: 15268
/* 1623 */    MCD::OPC_Decode, 167, 3, 31, // Opcode: ADD32fi
/* 1627 */    MCD::OPC_FilterValue, 4, 25, 0, 0, // Skip to: 1657
/* 1632 */    MCD::OPC_CheckField, 40, 4, 8, 61, 53, 0, // Skip to: 15268
/* 1639 */    MCD::OPC_CheckField, 24, 8, 0, 54, 53, 0, // Skip to: 15268
/* 1646 */    MCD::OPC_CheckField, 3, 1, 0, 47, 53, 0, // Skip to: 15268
/* 1653 */    MCD::OPC_Decode, 252, 3, 7, // Opcode: BCLR8fi
/* 1657 */    MCD::OPC_FilterValue, 6, 38, 53, 0, // Skip to: 15268
/* 1662 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1665 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1681
/* 1670 */    MCD::OPC_CheckField, 56, 4, 8, 23, 53, 0, // Skip to: 15268
/* 1677 */    MCD::OPC_Decode, 245, 4, 32, // Opcode: CMP32fi
/* 1681 */    MCD::OPC_FilterValue, 1, 14, 53, 0, // Skip to: 15268
/* 1686 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1689 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1698
/* 1694 */    MCD::OPC_Decode, 237, 4, 33, // Opcode: CMP32bi
/* 1698 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1707
/* 1703 */    MCD::OPC_Decode, 249, 4, 34, // Opcode: CMP32qi
/* 1707 */    MCD::OPC_FilterValue, 3, 244, 52, 0, // Skip to: 15268
/* 1712 */    MCD::OPC_CheckField, 56, 4, 8, 237, 52, 0, // Skip to: 15268
/* 1719 */    MCD::OPC_Decode, 247, 4, 35, // Opcode: CMP32ki
/* 1723 */    MCD::OPC_FilterValue, 12, 18, 0, 0, // Skip to: 1746
/* 1728 */    MCD::OPC_CheckField, 24, 8, 0, 221, 52, 0, // Skip to: 15268
/* 1735 */    MCD::OPC_CheckField, 9, 3, 4, 214, 52, 0, // Skip to: 15268
/* 1742 */    MCD::OPC_Decode, 136, 4, 0, // Opcode: BSET32di
/* 1746 */    MCD::OPC_FilterValue, 13, 148, 0, 0, // Skip to: 1899
/* 1751 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1754 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1794
/* 1759 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1762 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1778
/* 1767 */    MCD::OPC_CheckField, 24, 8, 0, 182, 52, 0, // Skip to: 15268
/* 1774 */    MCD::OPC_Decode, 142, 4, 3, // Opcode: BSET8ji
/* 1778 */    MCD::OPC_FilterValue, 1, 173, 52, 0, // Skip to: 15268
/* 1783 */    MCD::OPC_CheckField, 24, 8, 0, 166, 52, 0, // Skip to: 15268
/* 1790 */    MCD::OPC_Decode, 144, 4, 3, // Opcode: BSET8oi
/* 1794 */    MCD::OPC_FilterValue, 5, 30, 0, 0, // Skip to: 1829
/* 1799 */    MCD::OPC_CheckPredicate, 0, 152, 52, 0, // Skip to: 15268
/* 1804 */    MCD::OPC_CheckField, 25, 7, 0, 145, 52, 0, // Skip to: 15268
/* 1811 */    MCD::OPC_CheckField, 19, 3, 0, 138, 52, 0, // Skip to: 15268
/* 1818 */    MCD::OPC_CheckField, 3, 1, 0, 131, 52, 0, // Skip to: 15268
/* 1825 */    MCD::OPC_Decode, 217, 4, 36, // Opcode: CASARI8
/* 1829 */    MCD::OPC_FilterValue, 6, 30, 0, 0, // Skip to: 1864
/* 1834 */    MCD::OPC_CheckPredicate, 0, 117, 52, 0, // Skip to: 15268
/* 1839 */    MCD::OPC_CheckField, 25, 7, 0, 110, 52, 0, // Skip to: 15268
/* 1846 */    MCD::OPC_CheckField, 19, 3, 0, 103, 52, 0, // Skip to: 15268
/* 1853 */    MCD::OPC_CheckField, 3, 1, 0, 96, 52, 0, // Skip to: 15268
/* 1860 */    MCD::OPC_Decode, 215, 4, 37, // Opcode: CASARI16
/* 1864 */    MCD::OPC_FilterValue, 7, 87, 52, 0, // Skip to: 15268
/* 1869 */    MCD::OPC_CheckPredicate, 0, 82, 52, 0, // Skip to: 15268
/* 1874 */    MCD::OPC_CheckField, 25, 7, 0, 75, 52, 0, // Skip to: 15268
/* 1881 */    MCD::OPC_CheckField, 19, 3, 0, 68, 52, 0, // Skip to: 15268
/* 1888 */    MCD::OPC_CheckField, 3, 1, 0, 61, 52, 0, // Skip to: 15268
/* 1895 */    MCD::OPC_Decode, 216, 4, 38, // Opcode: CASARI32
/* 1899 */    MCD::OPC_FilterValue, 14, 148, 0, 0, // Skip to: 2052
/* 1904 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1907 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1947
/* 1912 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1915 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1931
/* 1920 */    MCD::OPC_CheckField, 24, 8, 0, 29, 52, 0, // Skip to: 15268
/* 1927 */    MCD::OPC_Decode, 138, 4, 3, // Opcode: BSET8ei
/* 1931 */    MCD::OPC_FilterValue, 1, 20, 52, 0, // Skip to: 15268
/* 1936 */    MCD::OPC_CheckField, 24, 8, 0, 13, 52, 0, // Skip to: 15268
/* 1943 */    MCD::OPC_Decode, 146, 4, 5, // Opcode: BSET8pi
/* 1947 */    MCD::OPC_FilterValue, 5, 30, 0, 0, // Skip to: 1982
/* 1952 */    MCD::OPC_CheckPredicate, 0, 255, 51, 0, // Skip to: 15268
/* 1957 */    MCD::OPC_CheckField, 25, 7, 0, 248, 51, 0, // Skip to: 15268
/* 1964 */    MCD::OPC_CheckField, 19, 3, 0, 241, 51, 0, // Skip to: 15268
/* 1971 */    MCD::OPC_CheckField, 3, 1, 1, 234, 51, 0, // Skip to: 15268
/* 1978 */    MCD::OPC_Decode, 220, 4, 39, // Opcode: CASARID8
/* 1982 */    MCD::OPC_FilterValue, 6, 30, 0, 0, // Skip to: 2017
/* 1987 */    MCD::OPC_CheckPredicate, 0, 220, 51, 0, // Skip to: 15268
/* 1992 */    MCD::OPC_CheckField, 25, 7, 0, 213, 51, 0, // Skip to: 15268
/* 1999 */    MCD::OPC_CheckField, 19, 3, 0, 206, 51, 0, // Skip to: 15268
/* 2006 */    MCD::OPC_CheckField, 3, 1, 1, 199, 51, 0, // Skip to: 15268
/* 2013 */    MCD::OPC_Decode, 218, 4, 40, // Opcode: CASARID16
/* 2017 */    MCD::OPC_FilterValue, 7, 190, 51, 0, // Skip to: 15268
/* 2022 */    MCD::OPC_CheckPredicate, 0, 185, 51, 0, // Skip to: 15268
/* 2027 */    MCD::OPC_CheckField, 25, 7, 0, 178, 51, 0, // Skip to: 15268
/* 2034 */    MCD::OPC_CheckField, 19, 3, 0, 171, 51, 0, // Skip to: 15268
/* 2041 */    MCD::OPC_CheckField, 3, 1, 1, 164, 51, 0, // Skip to: 15268
/* 2048 */    MCD::OPC_Decode, 219, 4, 41, // Opcode: CASARID32
/* 2052 */    MCD::OPC_FilterValue, 15, 246, 0, 0, // Skip to: 2303
/* 2057 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2060 */    MCD::OPC_FilterValue, 4, 25, 0, 0, // Skip to: 2090
/* 2065 */    MCD::OPC_CheckField, 40, 4, 8, 140, 51, 0, // Skip to: 15268
/* 2072 */    MCD::OPC_CheckField, 24, 8, 0, 133, 51, 0, // Skip to: 15268
/* 2079 */    MCD::OPC_CheckField, 3, 1, 0, 126, 51, 0, // Skip to: 15268
/* 2086 */    MCD::OPC_Decode, 140, 4, 7, // Opcode: BSET8fi
/* 2090 */    MCD::OPC_FilterValue, 5, 66, 0, 0, // Skip to: 2161
/* 2095 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2098 */    MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 2126
/* 2103 */    MCD::OPC_CheckPredicate, 0, 104, 51, 0, // Skip to: 15268
/* 2108 */    MCD::OPC_CheckField, 25, 7, 0, 97, 51, 0, // Skip to: 15268
/* 2115 */    MCD::OPC_CheckField, 19, 3, 0, 90, 51, 0, // Skip to: 15268
/* 2122 */    MCD::OPC_Decode, 223, 4, 42, // Opcode: CASARII8
/* 2126 */    MCD::OPC_FilterValue, 1, 81, 51, 0, // Skip to: 15268
/* 2131 */    MCD::OPC_CheckPredicate, 0, 76, 51, 0, // Skip to: 15268
/* 2136 */    MCD::OPC_CheckField, 25, 7, 0, 69, 51, 0, // Skip to: 15268
/* 2143 */    MCD::OPC_CheckField, 19, 3, 0, 62, 51, 0, // Skip to: 15268
/* 2150 */    MCD::OPC_CheckField, 0, 3, 0, 55, 51, 0, // Skip to: 15268
/* 2157 */    MCD::OPC_Decode, 214, 4, 43, // Opcode: CASAL8
/* 2161 */    MCD::OPC_FilterValue, 6, 66, 0, 0, // Skip to: 2232
/* 2166 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2169 */    MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 2197
/* 2174 */    MCD::OPC_CheckPredicate, 0, 33, 51, 0, // Skip to: 15268
/* 2179 */    MCD::OPC_CheckField, 25, 7, 0, 26, 51, 0, // Skip to: 15268
/* 2186 */    MCD::OPC_CheckField, 19, 3, 0, 19, 51, 0, // Skip to: 15268
/* 2193 */    MCD::OPC_Decode, 221, 4, 44, // Opcode: CASARII16
/* 2197 */    MCD::OPC_FilterValue, 1, 10, 51, 0, // Skip to: 15268
/* 2202 */    MCD::OPC_CheckPredicate, 0, 5, 51, 0, // Skip to: 15268
/* 2207 */    MCD::OPC_CheckField, 25, 7, 0, 254, 50, 0, // Skip to: 15268
/* 2214 */    MCD::OPC_CheckField, 19, 3, 0, 247, 50, 0, // Skip to: 15268
/* 2221 */    MCD::OPC_CheckField, 0, 3, 0, 240, 50, 0, // Skip to: 15268
/* 2228 */    MCD::OPC_Decode, 212, 4, 45, // Opcode: CASAL16
/* 2232 */    MCD::OPC_FilterValue, 7, 231, 50, 0, // Skip to: 15268
/* 2237 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2240 */    MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 2268
/* 2245 */    MCD::OPC_CheckPredicate, 0, 218, 50, 0, // Skip to: 15268
/* 2250 */    MCD::OPC_CheckField, 25, 7, 0, 211, 50, 0, // Skip to: 15268
/* 2257 */    MCD::OPC_CheckField, 19, 3, 0, 204, 50, 0, // Skip to: 15268
/* 2264 */    MCD::OPC_Decode, 222, 4, 46, // Opcode: CASARII32
/* 2268 */    MCD::OPC_FilterValue, 1, 195, 50, 0, // Skip to: 15268
/* 2273 */    MCD::OPC_CheckPredicate, 0, 190, 50, 0, // Skip to: 15268
/* 2278 */    MCD::OPC_CheckField, 25, 7, 0, 183, 50, 0, // Skip to: 15268
/* 2285 */    MCD::OPC_CheckField, 19, 3, 0, 176, 50, 0, // Skip to: 15268
/* 2292 */    MCD::OPC_CheckField, 0, 3, 0, 169, 50, 0, // Skip to: 15268
/* 2299 */    MCD::OPC_Decode, 213, 4, 47, // Opcode: CASAL32
/* 2303 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 2312
/* 2308 */    MCD::OPC_Decode, 150, 4, 48, // Opcode: BTST32dd
/* 2312 */    MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 2338
/* 2317 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2320 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2329
/* 2325 */    MCD::OPC_Decode, 156, 4, 49, // Opcode: BTST8jd
/* 2329 */    MCD::OPC_FilterValue, 1, 134, 50, 0, // Skip to: 15268
/* 2334 */    MCD::OPC_Decode, 160, 4, 49, // Opcode: BTST8od
/* 2338 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 2364
/* 2343 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2346 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2355
/* 2351 */    MCD::OPC_Decode, 152, 4, 49, // Opcode: BTST8ed
/* 2355 */    MCD::OPC_FilterValue, 1, 108, 50, 0, // Skip to: 15268
/* 2360 */    MCD::OPC_Decode, 162, 4, 50, // Opcode: BTST8pd
/* 2364 */    MCD::OPC_FilterValue, 19, 52, 0, 0, // Skip to: 2421
/* 2369 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2372 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2388
/* 2377 */    MCD::OPC_CheckField, 24, 4, 8, 84, 50, 0, // Skip to: 15268
/* 2384 */    MCD::OPC_Decode, 154, 4, 51, // Opcode: BTST8fd
/* 2388 */    MCD::OPC_FilterValue, 1, 75, 50, 0, // Skip to: 15268
/* 2393 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2396 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2405
/* 2401 */    MCD::OPC_Decode, 164, 4, 52, // Opcode: BTST8qd
/* 2405 */    MCD::OPC_FilterValue, 3, 58, 50, 0, // Skip to: 15268
/* 2410 */    MCD::OPC_CheckField, 24, 4, 8, 51, 50, 0, // Skip to: 15268
/* 2417 */    MCD::OPC_Decode, 158, 4, 53, // Opcode: BTST8kd
/* 2421 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 2430
/* 2426 */    MCD::OPC_Decode, 235, 3, 48, // Opcode: BCHG32dd
/* 2430 */    MCD::OPC_FilterValue, 21, 21, 0, 0, // Skip to: 2456
/* 2435 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2438 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2447
/* 2443 */    MCD::OPC_Decode, 241, 3, 49, // Opcode: BCHG8jd
/* 2447 */    MCD::OPC_FilterValue, 1, 16, 50, 0, // Skip to: 15268
/* 2452 */    MCD::OPC_Decode, 243, 3, 49, // Opcode: BCHG8od
/* 2456 */    MCD::OPC_FilterValue, 22, 21, 0, 0, // Skip to: 2482
/* 2461 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2464 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2473
/* 2469 */    MCD::OPC_Decode, 237, 3, 49, // Opcode: BCHG8ed
/* 2473 */    MCD::OPC_FilterValue, 1, 246, 49, 0, // Skip to: 15268
/* 2478 */    MCD::OPC_Decode, 245, 3, 50, // Opcode: BCHG8pd
/* 2482 */    MCD::OPC_FilterValue, 23, 18, 0, 0, // Skip to: 2505
/* 2487 */    MCD::OPC_CheckField, 24, 4, 8, 230, 49, 0, // Skip to: 15268
/* 2494 */    MCD::OPC_CheckField, 3, 1, 0, 223, 49, 0, // Skip to: 15268
/* 2501 */    MCD::OPC_Decode, 239, 3, 51, // Opcode: BCHG8fd
/* 2505 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 2514
/* 2510 */    MCD::OPC_Decode, 247, 3, 48, // Opcode: BCLR32dd
/* 2514 */    MCD::OPC_FilterValue, 25, 21, 0, 0, // Skip to: 2540
/* 2519 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2522 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2531
/* 2527 */    MCD::OPC_Decode, 253, 3, 49, // Opcode: BCLR8jd
/* 2531 */    MCD::OPC_FilterValue, 1, 188, 49, 0, // Skip to: 15268
/* 2536 */    MCD::OPC_Decode, 255, 3, 49, // Opcode: BCLR8od
/* 2540 */    MCD::OPC_FilterValue, 26, 21, 0, 0, // Skip to: 2566
/* 2545 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2548 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2557
/* 2553 */    MCD::OPC_Decode, 249, 3, 49, // Opcode: BCLR8ed
/* 2557 */    MCD::OPC_FilterValue, 1, 162, 49, 0, // Skip to: 15268
/* 2562 */    MCD::OPC_Decode, 129, 4, 50, // Opcode: BCLR8pd
/* 2566 */    MCD::OPC_FilterValue, 27, 18, 0, 0, // Skip to: 2589
/* 2571 */    MCD::OPC_CheckField, 24, 4, 8, 146, 49, 0, // Skip to: 15268
/* 2578 */    MCD::OPC_CheckField, 3, 1, 0, 139, 49, 0, // Skip to: 15268
/* 2585 */    MCD::OPC_Decode, 251, 3, 51, // Opcode: BCLR8fd
/* 2589 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 2598
/* 2594 */    MCD::OPC_Decode, 135, 4, 48, // Opcode: BSET32dd
/* 2598 */    MCD::OPC_FilterValue, 29, 21, 0, 0, // Skip to: 2624
/* 2603 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2606 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2615
/* 2611 */    MCD::OPC_Decode, 141, 4, 49, // Opcode: BSET8jd
/* 2615 */    MCD::OPC_FilterValue, 1, 104, 49, 0, // Skip to: 15268
/* 2620 */    MCD::OPC_Decode, 143, 4, 49, // Opcode: BSET8od
/* 2624 */    MCD::OPC_FilterValue, 30, 21, 0, 0, // Skip to: 2650
/* 2629 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2632 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2641
/* 2637 */    MCD::OPC_Decode, 137, 4, 49, // Opcode: BSET8ed
/* 2641 */    MCD::OPC_FilterValue, 1, 78, 49, 0, // Skip to: 15268
/* 2646 */    MCD::OPC_Decode, 145, 4, 50, // Opcode: BSET8pd
/* 2650 */    MCD::OPC_FilterValue, 31, 69, 49, 0, // Skip to: 15268
/* 2655 */    MCD::OPC_CheckField, 24, 4, 8, 62, 49, 0, // Skip to: 15268
/* 2662 */    MCD::OPC_CheckField, 3, 1, 0, 55, 49, 0, // Skip to: 15268
/* 2669 */    MCD::OPC_Decode, 139, 4, 51, // Opcode: BSET8fd
/* 2673 */    MCD::OPC_FilterValue, 1, 254, 4, 0, // Skip to: 3956
/* 2678 */    MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 2681 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2690
/* 2686 */    MCD::OPC_Decode, 170, 8, 54, // Opcode: MOV8dd
/* 2690 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2699
/* 2695 */    MCD::OPC_Decode, 174, 8, 55, // Opcode: MOV8dj
/* 2699 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 2708
/* 2704 */    MCD::OPC_Decode, 176, 8, 55, // Opcode: MOV8do
/* 2708 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 2717
/* 2713 */    MCD::OPC_Decode, 171, 8, 55, // Opcode: MOV8de
/* 2717 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 2726
/* 2722 */    MCD::OPC_Decode, 177, 8, 56, // Opcode: MOV8dp
/* 2726 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2742
/* 2731 */    MCD::OPC_CheckField, 24, 4, 8, 242, 48, 0, // Skip to: 15268
/* 2738 */    MCD::OPC_Decode, 172, 8, 57, // Opcode: MOV8df
/* 2742 */    MCD::OPC_FilterValue, 7, 53, 0, 0, // Skip to: 2800
/* 2747 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2750 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2759
/* 2755 */    MCD::OPC_Decode, 169, 8, 58, // Opcode: MOV8db
/* 2759 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2768
/* 2764 */    MCD::OPC_Decode, 178, 8, 59, // Opcode: MOV8dq
/* 2768 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2784
/* 2773 */    MCD::OPC_CheckField, 24, 4, 8, 200, 48, 0, // Skip to: 15268
/* 2780 */    MCD::OPC_Decode, 175, 8, 60, // Opcode: MOV8dk
/* 2784 */    MCD::OPC_FilterValue, 4, 191, 48, 0, // Skip to: 15268
/* 2789 */    MCD::OPC_CheckField, 24, 8, 0, 184, 48, 0, // Skip to: 15268
/* 2796 */    MCD::OPC_Decode, 173, 8, 61, // Opcode: MOV8di
/* 2800 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 2809
/* 2805 */    MCD::OPC_Decode, 200, 8, 62, // Opcode: MOV8jd
/* 2809 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 2818
/* 2814 */    MCD::OPC_Decode, 204, 8, 63, // Opcode: MOV8jj
/* 2818 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 2827
/* 2823 */    MCD::OPC_Decode, 206, 8, 63, // Opcode: MOV8jo
/* 2827 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 2836
/* 2832 */    MCD::OPC_Decode, 201, 8, 63, // Opcode: MOV8je
/* 2836 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 2845
/* 2841 */    MCD::OPC_Decode, 207, 8, 64, // Opcode: MOV8jp
/* 2845 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 2861
/* 2850 */    MCD::OPC_CheckField, 24, 4, 8, 123, 48, 0, // Skip to: 15268
/* 2857 */    MCD::OPC_Decode, 202, 8, 65, // Opcode: MOV8jf
/* 2861 */    MCD::OPC_FilterValue, 23, 53, 0, 0, // Skip to: 2919
/* 2866 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2869 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2878
/* 2874 */    MCD::OPC_Decode, 199, 8, 66, // Opcode: MOV8jb
/* 2878 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2887
/* 2883 */    MCD::OPC_Decode, 208, 8, 67, // Opcode: MOV8jq
/* 2887 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2903
/* 2892 */    MCD::OPC_CheckField, 24, 4, 8, 81, 48, 0, // Skip to: 15268
/* 2899 */    MCD::OPC_Decode, 205, 8, 68, // Opcode: MOV8jk
/* 2903 */    MCD::OPC_FilterValue, 4, 72, 48, 0, // Skip to: 15268
/* 2908 */    MCD::OPC_CheckField, 24, 8, 0, 65, 48, 0, // Skip to: 15268
/* 2915 */    MCD::OPC_Decode, 203, 8, 69, // Opcode: MOV8ji
/* 2919 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 2928
/* 2924 */    MCD::OPC_Decode, 220, 8, 62, // Opcode: MOV8od
/* 2928 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 2937
/* 2933 */    MCD::OPC_Decode, 224, 8, 63, // Opcode: MOV8oj
/* 2937 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 2946
/* 2942 */    MCD::OPC_Decode, 226, 8, 63, // Opcode: MOV8oo
/* 2946 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 2955
/* 2951 */    MCD::OPC_Decode, 221, 8, 63, // Opcode: MOV8oe
/* 2955 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 2964
/* 2960 */    MCD::OPC_Decode, 227, 8, 64, // Opcode: MOV8op
/* 2964 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 2980
/* 2969 */    MCD::OPC_CheckField, 24, 4, 8, 4, 48, 0, // Skip to: 15268
/* 2976 */    MCD::OPC_Decode, 222, 8, 65, // Opcode: MOV8of
/* 2980 */    MCD::OPC_FilterValue, 31, 53, 0, 0, // Skip to: 3038
/* 2985 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2988 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2997
/* 2993 */    MCD::OPC_Decode, 219, 8, 66, // Opcode: MOV8ob
/* 2997 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3006
/* 3002 */    MCD::OPC_Decode, 228, 8, 67, // Opcode: MOV8oq
/* 3006 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 3022
/* 3011 */    MCD::OPC_CheckField, 24, 4, 8, 218, 47, 0, // Skip to: 15268
/* 3018 */    MCD::OPC_Decode, 225, 8, 68, // Opcode: MOV8ok
/* 3022 */    MCD::OPC_FilterValue, 4, 209, 47, 0, // Skip to: 15268
/* 3027 */    MCD::OPC_CheckField, 24, 8, 0, 202, 47, 0, // Skip to: 15268
/* 3034 */    MCD::OPC_Decode, 223, 8, 69, // Opcode: MOV8oi
/* 3038 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 3047
/* 3043 */    MCD::OPC_Decode, 180, 8, 62, // Opcode: MOV8ed
/* 3047 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 3056
/* 3052 */    MCD::OPC_Decode, 184, 8, 63, // Opcode: MOV8ej
/* 3056 */    MCD::OPC_FilterValue, 35, 4, 0, 0, // Skip to: 3065
/* 3061 */    MCD::OPC_Decode, 186, 8, 63, // Opcode: MOV8eo
/* 3065 */    MCD::OPC_FilterValue, 36, 4, 0, 0, // Skip to: 3074
/* 3070 */    MCD::OPC_Decode, 181, 8, 63, // Opcode: MOV8ee
/* 3074 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 3083
/* 3079 */    MCD::OPC_Decode, 187, 8, 64, // Opcode: MOV8ep
/* 3083 */    MCD::OPC_FilterValue, 38, 11, 0, 0, // Skip to: 3099
/* 3088 */    MCD::OPC_CheckField, 24, 4, 8, 141, 47, 0, // Skip to: 15268
/* 3095 */    MCD::OPC_Decode, 182, 8, 65, // Opcode: MOV8ef
/* 3099 */    MCD::OPC_FilterValue, 39, 53, 0, 0, // Skip to: 3157
/* 3104 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3107 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3116
/* 3112 */    MCD::OPC_Decode, 179, 8, 66, // Opcode: MOV8eb
/* 3116 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3125
/* 3121 */    MCD::OPC_Decode, 188, 8, 67, // Opcode: MOV8eq
/* 3125 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 3141
/* 3130 */    MCD::OPC_CheckField, 24, 4, 8, 99, 47, 0, // Skip to: 15268
/* 3137 */    MCD::OPC_Decode, 185, 8, 68, // Opcode: MOV8ek
/* 3141 */    MCD::OPC_FilterValue, 4, 90, 47, 0, // Skip to: 15268
/* 3146 */    MCD::OPC_CheckField, 24, 8, 0, 83, 47, 0, // Skip to: 15268
/* 3153 */    MCD::OPC_Decode, 183, 8, 69, // Opcode: MOV8ei
/* 3157 */    MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 3166
/* 3162 */    MCD::OPC_Decode, 230, 8, 70, // Opcode: MOV8pd
/* 3166 */    MCD::OPC_FilterValue, 42, 4, 0, 0, // Skip to: 3175
/* 3171 */    MCD::OPC_Decode, 234, 8, 71, // Opcode: MOV8pj
/* 3175 */    MCD::OPC_FilterValue, 43, 4, 0, 0, // Skip to: 3184
/* 3180 */    MCD::OPC_Decode, 236, 8, 71, // Opcode: MOV8po
/* 3184 */    MCD::OPC_FilterValue, 44, 4, 0, 0, // Skip to: 3193
/* 3189 */    MCD::OPC_Decode, 231, 8, 71, // Opcode: MOV8pe
/* 3193 */    MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 3202
/* 3198 */    MCD::OPC_Decode, 237, 8, 72, // Opcode: MOV8pp
/* 3202 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 3218
/* 3207 */    MCD::OPC_CheckField, 24, 4, 8, 22, 47, 0, // Skip to: 15268
/* 3214 */    MCD::OPC_Decode, 232, 8, 73, // Opcode: MOV8pf
/* 3218 */    MCD::OPC_FilterValue, 47, 53, 0, 0, // Skip to: 3276
/* 3223 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3226 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3235
/* 3231 */    MCD::OPC_Decode, 229, 8, 74, // Opcode: MOV8pb
/* 3235 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3244
/* 3240 */    MCD::OPC_Decode, 238, 8, 75, // Opcode: MOV8pq
/* 3244 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 3260
/* 3249 */    MCD::OPC_CheckField, 24, 4, 8, 236, 46, 0, // Skip to: 15268
/* 3256 */    MCD::OPC_Decode, 235, 8, 76, // Opcode: MOV8pk
/* 3260 */    MCD::OPC_FilterValue, 4, 227, 46, 0, // Skip to: 15268
/* 3265 */    MCD::OPC_CheckField, 24, 8, 0, 220, 46, 0, // Skip to: 15268
/* 3272 */    MCD::OPC_Decode, 233, 8, 77, // Opcode: MOV8pi
/* 3276 */    MCD::OPC_FilterValue, 48, 11, 0, 0, // Skip to: 3292
/* 3281 */    MCD::OPC_CheckField, 24, 4, 8, 204, 46, 0, // Skip to: 15268
/* 3288 */    MCD::OPC_Decode, 190, 8, 78, // Opcode: MOV8fd
/* 3292 */    MCD::OPC_FilterValue, 50, 11, 0, 0, // Skip to: 3308
/* 3297 */    MCD::OPC_CheckField, 24, 4, 8, 188, 46, 0, // Skip to: 15268
/* 3304 */    MCD::OPC_Decode, 194, 8, 79, // Opcode: MOV8fj
/* 3308 */    MCD::OPC_FilterValue, 51, 11, 0, 0, // Skip to: 3324
/* 3313 */    MCD::OPC_CheckField, 24, 4, 8, 172, 46, 0, // Skip to: 15268
/* 3320 */    MCD::OPC_Decode, 196, 8, 79, // Opcode: MOV8fo
/* 3324 */    MCD::OPC_FilterValue, 52, 11, 0, 0, // Skip to: 3340
/* 3329 */    MCD::OPC_CheckField, 24, 4, 8, 156, 46, 0, // Skip to: 15268
/* 3336 */    MCD::OPC_Decode, 191, 8, 79, // Opcode: MOV8fe
/* 3340 */    MCD::OPC_FilterValue, 53, 11, 0, 0, // Skip to: 3356
/* 3345 */    MCD::OPC_CheckField, 40, 4, 8, 140, 46, 0, // Skip to: 15268
/* 3352 */    MCD::OPC_Decode, 197, 8, 80, // Opcode: MOV8fp
/* 3356 */    MCD::OPC_FilterValue, 54, 18, 0, 0, // Skip to: 3379
/* 3361 */    MCD::OPC_CheckField, 40, 4, 8, 124, 46, 0, // Skip to: 15268
/* 3368 */    MCD::OPC_CheckField, 24, 4, 8, 117, 46, 0, // Skip to: 15268
/* 3375 */    MCD::OPC_Decode, 192, 8, 81, // Opcode: MOV8ff
/* 3379 */    MCD::OPC_FilterValue, 55, 81, 0, 0, // Skip to: 3465
/* 3384 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3387 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3403
/* 3392 */    MCD::OPC_CheckField, 56, 4, 8, 93, 46, 0, // Skip to: 15268
/* 3399 */    MCD::OPC_Decode, 189, 8, 82, // Opcode: MOV8fb
/* 3403 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3419
/* 3408 */    MCD::OPC_CheckField, 40, 4, 8, 77, 46, 0, // Skip to: 15268
/* 3415 */    MCD::OPC_Decode, 198, 8, 83, // Opcode: MOV8fq
/* 3419 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 3442
/* 3424 */    MCD::OPC_CheckField, 40, 4, 8, 61, 46, 0, // Skip to: 15268
/* 3431 */    MCD::OPC_CheckField, 24, 4, 8, 54, 46, 0, // Skip to: 15268
/* 3438 */    MCD::OPC_Decode, 195, 8, 84, // Opcode: MOV8fk
/* 3442 */    MCD::OPC_FilterValue, 4, 45, 46, 0, // Skip to: 15268
/* 3447 */    MCD::OPC_CheckField, 40, 4, 8, 38, 46, 0, // Skip to: 15268
/* 3454 */    MCD::OPC_CheckField, 24, 8, 0, 31, 46, 0, // Skip to: 15268
/* 3461 */    MCD::OPC_Decode, 193, 8, 85, // Opcode: MOV8fi
/* 3465 */    MCD::OPC_FilterValue, 56, 37, 0, 0, // Skip to: 3507
/* 3470 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3473 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3482
/* 3478 */    MCD::OPC_Decode, 160, 8, 86, // Opcode: MOV8bd
/* 3482 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3491
/* 3487 */    MCD::OPC_Decode, 240, 8, 87, // Opcode: MOV8qd
/* 3491 */    MCD::OPC_FilterValue, 3, 252, 45, 0, // Skip to: 15268
/* 3496 */    MCD::OPC_CheckField, 24, 4, 8, 245, 45, 0, // Skip to: 15268
/* 3503 */    MCD::OPC_Decode, 210, 8, 88, // Opcode: MOV8kd
/* 3507 */    MCD::OPC_FilterValue, 58, 37, 0, 0, // Skip to: 3549
/* 3512 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3515 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3524
/* 3520 */    MCD::OPC_Decode, 164, 8, 28, // Opcode: MOV8bj
/* 3524 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3533
/* 3529 */    MCD::OPC_Decode, 244, 8, 17, // Opcode: MOV8qj
/* 3533 */    MCD::OPC_FilterValue, 3, 210, 45, 0, // Skip to: 15268
/* 3538 */    MCD::OPC_CheckField, 24, 4, 8, 203, 45, 0, // Skip to: 15268
/* 3545 */    MCD::OPC_Decode, 214, 8, 89, // Opcode: MOV8kj
/* 3549 */    MCD::OPC_FilterValue, 59, 37, 0, 0, // Skip to: 3591
/* 3554 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3557 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3566
/* 3562 */    MCD::OPC_Decode, 166, 8, 28, // Opcode: MOV8bo
/* 3566 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3575
/* 3571 */    MCD::OPC_Decode, 246, 8, 17, // Opcode: MOV8qo
/* 3575 */    MCD::OPC_FilterValue, 3, 168, 45, 0, // Skip to: 15268
/* 3580 */    MCD::OPC_CheckField, 24, 4, 8, 161, 45, 0, // Skip to: 15268
/* 3587 */    MCD::OPC_Decode, 216, 8, 89, // Opcode: MOV8ko
/* 3591 */    MCD::OPC_FilterValue, 60, 37, 0, 0, // Skip to: 3633
/* 3596 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3599 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3608
/* 3604 */    MCD::OPC_Decode, 161, 8, 28, // Opcode: MOV8be
/* 3608 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3617
/* 3613 */    MCD::OPC_Decode, 241, 8, 17, // Opcode: MOV8qe
/* 3617 */    MCD::OPC_FilterValue, 3, 126, 45, 0, // Skip to: 15268
/* 3622 */    MCD::OPC_CheckField, 24, 4, 8, 119, 45, 0, // Skip to: 15268
/* 3629 */    MCD::OPC_Decode, 211, 8, 89, // Opcode: MOV8ke
/* 3633 */    MCD::OPC_FilterValue, 61, 37, 0, 0, // Skip to: 3675
/* 3638 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3641 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3650
/* 3646 */    MCD::OPC_Decode, 167, 8, 90, // Opcode: MOV8bp
/* 3650 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3659
/* 3655 */    MCD::OPC_Decode, 247, 8, 91, // Opcode: MOV8qp
/* 3659 */    MCD::OPC_FilterValue, 3, 84, 45, 0, // Skip to: 15268
/* 3664 */    MCD::OPC_CheckField, 40, 4, 8, 77, 45, 0, // Skip to: 15268
/* 3671 */    MCD::OPC_Decode, 217, 8, 92, // Opcode: MOV8kp
/* 3675 */    MCD::OPC_FilterValue, 62, 58, 0, 0, // Skip to: 3738
/* 3680 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3683 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3699
/* 3688 */    MCD::OPC_CheckField, 24, 4, 8, 53, 45, 0, // Skip to: 15268
/* 3695 */    MCD::OPC_Decode, 162, 8, 93, // Opcode: MOV8bf
/* 3699 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3715
/* 3704 */    MCD::OPC_CheckField, 24, 4, 8, 37, 45, 0, // Skip to: 15268
/* 3711 */    MCD::OPC_Decode, 242, 8, 94, // Opcode: MOV8qf
/* 3715 */    MCD::OPC_FilterValue, 3, 28, 45, 0, // Skip to: 15268
/* 3720 */    MCD::OPC_CheckField, 40, 4, 8, 21, 45, 0, // Skip to: 15268
/* 3727 */    MCD::OPC_CheckField, 24, 4, 8, 14, 45, 0, // Skip to: 15268
/* 3734 */    MCD::OPC_Decode, 212, 8, 95, // Opcode: MOV8kf
/* 3738 */    MCD::OPC_FilterValue, 63, 5, 45, 0, // Skip to: 15268
/* 3743 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3746 */    MCD::OPC_FilterValue, 1, 37, 0, 0, // Skip to: 3788
/* 3751 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3754 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3763
/* 3759 */    MCD::OPC_Decode, 159, 8, 96, // Opcode: MOV8bb
/* 3763 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3772
/* 3768 */    MCD::OPC_Decode, 239, 8, 97, // Opcode: MOV8qb
/* 3772 */    MCD::OPC_FilterValue, 3, 227, 44, 0, // Skip to: 15268
/* 3777 */    MCD::OPC_CheckField, 56, 4, 8, 220, 44, 0, // Skip to: 15268
/* 3784 */    MCD::OPC_Decode, 209, 8, 98, // Opcode: MOV8kb
/* 3788 */    MCD::OPC_FilterValue, 2, 37, 0, 0, // Skip to: 3830
/* 3793 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3796 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3805
/* 3801 */    MCD::OPC_Decode, 168, 8, 99, // Opcode: MOV8bq
/* 3805 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3814
/* 3810 */    MCD::OPC_Decode, 248, 8, 100, // Opcode: MOV8qq
/* 3814 */    MCD::OPC_FilterValue, 3, 185, 44, 0, // Skip to: 15268
/* 3819 */    MCD::OPC_CheckField, 40, 4, 8, 178, 44, 0, // Skip to: 15268
/* 3826 */    MCD::OPC_Decode, 218, 8, 101, // Opcode: MOV8kq
/* 3830 */    MCD::OPC_FilterValue, 3, 58, 0, 0, // Skip to: 3893
/* 3835 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3838 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3854
/* 3843 */    MCD::OPC_CheckField, 24, 4, 8, 154, 44, 0, // Skip to: 15268
/* 3850 */    MCD::OPC_Decode, 165, 8, 102, // Opcode: MOV8bk
/* 3854 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3870
/* 3859 */    MCD::OPC_CheckField, 24, 4, 8, 138, 44, 0, // Skip to: 15268
/* 3866 */    MCD::OPC_Decode, 245, 8, 103, // Opcode: MOV8qk
/* 3870 */    MCD::OPC_FilterValue, 3, 129, 44, 0, // Skip to: 15268
/* 3875 */    MCD::OPC_CheckField, 40, 4, 8, 122, 44, 0, // Skip to: 15268
/* 3882 */    MCD::OPC_CheckField, 24, 4, 8, 115, 44, 0, // Skip to: 15268
/* 3889 */    MCD::OPC_Decode, 215, 8, 104, // Opcode: MOV8kk
/* 3893 */    MCD::OPC_FilterValue, 4, 106, 44, 0, // Skip to: 15268
/* 3898 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3901 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3917
/* 3906 */    MCD::OPC_CheckField, 24, 8, 0, 91, 44, 0, // Skip to: 15268
/* 3913 */    MCD::OPC_Decode, 163, 8, 105, // Opcode: MOV8bi
/* 3917 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3933
/* 3922 */    MCD::OPC_CheckField, 24, 8, 0, 75, 44, 0, // Skip to: 15268
/* 3929 */    MCD::OPC_Decode, 243, 8, 8, // Opcode: MOV8qi
/* 3933 */    MCD::OPC_FilterValue, 3, 66, 44, 0, // Skip to: 15268
/* 3938 */    MCD::OPC_CheckField, 40, 4, 8, 59, 44, 0, // Skip to: 15268
/* 3945 */    MCD::OPC_CheckField, 24, 8, 0, 52, 44, 0, // Skip to: 15268
/* 3952 */    MCD::OPC_Decode, 213, 8, 9, // Opcode: MOV8ki
/* 3956 */    MCD::OPC_FilterValue, 2, 181, 7, 0, // Skip to: 5934
/* 3961 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 3964 */    MCD::OPC_FilterValue, 0, 94, 1, 0, // Skip to: 4319
/* 3969 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3972 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 4031
/* 3977 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3980 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3996
/* 3985 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 4016
/* 3992 */    MCD::OPC_Decode, 175, 7, 106, // Opcode: MOV32dd
/* 3996 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 4016
/* 4001 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 4012
/* 4008 */    MCD::OPC_Decode, 143, 7, 63, // Opcode: MOV32aa
/* 4012 */    MCD::OPC_Decode, 140, 8, 107, // Opcode: MOV32ra
/* 4016 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 4027
/* 4023 */    MCD::OPC_Decode, 161, 7, 108, // Opcode: MOV32ar
/* 4027 */    MCD::OPC_Decode, 158, 8, 109, // Opcode: MOV32rr
/* 4031 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 4099
/* 4036 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4039 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4069
/* 4044 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4047 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4056
/* 4052 */    MCD::OPC_Decode, 210, 7, 110, // Opcode: MOV32jd
/* 4056 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4065
/* 4061 */    MCD::OPC_Decode, 208, 7, 63, // Opcode: MOV32ja
/* 4065 */    MCD::OPC_Decode, 219, 7, 108, // Opcode: MOV32jr
/* 4069 */    MCD::OPC_FilterValue, 1, 186, 43, 0, // Skip to: 15268
/* 4074 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4077 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4086
/* 4082 */    MCD::OPC_Decode, 234, 7, 110, // Opcode: MOV32od
/* 4086 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4095
/* 4091 */    MCD::OPC_Decode, 232, 7, 63, // Opcode: MOV32oa
/* 4095 */    MCD::OPC_Decode, 243, 7, 108, // Opcode: MOV32or
/* 4099 */    MCD::OPC_FilterValue, 2, 63, 0, 0, // Skip to: 4167
/* 4104 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4107 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4137
/* 4112 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4115 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4124
/* 4120 */    MCD::OPC_Decode, 186, 7, 110, // Opcode: MOV32ed
/* 4124 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4133
/* 4129 */    MCD::OPC_Decode, 184, 7, 63, // Opcode: MOV32ea
/* 4133 */    MCD::OPC_Decode, 195, 7, 108, // Opcode: MOV32er
/* 4137 */    MCD::OPC_FilterValue, 1, 118, 43, 0, // Skip to: 15268
/* 4142 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4145 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4154
/* 4150 */    MCD::OPC_Decode, 246, 7, 111, // Opcode: MOV32pd
/* 4154 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4163
/* 4159 */    MCD::OPC_Decode, 244, 7, 71, // Opcode: MOV32pa
/* 4163 */    MCD::OPC_Decode, 255, 7, 112, // Opcode: MOV32pr
/* 4167 */    MCD::OPC_FilterValue, 3, 88, 43, 0, // Skip to: 15268
/* 4172 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4175 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 4213
/* 4180 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4183 */    MCD::OPC_FilterValue, 8, 72, 43, 0, // Skip to: 15268
/* 4188 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4191 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4200
/* 4196 */    MCD::OPC_Decode, 198, 7, 113, // Opcode: MOV32fd
/* 4200 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4209
/* 4205 */    MCD::OPC_Decode, 196, 7, 79, // Opcode: MOV32fa
/* 4209 */    MCD::OPC_Decode, 207, 7, 114, // Opcode: MOV32fr
/* 4213 */    MCD::OPC_FilterValue, 1, 42, 43, 0, // Skip to: 15268
/* 4218 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4221 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 4251
/* 4226 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4229 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4238
/* 4234 */    MCD::OPC_Decode, 164, 7, 26, // Opcode: MOV32bd
/* 4238 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4247
/* 4243 */    MCD::OPC_Decode, 162, 7, 28, // Opcode: MOV32ba
/* 4247 */    MCD::OPC_Decode, 173, 7, 115, // Opcode: MOV32br
/* 4251 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 4281
/* 4256 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4259 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4268
/* 4264 */    MCD::OPC_Decode, 130, 8, 116, // Opcode: MOV32qd
/* 4268 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4277
/* 4273 */    MCD::OPC_Decode, 128, 8, 17, // Opcode: MOV32qa
/* 4277 */    MCD::OPC_Decode, 139, 8, 117, // Opcode: MOV32qr
/* 4281 */    MCD::OPC_FilterValue, 3, 230, 42, 0, // Skip to: 15268
/* 4286 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4289 */    MCD::OPC_FilterValue, 8, 222, 42, 0, // Skip to: 15268
/* 4294 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4297 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4306
/* 4302 */    MCD::OPC_Decode, 222, 7, 118, // Opcode: MOV32kd
/* 4306 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4315
/* 4311 */    MCD::OPC_Decode, 220, 7, 89, // Opcode: MOV32ka
/* 4315 */    MCD::OPC_Decode, 231, 7, 119, // Opcode: MOV32kr
/* 4319 */    MCD::OPC_FilterValue, 1, 75, 1, 0, // Skip to: 4655
/* 4324 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4327 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 4395
/* 4332 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4335 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4365
/* 4340 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4343 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4352
/* 4348 */    MCD::OPC_Decode, 179, 7, 120, // Opcode: MOV32dj
/* 4352 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4361
/* 4357 */    MCD::OPC_Decode, 151, 7, 63, // Opcode: MOV32aj
/* 4361 */    MCD::OPC_Decode, 148, 8, 107, // Opcode: MOV32rj
/* 4365 */    MCD::OPC_FilterValue, 1, 146, 42, 0, // Skip to: 15268
/* 4370 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4373 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4382
/* 4378 */    MCD::OPC_Decode, 181, 7, 120, // Opcode: MOV32do
/* 4382 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4391
/* 4387 */    MCD::OPC_Decode, 155, 7, 63, // Opcode: MOV32ao
/* 4391 */    MCD::OPC_Decode, 152, 8, 107, // Opcode: MOV32ro
/* 4395 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 4455
/* 4400 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4403 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4429
/* 4408 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4411 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4420
/* 4416 */    MCD::OPC_Decode, 214, 7, 63, // Opcode: MOV32jj
/* 4420 */    MCD::OPC_FilterValue, 1, 91, 42, 0, // Skip to: 15268
/* 4425 */    MCD::OPC_Decode, 238, 7, 63, // Opcode: MOV32oj
/* 4429 */    MCD::OPC_FilterValue, 1, 82, 42, 0, // Skip to: 15268
/* 4434 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4437 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4446
/* 4442 */    MCD::OPC_Decode, 216, 7, 63, // Opcode: MOV32jo
/* 4446 */    MCD::OPC_FilterValue, 1, 65, 42, 0, // Skip to: 15268
/* 4451 */    MCD::OPC_Decode, 240, 7, 63, // Opcode: MOV32oo
/* 4455 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 4515
/* 4460 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4463 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4489
/* 4468 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4471 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4480
/* 4476 */    MCD::OPC_Decode, 190, 7, 63, // Opcode: MOV32ej
/* 4480 */    MCD::OPC_FilterValue, 1, 31, 42, 0, // Skip to: 15268
/* 4485 */    MCD::OPC_Decode, 250, 7, 71, // Opcode: MOV32pj
/* 4489 */    MCD::OPC_FilterValue, 1, 22, 42, 0, // Skip to: 15268
/* 4494 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4497 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4506
/* 4502 */    MCD::OPC_Decode, 192, 7, 63, // Opcode: MOV32eo
/* 4506 */    MCD::OPC_FilterValue, 1, 5, 42, 0, // Skip to: 15268
/* 4511 */    MCD::OPC_Decode, 252, 7, 71, // Opcode: MOV32po
/* 4515 */    MCD::OPC_FilterValue, 3, 252, 41, 0, // Skip to: 15268
/* 4520 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4523 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 4589
/* 4528 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4531 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4547
/* 4536 */    MCD::OPC_CheckField, 24, 4, 8, 229, 41, 0, // Skip to: 15268
/* 4543 */    MCD::OPC_Decode, 202, 7, 79, // Opcode: MOV32fj
/* 4547 */    MCD::OPC_FilterValue, 1, 220, 41, 0, // Skip to: 15268
/* 4552 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4555 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4564
/* 4560 */    MCD::OPC_Decode, 168, 7, 28, // Opcode: MOV32bj
/* 4564 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4573
/* 4569 */    MCD::OPC_Decode, 134, 8, 17, // Opcode: MOV32qj
/* 4573 */    MCD::OPC_FilterValue, 3, 194, 41, 0, // Skip to: 15268
/* 4578 */    MCD::OPC_CheckField, 24, 4, 8, 187, 41, 0, // Skip to: 15268
/* 4585 */    MCD::OPC_Decode, 226, 7, 89, // Opcode: MOV32kj
/* 4589 */    MCD::OPC_FilterValue, 1, 178, 41, 0, // Skip to: 15268
/* 4594 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4597 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4613
/* 4602 */    MCD::OPC_CheckField, 24, 4, 8, 163, 41, 0, // Skip to: 15268
/* 4609 */    MCD::OPC_Decode, 204, 7, 79, // Opcode: MOV32fo
/* 4613 */    MCD::OPC_FilterValue, 1, 154, 41, 0, // Skip to: 15268
/* 4618 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4621 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4630
/* 4626 */    MCD::OPC_Decode, 170, 7, 28, // Opcode: MOV32bo
/* 4630 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4639
/* 4635 */    MCD::OPC_Decode, 136, 8, 17, // Opcode: MOV32qo
/* 4639 */    MCD::OPC_FilterValue, 3, 128, 41, 0, // Skip to: 15268
/* 4644 */    MCD::OPC_CheckField, 24, 4, 8, 121, 41, 0, // Skip to: 15268
/* 4651 */    MCD::OPC_Decode, 228, 7, 89, // Opcode: MOV32ko
/* 4655 */    MCD::OPC_FilterValue, 2, 75, 1, 0, // Skip to: 4991
/* 4660 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4663 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 4731
/* 4668 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4671 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4701
/* 4676 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4679 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4688
/* 4684 */    MCD::OPC_Decode, 176, 7, 120, // Opcode: MOV32de
/* 4688 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4697
/* 4693 */    MCD::OPC_Decode, 146, 7, 63, // Opcode: MOV32ae
/* 4697 */    MCD::OPC_Decode, 143, 8, 107, // Opcode: MOV32re
/* 4701 */    MCD::OPC_FilterValue, 1, 66, 41, 0, // Skip to: 15268
/* 4706 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4709 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4718
/* 4714 */    MCD::OPC_Decode, 182, 7, 121, // Opcode: MOV32dp
/* 4718 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4727
/* 4723 */    MCD::OPC_Decode, 157, 7, 64, // Opcode: MOV32ap
/* 4727 */    MCD::OPC_Decode, 154, 8, 122, // Opcode: MOV32rp
/* 4731 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 4791
/* 4736 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4739 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4765
/* 4744 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4747 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4756
/* 4752 */    MCD::OPC_Decode, 211, 7, 63, // Opcode: MOV32je
/* 4756 */    MCD::OPC_FilterValue, 1, 11, 41, 0, // Skip to: 15268
/* 4761 */    MCD::OPC_Decode, 235, 7, 63, // Opcode: MOV32oe
/* 4765 */    MCD::OPC_FilterValue, 1, 2, 41, 0, // Skip to: 15268
/* 4770 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4773 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4782
/* 4778 */    MCD::OPC_Decode, 217, 7, 64, // Opcode: MOV32jp
/* 4782 */    MCD::OPC_FilterValue, 1, 241, 40, 0, // Skip to: 15268
/* 4787 */    MCD::OPC_Decode, 241, 7, 64, // Opcode: MOV32op
/* 4791 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 4851
/* 4796 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4799 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4825
/* 4804 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4807 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4816
/* 4812 */    MCD::OPC_Decode, 187, 7, 63, // Opcode: MOV32ee
/* 4816 */    MCD::OPC_FilterValue, 1, 207, 40, 0, // Skip to: 15268
/* 4821 */    MCD::OPC_Decode, 247, 7, 71, // Opcode: MOV32pe
/* 4825 */    MCD::OPC_FilterValue, 1, 198, 40, 0, // Skip to: 15268
/* 4830 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4833 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4842
/* 4838 */    MCD::OPC_Decode, 193, 7, 64, // Opcode: MOV32ep
/* 4842 */    MCD::OPC_FilterValue, 1, 181, 40, 0, // Skip to: 15268
/* 4847 */    MCD::OPC_Decode, 253, 7, 72, // Opcode: MOV32pp
/* 4851 */    MCD::OPC_FilterValue, 3, 172, 40, 0, // Skip to: 15268
/* 4856 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4859 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 4925
/* 4864 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4867 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4883
/* 4872 */    MCD::OPC_CheckField, 24, 4, 8, 149, 40, 0, // Skip to: 15268
/* 4879 */    MCD::OPC_Decode, 199, 7, 79, // Opcode: MOV32fe
/* 4883 */    MCD::OPC_FilterValue, 1, 140, 40, 0, // Skip to: 15268
/* 4888 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4891 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4900
/* 4896 */    MCD::OPC_Decode, 165, 7, 28, // Opcode: MOV32be
/* 4900 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4909
/* 4905 */    MCD::OPC_Decode, 131, 8, 17, // Opcode: MOV32qe
/* 4909 */    MCD::OPC_FilterValue, 3, 114, 40, 0, // Skip to: 15268
/* 4914 */    MCD::OPC_CheckField, 24, 4, 8, 107, 40, 0, // Skip to: 15268
/* 4921 */    MCD::OPC_Decode, 223, 7, 89, // Opcode: MOV32ke
/* 4925 */    MCD::OPC_FilterValue, 1, 98, 40, 0, // Skip to: 15268
/* 4930 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4933 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4949
/* 4938 */    MCD::OPC_CheckField, 40, 4, 8, 83, 40, 0, // Skip to: 15268
/* 4945 */    MCD::OPC_Decode, 205, 7, 80, // Opcode: MOV32fp
/* 4949 */    MCD::OPC_FilterValue, 1, 74, 40, 0, // Skip to: 15268
/* 4954 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4957 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4966
/* 4962 */    MCD::OPC_Decode, 171, 7, 90, // Opcode: MOV32bp
/* 4966 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4975
/* 4971 */    MCD::OPC_Decode, 137, 8, 91, // Opcode: MOV32qp
/* 4975 */    MCD::OPC_FilterValue, 3, 48, 40, 0, // Skip to: 15268
/* 4980 */    MCD::OPC_CheckField, 40, 4, 8, 41, 40, 0, // Skip to: 15268
/* 4987 */    MCD::OPC_Decode, 229, 7, 92, // Opcode: MOV32kp
/* 4991 */    MCD::OPC_FilterValue, 3, 32, 40, 0, // Skip to: 15268
/* 4996 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4999 */    MCD::OPC_FilterValue, 0, 180, 0, 0, // Skip to: 5184
/* 5004 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5007 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 5045
/* 5012 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5015 */    MCD::OPC_FilterValue, 8, 8, 40, 0, // Skip to: 15268
/* 5020 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5023 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5032
/* 5028 */    MCD::OPC_Decode, 177, 7, 123, // Opcode: MOV32df
/* 5032 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5041
/* 5037 */    MCD::OPC_Decode, 148, 7, 65, // Opcode: MOV32af
/* 5041 */    MCD::OPC_Decode, 145, 8, 124, // Opcode: MOV32rf
/* 5045 */    MCD::OPC_FilterValue, 1, 234, 39, 0, // Skip to: 15268
/* 5050 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5053 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 5083
/* 5058 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5061 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5070
/* 5066 */    MCD::OPC_Decode, 174, 7, 125, // Opcode: MOV32db
/* 5070 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5079
/* 5075 */    MCD::OPC_Decode, 144, 7, 66, // Opcode: MOV32ab
/* 5079 */    MCD::OPC_Decode, 141, 8, 126, // Opcode: MOV32rb
/* 5083 */    MCD::OPC_FilterValue, 2, 26, 0, 0, // Skip to: 5114
/* 5088 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5091 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5100
/* 5096 */    MCD::OPC_Decode, 183, 7, 127, // Opcode: MOV32dq
/* 5100 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5109
/* 5105 */    MCD::OPC_Decode, 159, 7, 67, // Opcode: MOV32aq
/* 5109 */    MCD::OPC_Decode, 156, 8, 128, 1, // Opcode: MOV32rq
/* 5114 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 5154
/* 5119 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5122 */    MCD::OPC_FilterValue, 8, 157, 39, 0, // Skip to: 15268
/* 5127 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5130 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5140
/* 5135 */    MCD::OPC_Decode, 180, 7, 129, 1, // Opcode: MOV32dk
/* 5140 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5149
/* 5145 */    MCD::OPC_Decode, 153, 7, 68, // Opcode: MOV32ak
/* 5149 */    MCD::OPC_Decode, 150, 8, 130, 1, // Opcode: MOV32rk
/* 5154 */    MCD::OPC_FilterValue, 4, 125, 39, 0, // Skip to: 15268
/* 5159 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5162 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5171
/* 5167 */    MCD::OPC_Decode, 178, 7, 125, // Opcode: MOV32di
/* 5171 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5180
/* 5176 */    MCD::OPC_Decode, 150, 7, 66, // Opcode: MOV32ai
/* 5180 */    MCD::OPC_Decode, 147, 8, 126, // Opcode: MOV32ri
/* 5184 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 5358
/* 5189 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5192 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 5232
/* 5197 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5200 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5216
/* 5205 */    MCD::OPC_CheckField, 24, 4, 8, 72, 39, 0, // Skip to: 15268
/* 5212 */    MCD::OPC_Decode, 212, 7, 65, // Opcode: MOV32jf
/* 5216 */    MCD::OPC_FilterValue, 1, 63, 39, 0, // Skip to: 15268
/* 5221 */    MCD::OPC_CheckField, 24, 4, 8, 56, 39, 0, // Skip to: 15268
/* 5228 */    MCD::OPC_Decode, 236, 7, 65, // Opcode: MOV32of
/* 5232 */    MCD::OPC_FilterValue, 1, 47, 39, 0, // Skip to: 15268
/* 5237 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5240 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 5266
/* 5245 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5248 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5257
/* 5253 */    MCD::OPC_Decode, 209, 7, 66, // Opcode: MOV32jb
/* 5257 */    MCD::OPC_FilterValue, 1, 22, 39, 0, // Skip to: 15268
/* 5262 */    MCD::OPC_Decode, 233, 7, 66, // Opcode: MOV32ob
/* 5266 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 5292
/* 5271 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5274 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5283
/* 5279 */    MCD::OPC_Decode, 218, 7, 67, // Opcode: MOV32jq
/* 5283 */    MCD::OPC_FilterValue, 1, 252, 38, 0, // Skip to: 15268
/* 5288 */    MCD::OPC_Decode, 242, 7, 67, // Opcode: MOV32oq
/* 5292 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 5332
/* 5297 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5300 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5316
/* 5305 */    MCD::OPC_CheckField, 24, 4, 8, 228, 38, 0, // Skip to: 15268
/* 5312 */    MCD::OPC_Decode, 215, 7, 68, // Opcode: MOV32jk
/* 5316 */    MCD::OPC_FilterValue, 1, 219, 38, 0, // Skip to: 15268
/* 5321 */    MCD::OPC_CheckField, 24, 4, 8, 212, 38, 0, // Skip to: 15268
/* 5328 */    MCD::OPC_Decode, 239, 7, 68, // Opcode: MOV32ok
/* 5332 */    MCD::OPC_FilterValue, 4, 203, 38, 0, // Skip to: 15268
/* 5337 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5340 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5349
/* 5345 */    MCD::OPC_Decode, 213, 7, 66, // Opcode: MOV32ji
/* 5349 */    MCD::OPC_FilterValue, 1, 186, 38, 0, // Skip to: 15268
/* 5354 */    MCD::OPC_Decode, 237, 7, 66, // Opcode: MOV32oi
/* 5358 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 5532
/* 5363 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5366 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 5406
/* 5371 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5374 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5390
/* 5379 */    MCD::OPC_CheckField, 24, 4, 8, 154, 38, 0, // Skip to: 15268
/* 5386 */    MCD::OPC_Decode, 188, 7, 65, // Opcode: MOV32ef
/* 5390 */    MCD::OPC_FilterValue, 1, 145, 38, 0, // Skip to: 15268
/* 5395 */    MCD::OPC_CheckField, 24, 4, 8, 138, 38, 0, // Skip to: 15268
/* 5402 */    MCD::OPC_Decode, 248, 7, 73, // Opcode: MOV32pf
/* 5406 */    MCD::OPC_FilterValue, 1, 129, 38, 0, // Skip to: 15268
/* 5411 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5414 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 5440
/* 5419 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5422 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5431
/* 5427 */    MCD::OPC_Decode, 185, 7, 66, // Opcode: MOV32eb
/* 5431 */    MCD::OPC_FilterValue, 1, 104, 38, 0, // Skip to: 15268
/* 5436 */    MCD::OPC_Decode, 245, 7, 74, // Opcode: MOV32pb
/* 5440 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 5466
/* 5445 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5448 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5457
/* 5453 */    MCD::OPC_Decode, 194, 7, 67, // Opcode: MOV32eq
/* 5457 */    MCD::OPC_FilterValue, 1, 78, 38, 0, // Skip to: 15268
/* 5462 */    MCD::OPC_Decode, 254, 7, 75, // Opcode: MOV32pq
/* 5466 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 5506
/* 5471 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5474 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5490
/* 5479 */    MCD::OPC_CheckField, 24, 4, 8, 54, 38, 0, // Skip to: 15268
/* 5486 */    MCD::OPC_Decode, 191, 7, 68, // Opcode: MOV32ek
/* 5490 */    MCD::OPC_FilterValue, 1, 45, 38, 0, // Skip to: 15268
/* 5495 */    MCD::OPC_CheckField, 24, 4, 8, 38, 38, 0, // Skip to: 15268
/* 5502 */    MCD::OPC_Decode, 251, 7, 76, // Opcode: MOV32pk
/* 5506 */    MCD::OPC_FilterValue, 4, 29, 38, 0, // Skip to: 15268
/* 5511 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5514 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5523
/* 5519 */    MCD::OPC_Decode, 189, 7, 66, // Opcode: MOV32ei
/* 5523 */    MCD::OPC_FilterValue, 1, 12, 38, 0, // Skip to: 15268
/* 5528 */    MCD::OPC_Decode, 249, 7, 74, // Opcode: MOV32pi
/* 5532 */    MCD::OPC_FilterValue, 3, 3, 38, 0, // Skip to: 15268
/* 5537 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5540 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 5634
/* 5545 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5548 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5571
/* 5553 */    MCD::OPC_CheckField, 40, 4, 8, 236, 37, 0, // Skip to: 15268
/* 5560 */    MCD::OPC_CheckField, 24, 4, 8, 229, 37, 0, // Skip to: 15268
/* 5567 */    MCD::OPC_Decode, 200, 7, 81, // Opcode: MOV32ff
/* 5571 */    MCD::OPC_FilterValue, 1, 220, 37, 0, // Skip to: 15268
/* 5576 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5579 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 5595
/* 5584 */    MCD::OPC_CheckField, 24, 4, 8, 205, 37, 0, // Skip to: 15268
/* 5591 */    MCD::OPC_Decode, 166, 7, 93, // Opcode: MOV32bf
/* 5595 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 5611
/* 5600 */    MCD::OPC_CheckField, 24, 4, 8, 189, 37, 0, // Skip to: 15268
/* 5607 */    MCD::OPC_Decode, 132, 8, 94, // Opcode: MOV32qf
/* 5611 */    MCD::OPC_FilterValue, 3, 180, 37, 0, // Skip to: 15268
/* 5616 */    MCD::OPC_CheckField, 40, 4, 8, 173, 37, 0, // Skip to: 15268
/* 5623 */    MCD::OPC_CheckField, 24, 4, 8, 166, 37, 0, // Skip to: 15268
/* 5630 */    MCD::OPC_Decode, 224, 7, 95, // Opcode: MOV32kf
/* 5634 */    MCD::OPC_FilterValue, 1, 157, 37, 0, // Skip to: 15268
/* 5639 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5642 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 5708
/* 5647 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5650 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5666
/* 5655 */    MCD::OPC_CheckField, 56, 4, 8, 134, 37, 0, // Skip to: 15268
/* 5662 */    MCD::OPC_Decode, 197, 7, 82, // Opcode: MOV32fb
/* 5666 */    MCD::OPC_FilterValue, 1, 125, 37, 0, // Skip to: 15268
/* 5671 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5674 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5683
/* 5679 */    MCD::OPC_Decode, 163, 7, 96, // Opcode: MOV32bb
/* 5683 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5692
/* 5688 */    MCD::OPC_Decode, 129, 8, 97, // Opcode: MOV32qb
/* 5692 */    MCD::OPC_FilterValue, 3, 99, 37, 0, // Skip to: 15268
/* 5697 */    MCD::OPC_CheckField, 56, 4, 8, 92, 37, 0, // Skip to: 15268
/* 5704 */    MCD::OPC_Decode, 221, 7, 98, // Opcode: MOV32kb
/* 5708 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 5774
/* 5713 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5716 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5732
/* 5721 */    MCD::OPC_CheckField, 40, 4, 8, 68, 37, 0, // Skip to: 15268
/* 5728 */    MCD::OPC_Decode, 206, 7, 83, // Opcode: MOV32fq
/* 5732 */    MCD::OPC_FilterValue, 1, 59, 37, 0, // Skip to: 15268
/* 5737 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5740 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5749
/* 5745 */    MCD::OPC_Decode, 172, 7, 99, // Opcode: MOV32bq
/* 5749 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5758
/* 5754 */    MCD::OPC_Decode, 138, 8, 100, // Opcode: MOV32qq
/* 5758 */    MCD::OPC_FilterValue, 3, 33, 37, 0, // Skip to: 15268
/* 5763 */    MCD::OPC_CheckField, 40, 4, 8, 26, 37, 0, // Skip to: 15268
/* 5770 */    MCD::OPC_Decode, 230, 7, 101, // Opcode: MOV32kq
/* 5774 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 5868
/* 5779 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5782 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5805
/* 5787 */    MCD::OPC_CheckField, 40, 4, 8, 2, 37, 0, // Skip to: 15268
/* 5794 */    MCD::OPC_CheckField, 24, 4, 8, 251, 36, 0, // Skip to: 15268
/* 5801 */    MCD::OPC_Decode, 203, 7, 84, // Opcode: MOV32fk
/* 5805 */    MCD::OPC_FilterValue, 1, 242, 36, 0, // Skip to: 15268
/* 5810 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5813 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 5829
/* 5818 */    MCD::OPC_CheckField, 24, 4, 8, 227, 36, 0, // Skip to: 15268
/* 5825 */    MCD::OPC_Decode, 169, 7, 102, // Opcode: MOV32bk
/* 5829 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 5845
/* 5834 */    MCD::OPC_CheckField, 24, 4, 8, 211, 36, 0, // Skip to: 15268
/* 5841 */    MCD::OPC_Decode, 135, 8, 103, // Opcode: MOV32qk
/* 5845 */    MCD::OPC_FilterValue, 3, 202, 36, 0, // Skip to: 15268
/* 5850 */    MCD::OPC_CheckField, 40, 4, 8, 195, 36, 0, // Skip to: 15268
/* 5857 */    MCD::OPC_CheckField, 24, 4, 8, 188, 36, 0, // Skip to: 15268
/* 5864 */    MCD::OPC_Decode, 227, 7, 104, // Opcode: MOV32kk
/* 5868 */    MCD::OPC_FilterValue, 4, 179, 36, 0, // Skip to: 15268
/* 5873 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5876 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5892
/* 5881 */    MCD::OPC_CheckField, 56, 4, 8, 164, 36, 0, // Skip to: 15268
/* 5888 */    MCD::OPC_Decode, 201, 7, 82, // Opcode: MOV32fi
/* 5892 */    MCD::OPC_FilterValue, 1, 155, 36, 0, // Skip to: 15268
/* 5897 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5900 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5909
/* 5905 */    MCD::OPC_Decode, 167, 7, 96, // Opcode: MOV32bi
/* 5909 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5918
/* 5914 */    MCD::OPC_Decode, 133, 8, 97, // Opcode: MOV32qi
/* 5918 */    MCD::OPC_FilterValue, 3, 129, 36, 0, // Skip to: 15268
/* 5923 */    MCD::OPC_CheckField, 56, 4, 8, 122, 36, 0, // Skip to: 15268
/* 5930 */    MCD::OPC_Decode, 225, 7, 98, // Opcode: MOV32ki
/* 5934 */    MCD::OPC_FilterValue, 3, 233, 7, 0, // Skip to: 7964
/* 5939 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 5942 */    MCD::OPC_FilterValue, 0, 122, 1, 0, // Skip to: 6325
/* 5947 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5950 */    MCD::OPC_FilterValue, 0, 59, 0, 0, // Skip to: 6014
/* 5955 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5958 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 5975
/* 5963 */    MCD::OPC_CheckField, 6, 1, 0, 27, 0, 0, // Skip to: 5997
/* 5970 */    MCD::OPC_Decode, 135, 6, 131, 1, // Opcode: MOV16dd
/* 5975 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 5997
/* 5980 */    MCD::OPC_CheckField, 6, 1, 1, 5, 0, 0, // Skip to: 5992
/* 5987 */    MCD::OPC_Decode, 219, 5, 132, 1, // Opcode: MOV16aa
/* 5992 */    MCD::OPC_Decode, 243, 6, 133, 1, // Opcode: MOV16ra
/* 5997 */    MCD::OPC_CheckField, 6, 1, 1, 5, 0, 0, // Skip to: 6009
/* 6004 */    MCD::OPC_Decode, 237, 5, 134, 1, // Opcode: MOV16ar
/* 6009 */    MCD::OPC_Decode, 133, 7, 135, 1, // Opcode: MOV16rr
/* 6014 */    MCD::OPC_FilterValue, 1, 69, 0, 0, // Skip to: 6088
/* 6019 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6022 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6055
/* 6027 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6030 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6040
/* 6035 */    MCD::OPC_Decode, 176, 6, 136, 1, // Opcode: MOV16jd
/* 6040 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6050
/* 6045 */    MCD::OPC_Decode, 173, 6, 137, 1, // Opcode: MOV16ja
/* 6050 */    MCD::OPC_Decode, 185, 6, 138, 1, // Opcode: MOV16jr
/* 6055 */    MCD::OPC_FilterValue, 1, 248, 35, 0, // Skip to: 15268
/* 6060 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6063 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6073
/* 6068 */    MCD::OPC_Decode, 204, 6, 136, 1, // Opcode: MOV16od
/* 6073 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6083
/* 6078 */    MCD::OPC_Decode, 201, 6, 137, 1, // Opcode: MOV16oa
/* 6083 */    MCD::OPC_Decode, 213, 6, 138, 1, // Opcode: MOV16or
/* 6088 */    MCD::OPC_FilterValue, 2, 69, 0, 0, // Skip to: 6162
/* 6093 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6096 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6129
/* 6101 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6104 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6114
/* 6109 */    MCD::OPC_Decode, 148, 6, 136, 1, // Opcode: MOV16ed
/* 6114 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6124
/* 6119 */    MCD::OPC_Decode, 145, 6, 137, 1, // Opcode: MOV16ea
/* 6124 */    MCD::OPC_Decode, 157, 6, 138, 1, // Opcode: MOV16er
/* 6129 */    MCD::OPC_FilterValue, 1, 174, 35, 0, // Skip to: 15268
/* 6134 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6137 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6147
/* 6142 */    MCD::OPC_Decode, 218, 6, 139, 1, // Opcode: MOV16pd
/* 6147 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6157
/* 6152 */    MCD::OPC_Decode, 215, 6, 140, 1, // Opcode: MOV16pa
/* 6157 */    MCD::OPC_Decode, 227, 6, 141, 1, // Opcode: MOV16pr
/* 6162 */    MCD::OPC_FilterValue, 3, 141, 35, 0, // Skip to: 15268
/* 6167 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6170 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 6211
/* 6175 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6178 */    MCD::OPC_FilterValue, 8, 125, 35, 0, // Skip to: 15268
/* 6183 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6186 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6196
/* 6191 */    MCD::OPC_Decode, 162, 6, 142, 1, // Opcode: MOV16fd
/* 6196 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6206
/* 6201 */    MCD::OPC_Decode, 159, 6, 143, 1, // Opcode: MOV16fa
/* 6206 */    MCD::OPC_Decode, 171, 6, 144, 1, // Opcode: MOV16fr
/* 6211 */    MCD::OPC_FilterValue, 1, 92, 35, 0, // Skip to: 15268
/* 6216 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6219 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6252
/* 6224 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6227 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6237
/* 6232 */    MCD::OPC_Decode, 241, 5, 145, 1, // Opcode: MOV16bd
/* 6237 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6247
/* 6242 */    MCD::OPC_Decode, 238, 5, 146, 1, // Opcode: MOV16ba
/* 6247 */    MCD::OPC_Decode, 250, 5, 147, 1, // Opcode: MOV16br
/* 6252 */    MCD::OPC_FilterValue, 2, 27, 0, 0, // Skip to: 6284
/* 6257 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6260 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6269
/* 6265 */    MCD::OPC_Decode, 232, 6, 15, // Opcode: MOV16qd
/* 6269 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6279
/* 6274 */    MCD::OPC_Decode, 229, 6, 148, 1, // Opcode: MOV16qa
/* 6279 */    MCD::OPC_Decode, 241, 6, 149, 1, // Opcode: MOV16qr
/* 6284 */    MCD::OPC_FilterValue, 3, 19, 35, 0, // Skip to: 15268
/* 6289 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6292 */    MCD::OPC_FilterValue, 8, 11, 35, 0, // Skip to: 15268
/* 6297 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6300 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6310
/* 6305 */    MCD::OPC_Decode, 190, 6, 150, 1, // Opcode: MOV16kd
/* 6310 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6320
/* 6315 */    MCD::OPC_Decode, 187, 6, 151, 1, // Opcode: MOV16ka
/* 6320 */    MCD::OPC_Decode, 199, 6, 152, 1, // Opcode: MOV16kr
/* 6325 */    MCD::OPC_FilterValue, 1, 81, 1, 0, // Skip to: 6667
/* 6330 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6333 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 6407
/* 6338 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6341 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6374
/* 6346 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6349 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6359
/* 6354 */    MCD::OPC_Decode, 139, 6, 153, 1, // Opcode: MOV16dj
/* 6359 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6369
/* 6364 */    MCD::OPC_Decode, 227, 5, 154, 1, // Opcode: MOV16aj
/* 6369 */    MCD::OPC_Decode, 251, 6, 155, 1, // Opcode: MOV16rj
/* 6374 */    MCD::OPC_FilterValue, 1, 185, 34, 0, // Skip to: 15268
/* 6379 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6382 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6392
/* 6387 */    MCD::OPC_Decode, 141, 6, 153, 1, // Opcode: MOV16do
/* 6392 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6402
/* 6397 */    MCD::OPC_Decode, 231, 5, 154, 1, // Opcode: MOV16ao
/* 6402 */    MCD::OPC_Decode, 255, 6, 155, 1, // Opcode: MOV16ro
/* 6407 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 6467
/* 6412 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6415 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6441
/* 6420 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6423 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6432
/* 6428 */    MCD::OPC_Decode, 180, 6, 63, // Opcode: MOV16jj
/* 6432 */    MCD::OPC_FilterValue, 1, 127, 34, 0, // Skip to: 15268
/* 6437 */    MCD::OPC_Decode, 208, 6, 63, // Opcode: MOV16oj
/* 6441 */    MCD::OPC_FilterValue, 1, 118, 34, 0, // Skip to: 15268
/* 6446 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6449 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6458
/* 6454 */    MCD::OPC_Decode, 182, 6, 63, // Opcode: MOV16jo
/* 6458 */    MCD::OPC_FilterValue, 1, 101, 34, 0, // Skip to: 15268
/* 6463 */    MCD::OPC_Decode, 210, 6, 63, // Opcode: MOV16oo
/* 6467 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 6527
/* 6472 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6475 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6501
/* 6480 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6483 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6492
/* 6488 */    MCD::OPC_Decode, 152, 6, 63, // Opcode: MOV16ej
/* 6492 */    MCD::OPC_FilterValue, 1, 67, 34, 0, // Skip to: 15268
/* 6497 */    MCD::OPC_Decode, 222, 6, 71, // Opcode: MOV16pj
/* 6501 */    MCD::OPC_FilterValue, 1, 58, 34, 0, // Skip to: 15268
/* 6506 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6509 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6518
/* 6514 */    MCD::OPC_Decode, 154, 6, 63, // Opcode: MOV16eo
/* 6518 */    MCD::OPC_FilterValue, 1, 41, 34, 0, // Skip to: 15268
/* 6523 */    MCD::OPC_Decode, 224, 6, 71, // Opcode: MOV16po
/* 6527 */    MCD::OPC_FilterValue, 3, 32, 34, 0, // Skip to: 15268
/* 6532 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6535 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 6601
/* 6540 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6543 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6559
/* 6548 */    MCD::OPC_CheckField, 24, 4, 8, 9, 34, 0, // Skip to: 15268
/* 6555 */    MCD::OPC_Decode, 166, 6, 79, // Opcode: MOV16fj
/* 6559 */    MCD::OPC_FilterValue, 1, 0, 34, 0, // Skip to: 15268
/* 6564 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6567 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6576
/* 6572 */    MCD::OPC_Decode, 245, 5, 28, // Opcode: MOV16bj
/* 6576 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6585
/* 6581 */    MCD::OPC_Decode, 236, 6, 17, // Opcode: MOV16qj
/* 6585 */    MCD::OPC_FilterValue, 3, 230, 33, 0, // Skip to: 15268
/* 6590 */    MCD::OPC_CheckField, 24, 4, 8, 223, 33, 0, // Skip to: 15268
/* 6597 */    MCD::OPC_Decode, 194, 6, 89, // Opcode: MOV16kj
/* 6601 */    MCD::OPC_FilterValue, 1, 214, 33, 0, // Skip to: 15268
/* 6606 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6609 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6625
/* 6614 */    MCD::OPC_CheckField, 24, 4, 8, 199, 33, 0, // Skip to: 15268
/* 6621 */    MCD::OPC_Decode, 168, 6, 79, // Opcode: MOV16fo
/* 6625 */    MCD::OPC_FilterValue, 1, 190, 33, 0, // Skip to: 15268
/* 6630 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6633 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6642
/* 6638 */    MCD::OPC_Decode, 247, 5, 28, // Opcode: MOV16bo
/* 6642 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6651
/* 6647 */    MCD::OPC_Decode, 238, 6, 17, // Opcode: MOV16qo
/* 6651 */    MCD::OPC_FilterValue, 3, 164, 33, 0, // Skip to: 15268
/* 6656 */    MCD::OPC_CheckField, 24, 4, 8, 157, 33, 0, // Skip to: 15268
/* 6663 */    MCD::OPC_Decode, 196, 6, 89, // Opcode: MOV16ko
/* 6667 */    MCD::OPC_FilterValue, 2, 81, 1, 0, // Skip to: 7009
/* 6672 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6675 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 6749
/* 6680 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6683 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6716
/* 6688 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6691 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6701
/* 6696 */    MCD::OPC_Decode, 136, 6, 153, 1, // Opcode: MOV16de
/* 6701 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6711
/* 6706 */    MCD::OPC_Decode, 222, 5, 154, 1, // Opcode: MOV16ae
/* 6711 */    MCD::OPC_Decode, 246, 6, 155, 1, // Opcode: MOV16re
/* 6716 */    MCD::OPC_FilterValue, 1, 99, 33, 0, // Skip to: 15268
/* 6721 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6724 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6734
/* 6729 */    MCD::OPC_Decode, 142, 6, 156, 1, // Opcode: MOV16dp
/* 6734 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6744
/* 6739 */    MCD::OPC_Decode, 233, 5, 157, 1, // Opcode: MOV16ap
/* 6744 */    MCD::OPC_Decode, 129, 7, 158, 1, // Opcode: MOV16rp
/* 6749 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 6809
/* 6754 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6757 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6783
/* 6762 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6765 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6774
/* 6770 */    MCD::OPC_Decode, 177, 6, 63, // Opcode: MOV16je
/* 6774 */    MCD::OPC_FilterValue, 1, 41, 33, 0, // Skip to: 15268
/* 6779 */    MCD::OPC_Decode, 205, 6, 63, // Opcode: MOV16oe
/* 6783 */    MCD::OPC_FilterValue, 1, 32, 33, 0, // Skip to: 15268
/* 6788 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6791 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6800
/* 6796 */    MCD::OPC_Decode, 183, 6, 64, // Opcode: MOV16jp
/* 6800 */    MCD::OPC_FilterValue, 1, 15, 33, 0, // Skip to: 15268
/* 6805 */    MCD::OPC_Decode, 211, 6, 64, // Opcode: MOV16op
/* 6809 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 6869
/* 6814 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6817 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6843
/* 6822 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6825 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6834
/* 6830 */    MCD::OPC_Decode, 149, 6, 63, // Opcode: MOV16ee
/* 6834 */    MCD::OPC_FilterValue, 1, 237, 32, 0, // Skip to: 15268
/* 6839 */    MCD::OPC_Decode, 219, 6, 71, // Opcode: MOV16pe
/* 6843 */    MCD::OPC_FilterValue, 1, 228, 32, 0, // Skip to: 15268
/* 6848 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6851 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6860
/* 6856 */    MCD::OPC_Decode, 155, 6, 64, // Opcode: MOV16ep
/* 6860 */    MCD::OPC_FilterValue, 1, 211, 32, 0, // Skip to: 15268
/* 6865 */    MCD::OPC_Decode, 225, 6, 72, // Opcode: MOV16pp
/* 6869 */    MCD::OPC_FilterValue, 3, 202, 32, 0, // Skip to: 15268
/* 6874 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6877 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 6943
/* 6882 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6885 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6901
/* 6890 */    MCD::OPC_CheckField, 24, 4, 8, 179, 32, 0, // Skip to: 15268
/* 6897 */    MCD::OPC_Decode, 163, 6, 79, // Opcode: MOV16fe
/* 6901 */    MCD::OPC_FilterValue, 1, 170, 32, 0, // Skip to: 15268
/* 6906 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6909 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6918
/* 6914 */    MCD::OPC_Decode, 242, 5, 28, // Opcode: MOV16be
/* 6918 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6927
/* 6923 */    MCD::OPC_Decode, 233, 6, 17, // Opcode: MOV16qe
/* 6927 */    MCD::OPC_FilterValue, 3, 144, 32, 0, // Skip to: 15268
/* 6932 */    MCD::OPC_CheckField, 24, 4, 8, 137, 32, 0, // Skip to: 15268
/* 6939 */    MCD::OPC_Decode, 191, 6, 89, // Opcode: MOV16ke
/* 6943 */    MCD::OPC_FilterValue, 1, 128, 32, 0, // Skip to: 15268
/* 6948 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6951 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6967
/* 6956 */    MCD::OPC_CheckField, 40, 4, 8, 113, 32, 0, // Skip to: 15268
/* 6963 */    MCD::OPC_Decode, 169, 6, 80, // Opcode: MOV16fp
/* 6967 */    MCD::OPC_FilterValue, 1, 104, 32, 0, // Skip to: 15268
/* 6972 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6975 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6984
/* 6980 */    MCD::OPC_Decode, 248, 5, 90, // Opcode: MOV16bp
/* 6984 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6993
/* 6989 */    MCD::OPC_Decode, 239, 6, 91, // Opcode: MOV16qp
/* 6993 */    MCD::OPC_FilterValue, 3, 78, 32, 0, // Skip to: 15268
/* 6998 */    MCD::OPC_CheckField, 40, 4, 8, 71, 32, 0, // Skip to: 15268
/* 7005 */    MCD::OPC_Decode, 197, 6, 92, // Opcode: MOV16kp
/* 7009 */    MCD::OPC_FilterValue, 3, 62, 32, 0, // Skip to: 15268
/* 7014 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 7017 */    MCD::OPC_FilterValue, 0, 192, 0, 0, // Skip to: 7214
/* 7022 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7025 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 7066
/* 7030 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 7033 */    MCD::OPC_FilterValue, 8, 38, 32, 0, // Skip to: 15268
/* 7038 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7041 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7051
/* 7046 */    MCD::OPC_Decode, 137, 6, 159, 1, // Opcode: MOV16df
/* 7051 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7061
/* 7056 */    MCD::OPC_Decode, 224, 5, 160, 1, // Opcode: MOV16af
/* 7061 */    MCD::OPC_Decode, 248, 6, 161, 1, // Opcode: MOV16rf
/* 7066 */    MCD::OPC_FilterValue, 1, 5, 32, 0, // Skip to: 15268
/* 7071 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7074 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 7107
/* 7079 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7082 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7092
/* 7087 */    MCD::OPC_Decode, 133, 6, 162, 1, // Opcode: MOV16db
/* 7092 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7102
/* 7097 */    MCD::OPC_Decode, 220, 5, 163, 1, // Opcode: MOV16ab
/* 7102 */    MCD::OPC_Decode, 244, 6, 164, 1, // Opcode: MOV16rb
/* 7107 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 7140
/* 7112 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7115 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7125
/* 7120 */    MCD::OPC_Decode, 143, 6, 165, 1, // Opcode: MOV16dq
/* 7125 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7135
/* 7130 */    MCD::OPC_Decode, 235, 5, 166, 1, // Opcode: MOV16aq
/* 7135 */    MCD::OPC_Decode, 131, 7, 167, 1, // Opcode: MOV16rq
/* 7140 */    MCD::OPC_FilterValue, 3, 36, 0, 0, // Skip to: 7181
/* 7145 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 7148 */    MCD::OPC_FilterValue, 8, 179, 31, 0, // Skip to: 15268
/* 7153 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7156 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7166
/* 7161 */    MCD::OPC_Decode, 140, 6, 168, 1, // Opcode: MOV16dk
/* 7166 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7176
/* 7171 */    MCD::OPC_Decode, 229, 5, 169, 1, // Opcode: MOV16ak
/* 7176 */    MCD::OPC_Decode, 253, 6, 170, 1, // Opcode: MOV16rk
/* 7181 */    MCD::OPC_FilterValue, 4, 146, 31, 0, // Skip to: 15268
/* 7186 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7189 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7199
/* 7194 */    MCD::OPC_Decode, 138, 6, 165, 1, // Opcode: MOV16di
/* 7199 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7209
/* 7204 */    MCD::OPC_Decode, 226, 5, 166, 1, // Opcode: MOV16ai
/* 7209 */    MCD::OPC_Decode, 250, 6, 167, 1, // Opcode: MOV16ri
/* 7214 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 7388
/* 7219 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7222 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 7262
/* 7227 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7230 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7246
/* 7235 */    MCD::OPC_CheckField, 24, 4, 8, 90, 31, 0, // Skip to: 15268
/* 7242 */    MCD::OPC_Decode, 178, 6, 65, // Opcode: MOV16jf
/* 7246 */    MCD::OPC_FilterValue, 1, 81, 31, 0, // Skip to: 15268
/* 7251 */    MCD::OPC_CheckField, 24, 4, 8, 74, 31, 0, // Skip to: 15268
/* 7258 */    MCD::OPC_Decode, 206, 6, 65, // Opcode: MOV16of
/* 7262 */    MCD::OPC_FilterValue, 1, 65, 31, 0, // Skip to: 15268
/* 7267 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7270 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 7296
/* 7275 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7278 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7287
/* 7283 */    MCD::OPC_Decode, 174, 6, 66, // Opcode: MOV16jb
/* 7287 */    MCD::OPC_FilterValue, 1, 40, 31, 0, // Skip to: 15268
/* 7292 */    MCD::OPC_Decode, 202, 6, 66, // Opcode: MOV16ob
/* 7296 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 7322
/* 7301 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7304 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7313
/* 7309 */    MCD::OPC_Decode, 184, 6, 67, // Opcode: MOV16jq
/* 7313 */    MCD::OPC_FilterValue, 1, 14, 31, 0, // Skip to: 15268
/* 7318 */    MCD::OPC_Decode, 212, 6, 67, // Opcode: MOV16oq
/* 7322 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 7362
/* 7327 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7330 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7346
/* 7335 */    MCD::OPC_CheckField, 24, 4, 8, 246, 30, 0, // Skip to: 15268
/* 7342 */    MCD::OPC_Decode, 181, 6, 68, // Opcode: MOV16jk
/* 7346 */    MCD::OPC_FilterValue, 1, 237, 30, 0, // Skip to: 15268
/* 7351 */    MCD::OPC_CheckField, 24, 4, 8, 230, 30, 0, // Skip to: 15268
/* 7358 */    MCD::OPC_Decode, 209, 6, 68, // Opcode: MOV16ok
/* 7362 */    MCD::OPC_FilterValue, 4, 221, 30, 0, // Skip to: 15268
/* 7367 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7370 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7379
/* 7375 */    MCD::OPC_Decode, 179, 6, 67, // Opcode: MOV16ji
/* 7379 */    MCD::OPC_FilterValue, 1, 204, 30, 0, // Skip to: 15268
/* 7384 */    MCD::OPC_Decode, 207, 6, 67, // Opcode: MOV16oi
/* 7388 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 7562
/* 7393 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7396 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 7436
/* 7401 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7404 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7420
/* 7409 */    MCD::OPC_CheckField, 24, 4, 8, 172, 30, 0, // Skip to: 15268
/* 7416 */    MCD::OPC_Decode, 150, 6, 65, // Opcode: MOV16ef
/* 7420 */    MCD::OPC_FilterValue, 1, 163, 30, 0, // Skip to: 15268
/* 7425 */    MCD::OPC_CheckField, 24, 4, 8, 156, 30, 0, // Skip to: 15268
/* 7432 */    MCD::OPC_Decode, 220, 6, 73, // Opcode: MOV16pf
/* 7436 */    MCD::OPC_FilterValue, 1, 147, 30, 0, // Skip to: 15268
/* 7441 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7444 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 7470
/* 7449 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7452 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7461
/* 7457 */    MCD::OPC_Decode, 146, 6, 66, // Opcode: MOV16eb
/* 7461 */    MCD::OPC_FilterValue, 1, 122, 30, 0, // Skip to: 15268
/* 7466 */    MCD::OPC_Decode, 216, 6, 74, // Opcode: MOV16pb
/* 7470 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 7496
/* 7475 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7478 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7487
/* 7483 */    MCD::OPC_Decode, 156, 6, 67, // Opcode: MOV16eq
/* 7487 */    MCD::OPC_FilterValue, 1, 96, 30, 0, // Skip to: 15268
/* 7492 */    MCD::OPC_Decode, 226, 6, 75, // Opcode: MOV16pq
/* 7496 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 7536
/* 7501 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7504 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7520
/* 7509 */    MCD::OPC_CheckField, 24, 4, 8, 72, 30, 0, // Skip to: 15268
/* 7516 */    MCD::OPC_Decode, 153, 6, 68, // Opcode: MOV16ek
/* 7520 */    MCD::OPC_FilterValue, 1, 63, 30, 0, // Skip to: 15268
/* 7525 */    MCD::OPC_CheckField, 24, 4, 8, 56, 30, 0, // Skip to: 15268
/* 7532 */    MCD::OPC_Decode, 223, 6, 76, // Opcode: MOV16pk
/* 7536 */    MCD::OPC_FilterValue, 4, 47, 30, 0, // Skip to: 15268
/* 7541 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7544 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7553
/* 7549 */    MCD::OPC_Decode, 151, 6, 67, // Opcode: MOV16ei
/* 7553 */    MCD::OPC_FilterValue, 1, 30, 30, 0, // Skip to: 15268
/* 7558 */    MCD::OPC_Decode, 221, 6, 75, // Opcode: MOV16pi
/* 7562 */    MCD::OPC_FilterValue, 3, 21, 30, 0, // Skip to: 15268
/* 7567 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7570 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 7664
/* 7575 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7578 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7601
/* 7583 */    MCD::OPC_CheckField, 40, 4, 8, 254, 29, 0, // Skip to: 15268
/* 7590 */    MCD::OPC_CheckField, 24, 4, 8, 247, 29, 0, // Skip to: 15268
/* 7597 */    MCD::OPC_Decode, 164, 6, 81, // Opcode: MOV16ff
/* 7601 */    MCD::OPC_FilterValue, 1, 238, 29, 0, // Skip to: 15268
/* 7606 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7609 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 7625
/* 7614 */    MCD::OPC_CheckField, 24, 4, 8, 223, 29, 0, // Skip to: 15268
/* 7621 */    MCD::OPC_Decode, 243, 5, 93, // Opcode: MOV16bf
/* 7625 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 7641
/* 7630 */    MCD::OPC_CheckField, 24, 4, 8, 207, 29, 0, // Skip to: 15268
/* 7637 */    MCD::OPC_Decode, 234, 6, 94, // Opcode: MOV16qf
/* 7641 */    MCD::OPC_FilterValue, 3, 198, 29, 0, // Skip to: 15268
/* 7646 */    MCD::OPC_CheckField, 40, 4, 8, 191, 29, 0, // Skip to: 15268
/* 7653 */    MCD::OPC_CheckField, 24, 4, 8, 184, 29, 0, // Skip to: 15268
/* 7660 */    MCD::OPC_Decode, 192, 6, 95, // Opcode: MOV16kf
/* 7664 */    MCD::OPC_FilterValue, 1, 175, 29, 0, // Skip to: 15268
/* 7669 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7672 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 7738
/* 7677 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7680 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7696
/* 7685 */    MCD::OPC_CheckField, 56, 4, 8, 152, 29, 0, // Skip to: 15268
/* 7692 */    MCD::OPC_Decode, 160, 6, 82, // Opcode: MOV16fb
/* 7696 */    MCD::OPC_FilterValue, 1, 143, 29, 0, // Skip to: 15268
/* 7701 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7704 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7713
/* 7709 */    MCD::OPC_Decode, 239, 5, 96, // Opcode: MOV16bb
/* 7713 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7722
/* 7718 */    MCD::OPC_Decode, 230, 6, 97, // Opcode: MOV16qb
/* 7722 */    MCD::OPC_FilterValue, 3, 117, 29, 0, // Skip to: 15268
/* 7727 */    MCD::OPC_CheckField, 56, 4, 8, 110, 29, 0, // Skip to: 15268
/* 7734 */    MCD::OPC_Decode, 188, 6, 98, // Opcode: MOV16kb
/* 7738 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 7804
/* 7743 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7746 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7762
/* 7751 */    MCD::OPC_CheckField, 40, 4, 8, 86, 29, 0, // Skip to: 15268
/* 7758 */    MCD::OPC_Decode, 170, 6, 83, // Opcode: MOV16fq
/* 7762 */    MCD::OPC_FilterValue, 1, 77, 29, 0, // Skip to: 15268
/* 7767 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7770 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7779
/* 7775 */    MCD::OPC_Decode, 249, 5, 99, // Opcode: MOV16bq
/* 7779 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7788
/* 7784 */    MCD::OPC_Decode, 240, 6, 100, // Opcode: MOV16qq
/* 7788 */    MCD::OPC_FilterValue, 3, 51, 29, 0, // Skip to: 15268
/* 7793 */    MCD::OPC_CheckField, 40, 4, 8, 44, 29, 0, // Skip to: 15268
/* 7800 */    MCD::OPC_Decode, 198, 6, 101, // Opcode: MOV16kq
/* 7804 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 7898
/* 7809 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7812 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7835
/* 7817 */    MCD::OPC_CheckField, 40, 4, 8, 20, 29, 0, // Skip to: 15268
/* 7824 */    MCD::OPC_CheckField, 24, 4, 8, 13, 29, 0, // Skip to: 15268
/* 7831 */    MCD::OPC_Decode, 167, 6, 84, // Opcode: MOV16fk
/* 7835 */    MCD::OPC_FilterValue, 1, 4, 29, 0, // Skip to: 15268
/* 7840 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7843 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 7859
/* 7848 */    MCD::OPC_CheckField, 24, 4, 8, 245, 28, 0, // Skip to: 15268
/* 7855 */    MCD::OPC_Decode, 246, 5, 102, // Opcode: MOV16bk
/* 7859 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 7875
/* 7864 */    MCD::OPC_CheckField, 24, 4, 8, 229, 28, 0, // Skip to: 15268
/* 7871 */    MCD::OPC_Decode, 237, 6, 103, // Opcode: MOV16qk
/* 7875 */    MCD::OPC_FilterValue, 3, 220, 28, 0, // Skip to: 15268
/* 7880 */    MCD::OPC_CheckField, 40, 4, 8, 213, 28, 0, // Skip to: 15268
/* 7887 */    MCD::OPC_CheckField, 24, 4, 8, 206, 28, 0, // Skip to: 15268
/* 7894 */    MCD::OPC_Decode, 195, 6, 104, // Opcode: MOV16kk
/* 7898 */    MCD::OPC_FilterValue, 4, 197, 28, 0, // Skip to: 15268
/* 7903 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7906 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7922
/* 7911 */    MCD::OPC_CheckField, 40, 4, 8, 182, 28, 0, // Skip to: 15268
/* 7918 */    MCD::OPC_Decode, 165, 6, 83, // Opcode: MOV16fi
/* 7922 */    MCD::OPC_FilterValue, 1, 173, 28, 0, // Skip to: 15268
/* 7927 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7930 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7939
/* 7935 */    MCD::OPC_Decode, 244, 5, 99, // Opcode: MOV16bi
/* 7939 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7948
/* 7944 */    MCD::OPC_Decode, 235, 6, 100, // Opcode: MOV16qi
/* 7948 */    MCD::OPC_FilterValue, 3, 147, 28, 0, // Skip to: 15268
/* 7953 */    MCD::OPC_CheckField, 40, 4, 8, 140, 28, 0, // Skip to: 15268
/* 7960 */    MCD::OPC_Decode, 193, 6, 101, // Opcode: MOV16ki
/* 7964 */    MCD::OPC_FilterValue, 4, 3, 7, 0, // Skip to: 9764
/* 7969 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 7972 */    MCD::OPC_FilterValue, 0, 107, 0, 0, // Skip to: 8084
/* 7977 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7980 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7990
/* 7985 */    MCD::OPC_Decode, 159, 9, 171, 1, // Opcode: NEGX8d
/* 7990 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8000
/* 7995 */    MCD::OPC_Decode, 156, 9, 171, 1, // Opcode: NEG8d
/* 8000 */    MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 8010
/* 8005 */    MCD::OPC_Decode, 163, 9, 171, 1, // Opcode: NOT8d
/* 8010 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 8027
/* 8015 */    MCD::OPC_CheckField, 3, 1, 1, 78, 28, 0, // Skip to: 15268
/* 8022 */    MCD::OPC_Decode, 212, 5, 172, 1, // Opcode: LINK32
/* 8027 */    MCD::OPC_FilterValue, 6, 68, 28, 0, // Skip to: 15268
/* 8032 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 8035 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 8059
/* 8040 */    MCD::OPC_CheckField, 31, 1, 0, 53, 28, 0, // Skip to: 15268
/* 8047 */    MCD::OPC_CheckField, 3, 1, 0, 46, 28, 0, // Skip to: 15268
/* 8054 */    MCD::OPC_Decode, 209, 10, 173, 1, // Opcode: UMULd32d32
/* 8059 */    MCD::OPC_FilterValue, 128, 16, 35, 28, 0, // Skip to: 15268
/* 8065 */    MCD::OPC_CheckField, 31, 1, 0, 28, 28, 0, // Skip to: 15268
/* 8072 */    MCD::OPC_CheckField, 3, 1, 0, 21, 28, 0, // Skip to: 15268
/* 8079 */    MCD::OPC_Decode, 149, 10, 173, 1, // Opcode: SMULd32d32
/* 8084 */    MCD::OPC_FilterValue, 4, 117, 0, 0, // Skip to: 8206
/* 8089 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8092 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8102
/* 8097 */    MCD::OPC_Decode, 157, 9, 174, 1, // Opcode: NEGX16d
/* 8102 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8112
/* 8107 */    MCD::OPC_Decode, 154, 9, 174, 1, // Opcode: NEG16d
/* 8112 */    MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 8122
/* 8117 */    MCD::OPC_Decode, 161, 9, 174, 1, // Opcode: NOT16d
/* 8122 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 8139
/* 8127 */    MCD::OPC_CheckField, 3, 1, 1, 222, 27, 0, // Skip to: 15268
/* 8134 */    MCD::OPC_Decode, 131, 4, 175, 1, // Opcode: BKPT
/* 8139 */    MCD::OPC_FilterValue, 6, 52, 0, 0, // Skip to: 8196
/* 8144 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 8147 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 8171
/* 8152 */    MCD::OPC_CheckField, 31, 1, 0, 197, 27, 0, // Skip to: 15268
/* 8159 */    MCD::OPC_CheckField, 3, 1, 0, 190, 27, 0, // Skip to: 15268
/* 8166 */    MCD::OPC_Decode, 206, 10, 173, 1, // Opcode: UDIVd32d32
/* 8171 */    MCD::OPC_FilterValue, 128, 16, 179, 27, 0, // Skip to: 15268
/* 8177 */    MCD::OPC_CheckField, 31, 1, 0, 172, 27, 0, // Skip to: 15268
/* 8184 */    MCD::OPC_CheckField, 3, 1, 0, 165, 27, 0, // Skip to: 15268
/* 8191 */    MCD::OPC_Decode, 220, 9, 173, 1, // Opcode: SDIVd32d32
/* 8196 */    MCD::OPC_FilterValue, 7, 155, 27, 0, // Skip to: 15268
/* 8201 */    MCD::OPC_Decode, 203, 10, 176, 1, // Opcode: TRAP
/* 8206 */    MCD::OPC_FilterValue, 5, 37, 0, 0, // Skip to: 8248
/* 8211 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8214 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 8231
/* 8219 */    MCD::OPC_CheckField, 9, 3, 7, 130, 27, 0, // Skip to: 15268
/* 8226 */    MCD::OPC_Decode, 211, 5, 177, 1, // Opcode: LINK16
/* 8231 */    MCD::OPC_FilterValue, 1, 120, 27, 0, // Skip to: 15268
/* 8236 */    MCD::OPC_CheckField, 9, 3, 7, 113, 27, 0, // Skip to: 15268
/* 8243 */    MCD::OPC_Decode, 211, 10, 178, 1, // Opcode: UNLK
/* 8248 */    MCD::OPC_FilterValue, 7, 71, 0, 0, // Skip to: 8324
/* 8253 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 8256 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 8273
/* 8261 */    MCD::OPC_CheckField, 9, 3, 7, 88, 27, 0, // Skip to: 15268
/* 8268 */    MCD::OPC_Decode, 160, 9, 179, 1, // Opcode: NOP
/* 8273 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 8290
/* 8278 */    MCD::OPC_CheckField, 9, 3, 7, 71, 27, 0, // Skip to: 15268
/* 8285 */    MCD::OPC_Decode, 217, 9, 179, 1, // Opcode: RTE
/* 8290 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 8307
/* 8295 */    MCD::OPC_CheckField, 9, 3, 7, 54, 27, 0, // Skip to: 15268
/* 8302 */    MCD::OPC_Decode, 218, 9, 179, 1, // Opcode: RTS
/* 8307 */    MCD::OPC_FilterValue, 6, 44, 27, 0, // Skip to: 15268
/* 8312 */    MCD::OPC_CheckField, 9, 3, 7, 37, 27, 0, // Skip to: 15268
/* 8319 */    MCD::OPC_Decode, 204, 10, 179, 1, // Opcode: TRAPV
/* 8324 */    MCD::OPC_FilterValue, 8, 50, 0, 0, // Skip to: 8379
/* 8329 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8332 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8342
/* 8337 */    MCD::OPC_Decode, 158, 9, 180, 1, // Opcode: NEGX32d
/* 8342 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8352
/* 8347 */    MCD::OPC_Decode, 155, 9, 180, 1, // Opcode: NEG32d
/* 8352 */    MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 8362
/* 8357 */    MCD::OPC_Decode, 162, 9, 180, 1, // Opcode: NOT32d
/* 8362 */    MCD::OPC_FilterValue, 4, 245, 26, 0, // Skip to: 15268
/* 8367 */    MCD::OPC_CheckField, 3, 1, 0, 238, 26, 0, // Skip to: 15268
/* 8374 */    MCD::OPC_Decode, 135, 5, 181, 1, // Opcode: EXT16
/* 8379 */    MCD::OPC_FilterValue, 9, 72, 0, 0, // Skip to: 8456
/* 8384 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8387 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8413
/* 8392 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8395 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8404
/* 8400 */    MCD::OPC_Decode, 252, 8, 16, // Opcode: MOVM16jm
/* 8404 */    MCD::OPC_FilterValue, 1, 203, 26, 0, // Skip to: 15268
/* 8409 */    MCD::OPC_Decode, 134, 9, 16, // Opcode: MOVM16om
/* 8413 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 8439
/* 8418 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8421 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8430
/* 8426 */    MCD::OPC_Decode, 129, 9, 17, // Opcode: MOVM16mj
/* 8430 */    MCD::OPC_FilterValue, 1, 177, 26, 0, // Skip to: 15268
/* 8435 */    MCD::OPC_Decode, 131, 9, 17, // Opcode: MOVM16mo
/* 8439 */    MCD::OPC_FilterValue, 7, 168, 26, 0, // Skip to: 15268
/* 8444 */    MCD::OPC_CheckField, 3, 1, 0, 161, 26, 0, // Skip to: 15268
/* 8451 */    MCD::OPC_Decode, 209, 4, 178, 1, // Opcode: CALLj
/* 8456 */    MCD::OPC_FilterValue, 10, 55, 0, 0, // Skip to: 8516
/* 8461 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8464 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 8490
/* 8469 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8472 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8481
/* 8477 */    MCD::OPC_Decode, 250, 8, 16, // Opcode: MOVM16em
/* 8481 */    MCD::OPC_FilterValue, 6, 126, 26, 0, // Skip to: 15268
/* 8486 */    MCD::OPC_Decode, 255, 8, 17, // Opcode: MOVM16me
/* 8490 */    MCD::OPC_FilterValue, 1, 117, 26, 0, // Skip to: 15268
/* 8495 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8498 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8507
/* 8503 */    MCD::OPC_Decode, 135, 9, 18, // Opcode: MOVM16pm
/* 8507 */    MCD::OPC_FilterValue, 6, 100, 26, 0, // Skip to: 15268
/* 8512 */    MCD::OPC_Decode, 132, 9, 19, // Opcode: MOVM16mp
/* 8516 */    MCD::OPC_FilterValue, 11, 180, 0, 0, // Skip to: 8701
/* 8521 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8524 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 8590
/* 8529 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8532 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8548
/* 8537 */    MCD::OPC_CheckField, 40, 4, 8, 68, 26, 0, // Skip to: 15268
/* 8544 */    MCD::OPC_Decode, 251, 8, 20, // Opcode: MOVM16fm
/* 8548 */    MCD::OPC_FilterValue, 1, 59, 26, 0, // Skip to: 15268
/* 8553 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8556 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8565
/* 8561 */    MCD::OPC_Decode, 249, 8, 99, // Opcode: MOVM16bm
/* 8565 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8574
/* 8570 */    MCD::OPC_Decode, 136, 9, 100, // Opcode: MOVM16qm
/* 8574 */    MCD::OPC_FilterValue, 3, 33, 26, 0, // Skip to: 15268
/* 8579 */    MCD::OPC_CheckField, 40, 4, 8, 26, 26, 0, // Skip to: 15268
/* 8586 */    MCD::OPC_Decode, 253, 8, 101, // Opcode: MOVM16km
/* 8590 */    MCD::OPC_FilterValue, 6, 61, 0, 0, // Skip to: 8656
/* 8595 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8598 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8614
/* 8603 */    MCD::OPC_CheckField, 40, 4, 8, 2, 26, 0, // Skip to: 15268
/* 8610 */    MCD::OPC_Decode, 128, 9, 21, // Opcode: MOVM16mf
/* 8614 */    MCD::OPC_FilterValue, 1, 249, 25, 0, // Skip to: 15268
/* 8619 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8622 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8631
/* 8627 */    MCD::OPC_Decode, 254, 8, 22, // Opcode: MOVM16mb
/* 8631 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8640
/* 8636 */    MCD::OPC_Decode, 133, 9, 23, // Opcode: MOVM16mq
/* 8640 */    MCD::OPC_FilterValue, 3, 223, 25, 0, // Skip to: 15268
/* 8645 */    MCD::OPC_CheckField, 40, 4, 8, 216, 25, 0, // Skip to: 15268
/* 8652 */    MCD::OPC_Decode, 130, 9, 24, // Opcode: MOVM16mk
/* 8656 */    MCD::OPC_FilterValue, 7, 207, 25, 0, // Skip to: 15268
/* 8661 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 8664 */    MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 8674
/* 8669 */    MCD::OPC_Decode, 208, 4, 182, 1, // Opcode: CALLb
/* 8674 */    MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 8684
/* 8679 */    MCD::OPC_Decode, 211, 4, 183, 1, // Opcode: CALLq
/* 8684 */    MCD::OPC_FilterValue, 11, 179, 25, 0, // Skip to: 15268
/* 8689 */    MCD::OPC_CheckField, 24, 4, 8, 172, 25, 0, // Skip to: 15268
/* 8696 */    MCD::OPC_Decode, 210, 4, 184, 1, // Opcode: CALLk
/* 8701 */    MCD::OPC_FilterValue, 12, 98, 0, 0, // Skip to: 8804
/* 8706 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8709 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 8731
/* 8714 */    MCD::OPC_CheckPredicate, 1, 149, 25, 0, // Skip to: 15268
/* 8719 */    MCD::OPC_CheckField, 3, 1, 0, 142, 25, 0, // Skip to: 15268
/* 8726 */    MCD::OPC_Decode, 144, 6, 185, 1, // Opcode: MOV16ds
/* 8731 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 8753
/* 8736 */    MCD::OPC_CheckPredicate, 1, 127, 25, 0, // Skip to: 15268
/* 8741 */    MCD::OPC_CheckField, 3, 1, 0, 120, 25, 0, // Skip to: 15268
/* 8748 */    MCD::OPC_Decode, 134, 6, 186, 1, // Opcode: MOV16dc
/* 8753 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 8770
/* 8758 */    MCD::OPC_CheckField, 3, 1, 0, 103, 25, 0, // Skip to: 15268
/* 8765 */    MCD::OPC_Decode, 253, 5, 187, 1, // Opcode: MOV16cd
/* 8770 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 8787
/* 8775 */    MCD::OPC_CheckField, 3, 1, 0, 86, 25, 0, // Skip to: 15268
/* 8782 */    MCD::OPC_Decode, 135, 7, 188, 1, // Opcode: MOV16sd
/* 8787 */    MCD::OPC_FilterValue, 4, 76, 25, 0, // Skip to: 15268
/* 8792 */    MCD::OPC_CheckField, 3, 1, 0, 69, 25, 0, // Skip to: 15268
/* 8799 */    MCD::OPC_Decode, 136, 5, 189, 1, // Opcode: EXT32
/* 8804 */    MCD::OPC_FilterValue, 13, 204, 0, 0, // Skip to: 9013
/* 8809 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8812 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 8850
/* 8817 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8820 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8835
/* 8825 */    MCD::OPC_CheckPredicate, 1, 38, 25, 0, // Skip to: 15268
/* 8830 */    MCD::OPC_Decode, 186, 6, 190, 1, // Opcode: MOV16js
/* 8835 */    MCD::OPC_FilterValue, 1, 28, 25, 0, // Skip to: 15268
/* 8840 */    MCD::OPC_CheckPredicate, 1, 23, 25, 0, // Skip to: 15268
/* 8845 */    MCD::OPC_Decode, 214, 6, 190, 1, // Opcode: MOV16os
/* 8850 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 8888
/* 8855 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8858 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8873
/* 8863 */    MCD::OPC_CheckPredicate, 1, 0, 25, 0, // Skip to: 15268
/* 8868 */    MCD::OPC_Decode, 175, 6, 191, 1, // Opcode: MOV16jc
/* 8873 */    MCD::OPC_FilterValue, 1, 246, 24, 0, // Skip to: 15268
/* 8878 */    MCD::OPC_CheckPredicate, 1, 241, 24, 0, // Skip to: 15268
/* 8883 */    MCD::OPC_Decode, 203, 6, 191, 1, // Opcode: MOV16oc
/* 8888 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 8916
/* 8893 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8896 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8906
/* 8901 */    MCD::OPC_Decode, 128, 6, 187, 1, // Opcode: MOV16cj
/* 8906 */    MCD::OPC_FilterValue, 1, 213, 24, 0, // Skip to: 15268
/* 8911 */    MCD::OPC_Decode, 130, 6, 187, 1, // Opcode: MOV16co
/* 8916 */    MCD::OPC_FilterValue, 3, 23, 0, 0, // Skip to: 8944
/* 8921 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8924 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8934
/* 8929 */    MCD::OPC_Decode, 138, 7, 188, 1, // Opcode: MOV16sj
/* 8934 */    MCD::OPC_FilterValue, 1, 185, 24, 0, // Skip to: 15268
/* 8939 */    MCD::OPC_Decode, 140, 7, 188, 1, // Opcode: MOV16so
/* 8944 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8970
/* 8949 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8952 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8961
/* 8957 */    MCD::OPC_Decode, 140, 9, 16, // Opcode: MOVM32jm
/* 8961 */    MCD::OPC_FilterValue, 1, 158, 24, 0, // Skip to: 15268
/* 8966 */    MCD::OPC_Decode, 150, 9, 16, // Opcode: MOVM32om
/* 8970 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 8996
/* 8975 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8978 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8987
/* 8983 */    MCD::OPC_Decode, 145, 9, 17, // Opcode: MOVM32mj
/* 8987 */    MCD::OPC_FilterValue, 1, 132, 24, 0, // Skip to: 15268
/* 8992 */    MCD::OPC_Decode, 147, 9, 17, // Opcode: MOVM32mo
/* 8996 */    MCD::OPC_FilterValue, 7, 123, 24, 0, // Skip to: 15268
/* 9001 */    MCD::OPC_CheckField, 3, 1, 0, 116, 24, 0, // Skip to: 15268
/* 9008 */    MCD::OPC_Decode, 205, 5, 178, 1, // Opcode: JMP32j
/* 9013 */    MCD::OPC_FilterValue, 14, 187, 0, 0, // Skip to: 9205
/* 9018 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 9021 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 9059
/* 9026 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9029 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 9044
/* 9034 */    MCD::OPC_CheckPredicate, 1, 85, 24, 0, // Skip to: 15268
/* 9039 */    MCD::OPC_Decode, 158, 6, 190, 1, // Opcode: MOV16es
/* 9044 */    MCD::OPC_FilterValue, 1, 75, 24, 0, // Skip to: 15268
/* 9049 */    MCD::OPC_CheckPredicate, 1, 70, 24, 0, // Skip to: 15268
/* 9054 */    MCD::OPC_Decode, 228, 6, 192, 1, // Opcode: MOV16ps
/* 9059 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 9097
/* 9064 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9067 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 9082
/* 9072 */    MCD::OPC_CheckPredicate, 1, 47, 24, 0, // Skip to: 15268
/* 9077 */    MCD::OPC_Decode, 147, 6, 191, 1, // Opcode: MOV16ec
/* 9082 */    MCD::OPC_FilterValue, 1, 37, 24, 0, // Skip to: 15268
/* 9087 */    MCD::OPC_CheckPredicate, 1, 32, 24, 0, // Skip to: 15268
/* 9092 */    MCD::OPC_Decode, 217, 6, 193, 1, // Opcode: MOV16pc
/* 9097 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 9125
/* 9102 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9105 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 9115
/* 9110 */    MCD::OPC_Decode, 254, 5, 187, 1, // Opcode: MOV16ce
/* 9115 */    MCD::OPC_FilterValue, 1, 4, 24, 0, // Skip to: 15268
/* 9120 */    MCD::OPC_Decode, 131, 6, 187, 1, // Opcode: MOV16cp
/* 9125 */    MCD::OPC_FilterValue, 3, 23, 0, 0, // Skip to: 9153
/* 9130 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9133 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 9143
/* 9138 */    MCD::OPC_Decode, 136, 7, 188, 1, // Opcode: MOV16se
/* 9143 */    MCD::OPC_FilterValue, 1, 232, 23, 0, // Skip to: 15268
/* 9148 */    MCD::OPC_Decode, 141, 7, 188, 1, // Opcode: MOV16sp
/* 9153 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 9179
/* 9158 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9161 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9170
/* 9166 */    MCD::OPC_Decode, 138, 9, 16, // Opcode: MOVM32em
/* 9170 */    MCD::OPC_FilterValue, 1, 205, 23, 0, // Skip to: 15268
/* 9175 */    MCD::OPC_Decode, 151, 9, 18, // Opcode: MOVM32pm
/* 9179 */    MCD::OPC_FilterValue, 6, 196, 23, 0, // Skip to: 15268
/* 9184 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9187 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 9196
/* 9192 */    MCD::OPC_Decode, 143, 9, 17, // Opcode: MOVM32me
/* 9196 */    MCD::OPC_FilterValue, 1, 179, 23, 0, // Skip to: 15268
/* 9201 */    MCD::OPC_Decode, 148, 9, 19, // Opcode: MOVM32mp
/* 9205 */    MCD::OPC_FilterValue, 15, 216, 1, 0, // Skip to: 9682
/* 9210 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 9213 */    MCD::OPC_FilterValue, 0, 85, 0, 0, // Skip to: 9303
/* 9218 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9221 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 9243
/* 9226 */    MCD::OPC_CheckPredicate, 1, 149, 23, 0, // Skip to: 15268
/* 9231 */    MCD::OPC_CheckField, 24, 4, 8, 142, 23, 0, // Skip to: 15268
/* 9238 */    MCD::OPC_Decode, 172, 6, 194, 1, // Opcode: MOV16fs
/* 9243 */    MCD::OPC_FilterValue, 1, 132, 23, 0, // Skip to: 15268
/* 9248 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9251 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 9266
/* 9256 */    MCD::OPC_CheckPredicate, 1, 119, 23, 0, // Skip to: 15268
/* 9261 */    MCD::OPC_Decode, 251, 5, 195, 1, // Opcode: MOV16bs
/* 9266 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 9281
/* 9271 */    MCD::OPC_CheckPredicate, 1, 104, 23, 0, // Skip to: 15268
/* 9276 */    MCD::OPC_Decode, 242, 6, 196, 1, // Opcode: MOV16qs
/* 9281 */    MCD::OPC_FilterValue, 3, 94, 23, 0, // Skip to: 15268
/* 9286 */    MCD::OPC_CheckPredicate, 1, 89, 23, 0, // Skip to: 15268
/* 9291 */    MCD::OPC_CheckField, 24, 4, 8, 82, 23, 0, // Skip to: 15268
/* 9298 */    MCD::OPC_Decode, 200, 6, 197, 1, // Opcode: MOV16ks
/* 9303 */    MCD::OPC_FilterValue, 1, 85, 0, 0, // Skip to: 9393
/* 9308 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9311 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 9333
/* 9316 */    MCD::OPC_CheckPredicate, 1, 59, 23, 0, // Skip to: 15268
/* 9321 */    MCD::OPC_CheckField, 24, 4, 8, 52, 23, 0, // Skip to: 15268
/* 9328 */    MCD::OPC_Decode, 161, 6, 198, 1, // Opcode: MOV16fc
/* 9333 */    MCD::OPC_FilterValue, 1, 42, 23, 0, // Skip to: 15268
/* 9338 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9341 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 9356
/* 9346 */    MCD::OPC_CheckPredicate, 1, 29, 23, 0, // Skip to: 15268
/* 9351 */    MCD::OPC_Decode, 240, 5, 199, 1, // Opcode: MOV16bc
/* 9356 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 9371
/* 9361 */    MCD::OPC_CheckPredicate, 1, 14, 23, 0, // Skip to: 15268
/* 9366 */    MCD::OPC_Decode, 231, 6, 200, 1, // Opcode: MOV16qc
/* 9371 */    MCD::OPC_FilterValue, 3, 4, 23, 0, // Skip to: 15268
/* 9376 */    MCD::OPC_CheckPredicate, 1, 255, 22, 0, // Skip to: 15268
/* 9381 */    MCD::OPC_CheckField, 24, 4, 8, 248, 22, 0, // Skip to: 15268
/* 9388 */    MCD::OPC_Decode, 189, 6, 201, 1, // Opcode: MOV16kc
/* 9393 */    MCD::OPC_FilterValue, 2, 65, 0, 0, // Skip to: 9463
/* 9398 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9401 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9418
/* 9406 */    MCD::OPC_CheckField, 24, 4, 8, 223, 22, 0, // Skip to: 15268
/* 9413 */    MCD::OPC_Decode, 255, 5, 187, 1, // Opcode: MOV16cf
/* 9418 */    MCD::OPC_FilterValue, 1, 213, 22, 0, // Skip to: 15268
/* 9423 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9426 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 9436
/* 9431 */    MCD::OPC_Decode, 252, 5, 187, 1, // Opcode: MOV16cb
/* 9436 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9446
/* 9441 */    MCD::OPC_Decode, 132, 6, 187, 1, // Opcode: MOV16cq
/* 9446 */    MCD::OPC_FilterValue, 3, 185, 22, 0, // Skip to: 15268
/* 9451 */    MCD::OPC_CheckField, 24, 4, 8, 178, 22, 0, // Skip to: 15268
/* 9458 */    MCD::OPC_Decode, 129, 6, 187, 1, // Opcode: MOV16ck
/* 9463 */    MCD::OPC_FilterValue, 3, 65, 0, 0, // Skip to: 9533
/* 9468 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9471 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9488
/* 9476 */    MCD::OPC_CheckField, 24, 4, 8, 153, 22, 0, // Skip to: 15268
/* 9483 */    MCD::OPC_Decode, 137, 7, 188, 1, // Opcode: MOV16sf
/* 9488 */    MCD::OPC_FilterValue, 1, 143, 22, 0, // Skip to: 15268
/* 9493 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9496 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 9506
/* 9501 */    MCD::OPC_Decode, 134, 7, 188, 1, // Opcode: MOV16sb
/* 9506 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9516
/* 9511 */    MCD::OPC_Decode, 142, 7, 188, 1, // Opcode: MOV16sq
/* 9516 */    MCD::OPC_FilterValue, 3, 115, 22, 0, // Skip to: 15268
/* 9521 */    MCD::OPC_CheckField, 24, 4, 8, 108, 22, 0, // Skip to: 15268
/* 9528 */    MCD::OPC_Decode, 139, 7, 188, 1, // Opcode: MOV16sk
/* 9533 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 9599
/* 9538 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9541 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 9557
/* 9546 */    MCD::OPC_CheckField, 40, 4, 8, 83, 22, 0, // Skip to: 15268
/* 9553 */    MCD::OPC_Decode, 139, 9, 20, // Opcode: MOVM32fm
/* 9557 */    MCD::OPC_FilterValue, 1, 74, 22, 0, // Skip to: 15268
/* 9562 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9565 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9574
/* 9570 */    MCD::OPC_Decode, 137, 9, 99, // Opcode: MOVM32bm
/* 9574 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9583
/* 9579 */    MCD::OPC_Decode, 152, 9, 100, // Opcode: MOVM32qm
/* 9583 */    MCD::OPC_FilterValue, 3, 48, 22, 0, // Skip to: 15268
/* 9588 */    MCD::OPC_CheckField, 40, 4, 8, 41, 22, 0, // Skip to: 15268
/* 9595 */    MCD::OPC_Decode, 141, 9, 101, // Opcode: MOVM32km
/* 9599 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 9616
/* 9604 */    MCD::OPC_CheckField, 0, 4, 12, 25, 22, 0, // Skip to: 15268
/* 9611 */    MCD::OPC_Decode, 204, 5, 179, 1, // Opcode: ILLEGAL
/* 9616 */    MCD::OPC_FilterValue, 6, 15, 22, 0, // Skip to: 15268
/* 9621 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9624 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 9640
/* 9629 */    MCD::OPC_CheckField, 40, 4, 8, 0, 22, 0, // Skip to: 15268
/* 9636 */    MCD::OPC_Decode, 144, 9, 21, // Opcode: MOVM32mf
/* 9640 */    MCD::OPC_FilterValue, 1, 247, 21, 0, // Skip to: 15268
/* 9645 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9648 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9657
/* 9653 */    MCD::OPC_Decode, 142, 9, 22, // Opcode: MOVM32mb
/* 9657 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9666
/* 9662 */    MCD::OPC_Decode, 149, 9, 23, // Opcode: MOVM32mq
/* 9666 */    MCD::OPC_FilterValue, 3, 221, 21, 0, // Skip to: 15268
/* 9671 */    MCD::OPC_CheckField, 40, 4, 8, 214, 21, 0, // Skip to: 15268
/* 9678 */    MCD::OPC_Decode, 146, 9, 24, // Opcode: MOVM32mk
/* 9682 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 9698
/* 9687 */    MCD::OPC_CheckField, 3, 1, 1, 198, 21, 0, // Skip to: 15268
/* 9694 */    MCD::OPC_Decode, 209, 5, 64, // Opcode: LEA32p
/* 9698 */    MCD::OPC_FilterValue, 31, 189, 21, 0, // Skip to: 15268
/* 9703 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9706 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 9722
/* 9711 */    MCD::OPC_CheckField, 24, 4, 8, 174, 21, 0, // Skip to: 15268
/* 9718 */    MCD::OPC_Decode, 207, 5, 65, // Opcode: LEA32f
/* 9722 */    MCD::OPC_FilterValue, 1, 165, 21, 0, // Skip to: 15268
/* 9727 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9730 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9739
/* 9735 */    MCD::OPC_Decode, 206, 5, 66, // Opcode: LEA32b
/* 9739 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9748
/* 9744 */    MCD::OPC_Decode, 210, 5, 67, // Opcode: LEA32q
/* 9748 */    MCD::OPC_FilterValue, 3, 139, 21, 0, // Skip to: 15268
/* 9753 */    MCD::OPC_CheckField, 24, 4, 8, 132, 21, 0, // Skip to: 15268
/* 9760 */    MCD::OPC_Decode, 208, 5, 68, // Opcode: LEA32k
/* 9764 */    MCD::OPC_FilterValue, 5, 203, 2, 0, // Skip to: 10484
/* 9769 */    MCD::OPC_ExtractField, 4, 8,  // Inst{11-4} ...
/* 9772 */    MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 9782
/* 9777 */    MCD::OPC_Decode, 235, 9, 202, 1, // Opcode: SETd8t
/* 9782 */    MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 9799
/* 9787 */    MCD::OPC_CheckField, 3, 1, 0, 98, 21, 0, // Skip to: 15268
/* 9794 */    MCD::OPC_Decode, 251, 9, 178, 1, // Opcode: SETj8t
/* 9799 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 9815
/* 9804 */    MCD::OPC_CheckField, 3, 1, 1, 81, 21, 0, // Skip to: 15268
/* 9811 */    MCD::OPC_Decode, 139, 10, 17, // Opcode: SETp8t
/* 9815 */    MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 9825
/* 9820 */    MCD::OPC_Decode, 225, 9, 202, 1, // Opcode: SETd8f
/* 9825 */    MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 9842
/* 9830 */    MCD::OPC_CheckField, 3, 1, 0, 55, 21, 0, // Skip to: 15268
/* 9837 */    MCD::OPC_Decode, 241, 9, 178, 1, // Opcode: SETj8f
/* 9842 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 9858
/* 9847 */    MCD::OPC_CheckField, 3, 1, 1, 38, 21, 0, // Skip to: 15268
/* 9854 */    MCD::OPC_Decode, 129, 10, 17, // Opcode: SETp8f
/* 9858 */    MCD::OPC_FilterValue, 44, 5, 0, 0, // Skip to: 9868
/* 9863 */    MCD::OPC_Decode, 228, 9, 202, 1, // Opcode: SETd8hi
/* 9868 */    MCD::OPC_FilterValue, 45, 12, 0, 0, // Skip to: 9885
/* 9873 */    MCD::OPC_CheckField, 3, 1, 0, 12, 21, 0, // Skip to: 15268
/* 9880 */    MCD::OPC_Decode, 244, 9, 178, 1, // Opcode: SETj8hi
/* 9885 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 9901
/* 9890 */    MCD::OPC_CheckField, 3, 1, 1, 251, 20, 0, // Skip to: 15268
/* 9897 */    MCD::OPC_Decode, 132, 10, 17, // Opcode: SETp8hi
/* 9901 */    MCD::OPC_FilterValue, 60, 5, 0, 0, // Skip to: 9911
/* 9906 */    MCD::OPC_Decode, 230, 9, 202, 1, // Opcode: SETd8ls
/* 9911 */    MCD::OPC_FilterValue, 61, 12, 0, 0, // Skip to: 9928
/* 9916 */    MCD::OPC_CheckField, 3, 1, 0, 225, 20, 0, // Skip to: 15268
/* 9923 */    MCD::OPC_Decode, 246, 9, 178, 1, // Opcode: SETj8ls
/* 9928 */    MCD::OPC_FilterValue, 62, 11, 0, 0, // Skip to: 9944
/* 9933 */    MCD::OPC_CheckField, 3, 1, 1, 208, 20, 0, // Skip to: 15268
/* 9940 */    MCD::OPC_Decode, 134, 10, 17, // Opcode: SETp8ls
/* 9944 */    MCD::OPC_FilterValue, 76, 5, 0, 0, // Skip to: 9954
/* 9949 */    MCD::OPC_Decode, 222, 9, 202, 1, // Opcode: SETd8cc
/* 9954 */    MCD::OPC_FilterValue, 77, 12, 0, 0, // Skip to: 9971
/* 9959 */    MCD::OPC_CheckField, 3, 1, 0, 182, 20, 0, // Skip to: 15268
/* 9966 */    MCD::OPC_Decode, 238, 9, 178, 1, // Opcode: SETj8cc
/* 9971 */    MCD::OPC_FilterValue, 78, 11, 0, 0, // Skip to: 9987
/* 9976 */    MCD::OPC_CheckField, 3, 1, 1, 165, 20, 0, // Skip to: 15268
/* 9983 */    MCD::OPC_Decode, 254, 9, 17, // Opcode: SETp8cc
/* 9987 */    MCD::OPC_FilterValue, 92, 5, 0, 0, // Skip to: 9997
/* 9992 */    MCD::OPC_Decode, 223, 9, 202, 1, // Opcode: SETd8cs
/* 9997 */    MCD::OPC_FilterValue, 93, 12, 0, 0, // Skip to: 10014
/* 10002 */   MCD::OPC_CheckField, 3, 1, 0, 139, 20, 0, // Skip to: 15268
/* 10009 */   MCD::OPC_Decode, 239, 9, 178, 1, // Opcode: SETj8cs
/* 10014 */   MCD::OPC_FilterValue, 94, 11, 0, 0, // Skip to: 10030
/* 10019 */   MCD::OPC_CheckField, 3, 1, 1, 122, 20, 0, // Skip to: 15268
/* 10026 */   MCD::OPC_Decode, 255, 9, 17, // Opcode: SETp8cs
/* 10030 */   MCD::OPC_FilterValue, 108, 5, 0, 0, // Skip to: 10040
/* 10035 */   MCD::OPC_Decode, 233, 9, 202, 1, // Opcode: SETd8ne
/* 10040 */   MCD::OPC_FilterValue, 109, 12, 0, 0, // Skip to: 10057
/* 10045 */   MCD::OPC_CheckField, 3, 1, 0, 96, 20, 0, // Skip to: 15268
/* 10052 */   MCD::OPC_Decode, 249, 9, 178, 1, // Opcode: SETj8ne
/* 10057 */   MCD::OPC_FilterValue, 110, 11, 0, 0, // Skip to: 10073
/* 10062 */   MCD::OPC_CheckField, 3, 1, 1, 79, 20, 0, // Skip to: 15268
/* 10069 */   MCD::OPC_Decode, 137, 10, 17, // Opcode: SETp8ne
/* 10073 */   MCD::OPC_FilterValue, 124, 5, 0, 0, // Skip to: 10083
/* 10078 */   MCD::OPC_Decode, 224, 9, 202, 1, // Opcode: SETd8eq
/* 10083 */   MCD::OPC_FilterValue, 125, 12, 0, 0, // Skip to: 10100
/* 10088 */   MCD::OPC_CheckField, 3, 1, 0, 53, 20, 0, // Skip to: 15268
/* 10095 */   MCD::OPC_Decode, 240, 9, 178, 1, // Opcode: SETj8eq
/* 10100 */   MCD::OPC_FilterValue, 126, 11, 0, 0, // Skip to: 10116
/* 10105 */   MCD::OPC_CheckField, 3, 1, 1, 36, 20, 0, // Skip to: 15268
/* 10112 */   MCD::OPC_Decode, 128, 10, 17, // Opcode: SETp8eq
/* 10116 */   MCD::OPC_FilterValue, 140, 1, 5, 0, 0, // Skip to: 10127
/* 10122 */   MCD::OPC_Decode, 236, 9, 202, 1, // Opcode: SETd8vc
/* 10127 */   MCD::OPC_FilterValue, 141, 1, 12, 0, 0, // Skip to: 10145
/* 10133 */   MCD::OPC_CheckField, 3, 1, 0, 8, 20, 0, // Skip to: 15268
/* 10140 */   MCD::OPC_Decode, 252, 9, 178, 1, // Opcode: SETj8vc
/* 10145 */   MCD::OPC_FilterValue, 142, 1, 11, 0, 0, // Skip to: 10162
/* 10151 */   MCD::OPC_CheckField, 3, 1, 1, 246, 19, 0, // Skip to: 15268
/* 10158 */   MCD::OPC_Decode, 140, 10, 17, // Opcode: SETp8vc
/* 10162 */   MCD::OPC_FilterValue, 156, 1, 5, 0, 0, // Skip to: 10173
/* 10168 */   MCD::OPC_Decode, 237, 9, 202, 1, // Opcode: SETd8vs
/* 10173 */   MCD::OPC_FilterValue, 157, 1, 12, 0, 0, // Skip to: 10191
/* 10179 */   MCD::OPC_CheckField, 3, 1, 0, 218, 19, 0, // Skip to: 15268
/* 10186 */   MCD::OPC_Decode, 253, 9, 178, 1, // Opcode: SETj8vs
/* 10191 */   MCD::OPC_FilterValue, 158, 1, 11, 0, 0, // Skip to: 10208
/* 10197 */   MCD::OPC_CheckField, 3, 1, 1, 200, 19, 0, // Skip to: 15268
/* 10204 */   MCD::OPC_Decode, 141, 10, 17, // Opcode: SETp8vs
/* 10208 */   MCD::OPC_FilterValue, 172, 1, 5, 0, 0, // Skip to: 10219
/* 10214 */   MCD::OPC_Decode, 234, 9, 202, 1, // Opcode: SETd8pl
/* 10219 */   MCD::OPC_FilterValue, 173, 1, 12, 0, 0, // Skip to: 10237
/* 10225 */   MCD::OPC_CheckField, 3, 1, 0, 172, 19, 0, // Skip to: 15268
/* 10232 */   MCD::OPC_Decode, 250, 9, 178, 1, // Opcode: SETj8pl
/* 10237 */   MCD::OPC_FilterValue, 174, 1, 11, 0, 0, // Skip to: 10254
/* 10243 */   MCD::OPC_CheckField, 3, 1, 1, 154, 19, 0, // Skip to: 15268
/* 10250 */   MCD::OPC_Decode, 138, 10, 17, // Opcode: SETp8pl
/* 10254 */   MCD::OPC_FilterValue, 188, 1, 5, 0, 0, // Skip to: 10265
/* 10260 */   MCD::OPC_Decode, 232, 9, 202, 1, // Opcode: SETd8mi
/* 10265 */   MCD::OPC_FilterValue, 189, 1, 12, 0, 0, // Skip to: 10283
/* 10271 */   MCD::OPC_CheckField, 3, 1, 0, 126, 19, 0, // Skip to: 15268
/* 10278 */   MCD::OPC_Decode, 248, 9, 178, 1, // Opcode: SETj8mi
/* 10283 */   MCD::OPC_FilterValue, 190, 1, 11, 0, 0, // Skip to: 10300
/* 10289 */   MCD::OPC_CheckField, 3, 1, 1, 108, 19, 0, // Skip to: 15268
/* 10296 */   MCD::OPC_Decode, 136, 10, 17, // Opcode: SETp8mi
/* 10300 */   MCD::OPC_FilterValue, 204, 1, 5, 0, 0, // Skip to: 10311
/* 10306 */   MCD::OPC_Decode, 226, 9, 202, 1, // Opcode: SETd8ge
/* 10311 */   MCD::OPC_FilterValue, 205, 1, 12, 0, 0, // Skip to: 10329
/* 10317 */   MCD::OPC_CheckField, 3, 1, 0, 80, 19, 0, // Skip to: 15268
/* 10324 */   MCD::OPC_Decode, 242, 9, 178, 1, // Opcode: SETj8ge
/* 10329 */   MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 10346
/* 10335 */   MCD::OPC_CheckField, 3, 1, 1, 62, 19, 0, // Skip to: 15268
/* 10342 */   MCD::OPC_Decode, 130, 10, 17, // Opcode: SETp8ge
/* 10346 */   MCD::OPC_FilterValue, 220, 1, 5, 0, 0, // Skip to: 10357
/* 10352 */   MCD::OPC_Decode, 231, 9, 202, 1, // Opcode: SETd8lt
/* 10357 */   MCD::OPC_FilterValue, 221, 1, 12, 0, 0, // Skip to: 10375
/* 10363 */   MCD::OPC_CheckField, 3, 1, 0, 34, 19, 0, // Skip to: 15268
/* 10370 */   MCD::OPC_Decode, 247, 9, 178, 1, // Opcode: SETj8lt
/* 10375 */   MCD::OPC_FilterValue, 222, 1, 11, 0, 0, // Skip to: 10392
/* 10381 */   MCD::OPC_CheckField, 3, 1, 1, 16, 19, 0, // Skip to: 15268
/* 10388 */   MCD::OPC_Decode, 135, 10, 17, // Opcode: SETp8lt
/* 10392 */   MCD::OPC_FilterValue, 236, 1, 5, 0, 0, // Skip to: 10403
/* 10398 */   MCD::OPC_Decode, 227, 9, 202, 1, // Opcode: SETd8gt
/* 10403 */   MCD::OPC_FilterValue, 237, 1, 12, 0, 0, // Skip to: 10421
/* 10409 */   MCD::OPC_CheckField, 3, 1, 0, 244, 18, 0, // Skip to: 15268
/* 10416 */   MCD::OPC_Decode, 243, 9, 178, 1, // Opcode: SETj8gt
/* 10421 */   MCD::OPC_FilterValue, 238, 1, 11, 0, 0, // Skip to: 10438
/* 10427 */   MCD::OPC_CheckField, 3, 1, 1, 226, 18, 0, // Skip to: 15268
/* 10434 */   MCD::OPC_Decode, 131, 10, 17, // Opcode: SETp8gt
/* 10438 */   MCD::OPC_FilterValue, 252, 1, 5, 0, 0, // Skip to: 10449
/* 10444 */   MCD::OPC_Decode, 229, 9, 202, 1, // Opcode: SETd8le
/* 10449 */   MCD::OPC_FilterValue, 253, 1, 12, 0, 0, // Skip to: 10467
/* 10455 */   MCD::OPC_CheckField, 3, 1, 0, 198, 18, 0, // Skip to: 15268
/* 10462 */   MCD::OPC_Decode, 245, 9, 178, 1, // Opcode: SETj8le
/* 10467 */   MCD::OPC_FilterValue, 254, 1, 187, 18, 0, // Skip to: 15268
/* 10473 */   MCD::OPC_CheckField, 3, 1, 1, 180, 18, 0, // Skip to: 15268
/* 10480 */   MCD::OPC_Decode, 133, 10, 17, // Opcode: SETp8le
/* 10484 */   MCD::OPC_FilterValue, 6, 115, 2, 0, // Skip to: 11116
/* 10489 */   MCD::OPC_ExtractField, 8, 4,  // Inst{11-8} ...
/* 10492 */   MCD::OPC_FilterValue, 0, 34, 0, 0, // Skip to: 10531
/* 10497 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10500 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10510
/* 10505 */   MCD::OPC_Decode, 132, 4, 183, 1, // Opcode: BRA16
/* 10510 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10526
/* 10516 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10526
/* 10521 */   MCD::OPC_Decode, 133, 4, 182, 1, // Opcode: BRA32
/* 10526 */   MCD::OPC_Decode, 134, 4, 203, 1, // Opcode: BRA8
/* 10531 */   MCD::OPC_FilterValue, 1, 34, 0, 0, // Skip to: 10570
/* 10536 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10539 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10549
/* 10544 */   MCD::OPC_Decode, 147, 4, 183, 1, // Opcode: BSR16
/* 10549 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10565
/* 10555 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10565
/* 10560 */   MCD::OPC_Decode, 148, 4, 182, 1, // Opcode: BSR32
/* 10565 */   MCD::OPC_Decode, 149, 4, 203, 1, // Opcode: BSR8
/* 10570 */   MCD::OPC_FilterValue, 2, 34, 0, 0, // Skip to: 10609
/* 10575 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10578 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10588
/* 10583 */   MCD::OPC_Decode, 181, 4, 183, 1, // Opcode: Bhi16
/* 10588 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10604
/* 10594 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10604
/* 10599 */   MCD::OPC_Decode, 182, 4, 204, 1, // Opcode: Bhi32
/* 10604 */   MCD::OPC_Decode, 183, 4, 203, 1, // Opcode: Bhi8
/* 10609 */   MCD::OPC_FilterValue, 3, 34, 0, 0, // Skip to: 10648
/* 10614 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10617 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10627
/* 10622 */   MCD::OPC_Decode, 187, 4, 183, 1, // Opcode: Bls16
/* 10627 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10643
/* 10633 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10643
/* 10638 */   MCD::OPC_Decode, 188, 4, 204, 1, // Opcode: Bls32
/* 10643 */   MCD::OPC_Decode, 189, 4, 203, 1, // Opcode: Bls8
/* 10648 */   MCD::OPC_FilterValue, 4, 34, 0, 0, // Skip to: 10687
/* 10653 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10656 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10666
/* 10661 */   MCD::OPC_Decode, 166, 4, 183, 1, // Opcode: Bcc16
/* 10666 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10682
/* 10672 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10682
/* 10677 */   MCD::OPC_Decode, 167, 4, 204, 1, // Opcode: Bcc32
/* 10682 */   MCD::OPC_Decode, 168, 4, 203, 1, // Opcode: Bcc8
/* 10687 */   MCD::OPC_FilterValue, 5, 34, 0, 0, // Skip to: 10726
/* 10692 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10695 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10705
/* 10700 */   MCD::OPC_Decode, 169, 4, 183, 1, // Opcode: Bcs16
/* 10705 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10721
/* 10711 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10721
/* 10716 */   MCD::OPC_Decode, 170, 4, 204, 1, // Opcode: Bcs32
/* 10721 */   MCD::OPC_Decode, 171, 4, 203, 1, // Opcode: Bcs8
/* 10726 */   MCD::OPC_FilterValue, 6, 34, 0, 0, // Skip to: 10765
/* 10731 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10734 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10744
/* 10739 */   MCD::OPC_Decode, 196, 4, 183, 1, // Opcode: Bne16
/* 10744 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10760
/* 10750 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10760
/* 10755 */   MCD::OPC_Decode, 197, 4, 204, 1, // Opcode: Bne32
/* 10760 */   MCD::OPC_Decode, 198, 4, 203, 1, // Opcode: Bne8
/* 10765 */   MCD::OPC_FilterValue, 7, 34, 0, 0, // Skip to: 10804
/* 10770 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10773 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10783
/* 10778 */   MCD::OPC_Decode, 172, 4, 183, 1, // Opcode: Beq16
/* 10783 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10799
/* 10789 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10799
/* 10794 */   MCD::OPC_Decode, 173, 4, 204, 1, // Opcode: Beq32
/* 10799 */   MCD::OPC_Decode, 174, 4, 203, 1, // Opcode: Beq8
/* 10804 */   MCD::OPC_FilterValue, 8, 34, 0, 0, // Skip to: 10843
/* 10809 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10812 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10822
/* 10817 */   MCD::OPC_Decode, 202, 4, 183, 1, // Opcode: Bvc16
/* 10822 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10838
/* 10828 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10838
/* 10833 */   MCD::OPC_Decode, 203, 4, 204, 1, // Opcode: Bvc32
/* 10838 */   MCD::OPC_Decode, 204, 4, 203, 1, // Opcode: Bvc8
/* 10843 */   MCD::OPC_FilterValue, 9, 34, 0, 0, // Skip to: 10882
/* 10848 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10851 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10861
/* 10856 */   MCD::OPC_Decode, 205, 4, 183, 1, // Opcode: Bvs16
/* 10861 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10877
/* 10867 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10877
/* 10872 */   MCD::OPC_Decode, 206, 4, 204, 1, // Opcode: Bvs32
/* 10877 */   MCD::OPC_Decode, 207, 4, 203, 1, // Opcode: Bvs8
/* 10882 */   MCD::OPC_FilterValue, 10, 34, 0, 0, // Skip to: 10921
/* 10887 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10890 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10900
/* 10895 */   MCD::OPC_Decode, 199, 4, 183, 1, // Opcode: Bpl16
/* 10900 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10916
/* 10906 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10916
/* 10911 */   MCD::OPC_Decode, 200, 4, 204, 1, // Opcode: Bpl32
/* 10916 */   MCD::OPC_Decode, 201, 4, 203, 1, // Opcode: Bpl8
/* 10921 */   MCD::OPC_FilterValue, 11, 34, 0, 0, // Skip to: 10960
/* 10926 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10929 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10939
/* 10934 */   MCD::OPC_Decode, 193, 4, 183, 1, // Opcode: Bmi16
/* 10939 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10955
/* 10945 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10955
/* 10950 */   MCD::OPC_Decode, 194, 4, 204, 1, // Opcode: Bmi32
/* 10955 */   MCD::OPC_Decode, 195, 4, 203, 1, // Opcode: Bmi8
/* 10960 */   MCD::OPC_FilterValue, 12, 34, 0, 0, // Skip to: 10999
/* 10965 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 10968 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10978
/* 10973 */   MCD::OPC_Decode, 175, 4, 183, 1, // Opcode: Bge16
/* 10978 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 10994
/* 10984 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 10994
/* 10989 */   MCD::OPC_Decode, 176, 4, 204, 1, // Opcode: Bge32
/* 10994 */   MCD::OPC_Decode, 177, 4, 203, 1, // Opcode: Bge8
/* 10999 */   MCD::OPC_FilterValue, 13, 34, 0, 0, // Skip to: 11038
/* 11004 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 11007 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 11017
/* 11012 */   MCD::OPC_Decode, 190, 4, 183, 1, // Opcode: Blt16
/* 11017 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 11033
/* 11023 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 11033
/* 11028 */   MCD::OPC_Decode, 191, 4, 204, 1, // Opcode: Blt32
/* 11033 */   MCD::OPC_Decode, 192, 4, 203, 1, // Opcode: Blt8
/* 11038 */   MCD::OPC_FilterValue, 14, 34, 0, 0, // Skip to: 11077
/* 11043 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 11046 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 11056
/* 11051 */   MCD::OPC_Decode, 178, 4, 183, 1, // Opcode: Bgt16
/* 11056 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 11072
/* 11062 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 11072
/* 11067 */   MCD::OPC_Decode, 179, 4, 204, 1, // Opcode: Bgt32
/* 11072 */   MCD::OPC_Decode, 180, 4, 203, 1, // Opcode: Bgt8
/* 11077 */   MCD::OPC_FilterValue, 15, 90, 16, 0, // Skip to: 15268
/* 11082 */   MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 11085 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 11095
/* 11090 */   MCD::OPC_Decode, 184, 4, 183, 1, // Opcode: Ble16
/* 11095 */   MCD::OPC_FilterValue, 255, 1, 10, 0, 0, // Skip to: 11111
/* 11101 */   MCD::OPC_CheckPredicate, 0, 5, 0, 0, // Skip to: 11111
/* 11106 */   MCD::OPC_Decode, 185, 4, 204, 1, // Opcode: Ble32
/* 11111 */   MCD::OPC_Decode, 186, 4, 203, 1, // Opcode: Ble8
/* 11116 */   MCD::OPC_FilterValue, 7, 12, 0, 0, // Skip to: 11133
/* 11121 */   MCD::OPC_CheckField, 8, 1, 0, 44, 16, 0, // Skip to: 15268
/* 11128 */   MCD::OPC_Decode, 153, 9, 205, 1, // Opcode: MOVQ
/* 11133 */   MCD::OPC_FilterValue, 8, 110, 2, 0, // Skip to: 11760
/* 11138 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11141 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11158
/* 11146 */   MCD::OPC_CheckField, 3, 1, 0, 19, 16, 0, // Skip to: 15268
/* 11153 */   MCD::OPC_Decode, 192, 9, 206, 1, // Opcode: OR8dd
/* 11158 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11175
/* 11163 */   MCD::OPC_CheckField, 3, 1, 0, 2, 16, 0, // Skip to: 15268
/* 11170 */   MCD::OPC_Decode, 195, 9, 207, 1, // Opcode: OR8dj
/* 11175 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11192
/* 11180 */   MCD::OPC_CheckField, 3, 1, 1, 241, 15, 0, // Skip to: 15268
/* 11187 */   MCD::OPC_Decode, 197, 9, 208, 1, // Opcode: OR8dp
/* 11192 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 11269
/* 11197 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11200 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11217
/* 11205 */   MCD::OPC_CheckField, 24, 4, 8, 216, 15, 0, // Skip to: 15268
/* 11212 */   MCD::OPC_Decode, 193, 9, 209, 1, // Opcode: OR8df
/* 11217 */   MCD::OPC_FilterValue, 1, 206, 15, 0, // Skip to: 15268
/* 11222 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11225 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11235
/* 11230 */   MCD::OPC_Decode, 198, 9, 210, 1, // Opcode: OR8dq
/* 11235 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11252
/* 11240 */   MCD::OPC_CheckField, 24, 4, 8, 181, 15, 0, // Skip to: 15268
/* 11247 */   MCD::OPC_Decode, 196, 9, 211, 1, // Opcode: OR8dk
/* 11252 */   MCD::OPC_FilterValue, 4, 171, 15, 0, // Skip to: 15268
/* 11257 */   MCD::OPC_CheckField, 24, 8, 0, 164, 15, 0, // Skip to: 15268
/* 11264 */   MCD::OPC_Decode, 194, 9, 212, 1, // Opcode: OR8di
/* 11269 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 11291
/* 11274 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11286
/* 11281 */   MCD::OPC_Decode, 164, 9, 213, 1, // Opcode: OR16dd
/* 11286 */   MCD::OPC_Decode, 171, 9, 214, 1, // Opcode: OR16dr
/* 11291 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11308
/* 11296 */   MCD::OPC_CheckField, 3, 1, 0, 125, 15, 0, // Skip to: 15268
/* 11303 */   MCD::OPC_Decode, 167, 9, 215, 1, // Opcode: OR16dj
/* 11308 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11325
/* 11313 */   MCD::OPC_CheckField, 3, 1, 1, 108, 15, 0, // Skip to: 15268
/* 11320 */   MCD::OPC_Decode, 169, 9, 216, 1, // Opcode: OR16dp
/* 11325 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11395
/* 11330 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11333 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11350
/* 11338 */   MCD::OPC_CheckField, 24, 4, 8, 83, 15, 0, // Skip to: 15268
/* 11345 */   MCD::OPC_Decode, 165, 9, 217, 1, // Opcode: OR16df
/* 11350 */   MCD::OPC_FilterValue, 1, 73, 15, 0, // Skip to: 15268
/* 11355 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11358 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11368
/* 11363 */   MCD::OPC_Decode, 170, 9, 218, 1, // Opcode: OR16dq
/* 11368 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11385
/* 11373 */   MCD::OPC_CheckField, 24, 4, 8, 48, 15, 0, // Skip to: 15268
/* 11380 */   MCD::OPC_Decode, 168, 9, 219, 1, // Opcode: OR16dk
/* 11385 */   MCD::OPC_FilterValue, 4, 38, 15, 0, // Skip to: 15268
/* 11390 */   MCD::OPC_Decode, 166, 9, 218, 1, // Opcode: OR16di
/* 11395 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11417
/* 11400 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11412
/* 11407 */   MCD::OPC_Decode, 178, 9, 220, 1, // Opcode: OR32dd
/* 11412 */   MCD::OPC_Decode, 185, 9, 221, 1, // Opcode: OR32dr
/* 11417 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11434
/* 11422 */   MCD::OPC_CheckField, 3, 1, 0, 255, 14, 0, // Skip to: 15268
/* 11429 */   MCD::OPC_Decode, 181, 9, 222, 1, // Opcode: OR32dj
/* 11434 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11451
/* 11439 */   MCD::OPC_CheckField, 3, 1, 1, 238, 14, 0, // Skip to: 15268
/* 11446 */   MCD::OPC_Decode, 183, 9, 223, 1, // Opcode: OR32dp
/* 11451 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11521
/* 11456 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11459 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11476
/* 11464 */   MCD::OPC_CheckField, 24, 4, 8, 213, 14, 0, // Skip to: 15268
/* 11471 */   MCD::OPC_Decode, 179, 9, 224, 1, // Opcode: OR32df
/* 11476 */   MCD::OPC_FilterValue, 1, 203, 14, 0, // Skip to: 15268
/* 11481 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11484 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11494
/* 11489 */   MCD::OPC_Decode, 184, 9, 225, 1, // Opcode: OR32dq
/* 11494 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11511
/* 11499 */   MCD::OPC_CheckField, 24, 4, 8, 178, 14, 0, // Skip to: 15268
/* 11506 */   MCD::OPC_Decode, 182, 9, 226, 1, // Opcode: OR32dk
/* 11511 */   MCD::OPC_FilterValue, 4, 168, 14, 0, // Skip to: 15268
/* 11516 */   MCD::OPC_Decode, 180, 9, 227, 1, // Opcode: OR32di
/* 11521 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 11538
/* 11526 */   MCD::OPC_CheckField, 3, 1, 0, 151, 14, 0, // Skip to: 15268
/* 11533 */   MCD::OPC_Decode, 205, 10, 228, 1, // Opcode: UDIVd32d16
/* 11538 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 11555
/* 11543 */   MCD::OPC_CheckField, 0, 4, 12, 134, 14, 0, // Skip to: 15268
/* 11550 */   MCD::OPC_Decode, 207, 10, 225, 1, // Opcode: UDIVd32i16
/* 11555 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11571
/* 11560 */   MCD::OPC_CheckField, 3, 1, 0, 117, 14, 0, // Skip to: 15268
/* 11567 */   MCD::OPC_Decode, 201, 9, 49, // Opcode: OR8jd
/* 11571 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 11587
/* 11576 */   MCD::OPC_CheckField, 3, 1, 1, 101, 14, 0, // Skip to: 15268
/* 11583 */   MCD::OPC_Decode, 203, 9, 50, // Opcode: OR8pd
/* 11587 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 11610
/* 11592 */   MCD::OPC_CheckField, 24, 4, 8, 85, 14, 0, // Skip to: 15268
/* 11599 */   MCD::OPC_CheckField, 3, 1, 0, 78, 14, 0, // Skip to: 15268
/* 11606 */   MCD::OPC_Decode, 199, 9, 51, // Opcode: OR8fd
/* 11610 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 11627
/* 11615 */   MCD::OPC_CheckField, 3, 1, 0, 62, 14, 0, // Skip to: 15268
/* 11622 */   MCD::OPC_Decode, 174, 9, 229, 1, // Opcode: OR16jd
/* 11627 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 11644
/* 11632 */   MCD::OPC_CheckField, 3, 1, 1, 45, 14, 0, // Skip to: 15268
/* 11639 */   MCD::OPC_Decode, 176, 9, 230, 1, // Opcode: OR16pd
/* 11644 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 11668
/* 11649 */   MCD::OPC_CheckField, 24, 4, 8, 28, 14, 0, // Skip to: 15268
/* 11656 */   MCD::OPC_CheckField, 3, 1, 0, 21, 14, 0, // Skip to: 15268
/* 11663 */   MCD::OPC_Decode, 172, 9, 231, 1, // Opcode: OR16fd
/* 11668 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 11685
/* 11673 */   MCD::OPC_CheckField, 3, 1, 0, 4, 14, 0, // Skip to: 15268
/* 11680 */   MCD::OPC_Decode, 188, 9, 232, 1, // Opcode: OR32jd
/* 11685 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 11702
/* 11690 */   MCD::OPC_CheckField, 3, 1, 1, 243, 13, 0, // Skip to: 15268
/* 11697 */   MCD::OPC_Decode, 190, 9, 233, 1, // Opcode: OR32pd
/* 11702 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 11726
/* 11707 */   MCD::OPC_CheckField, 24, 4, 8, 226, 13, 0, // Skip to: 15268
/* 11714 */   MCD::OPC_CheckField, 3, 1, 0, 219, 13, 0, // Skip to: 15268
/* 11721 */   MCD::OPC_Decode, 186, 9, 234, 1, // Opcode: OR32fd
/* 11726 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 11743
/* 11731 */   MCD::OPC_CheckField, 3, 1, 0, 202, 13, 0, // Skip to: 15268
/* 11738 */   MCD::OPC_Decode, 219, 9, 228, 1, // Opcode: SDIVd32d16
/* 11743 */   MCD::OPC_FilterValue, 31, 192, 13, 0, // Skip to: 15268
/* 11748 */   MCD::OPC_CheckField, 0, 4, 12, 185, 13, 0, // Skip to: 15268
/* 11755 */   MCD::OPC_Decode, 221, 9, 225, 1, // Opcode: SDIVd32i16
/* 11760 */   MCD::OPC_FilterValue, 9, 217, 2, 0, // Skip to: 12494
/* 11765 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11768 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11785
/* 11773 */   MCD::OPC_CheckField, 3, 1, 0, 160, 13, 0, // Skip to: 15268
/* 11780 */   MCD::OPC_Decode, 187, 10, 206, 1, // Opcode: SUB8dd
/* 11785 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11802
/* 11790 */   MCD::OPC_CheckField, 3, 1, 0, 143, 13, 0, // Skip to: 15268
/* 11797 */   MCD::OPC_Decode, 190, 10, 207, 1, // Opcode: SUB8dj
/* 11802 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11819
/* 11807 */   MCD::OPC_CheckField, 3, 1, 1, 126, 13, 0, // Skip to: 15268
/* 11814 */   MCD::OPC_Decode, 192, 10, 208, 1, // Opcode: SUB8dp
/* 11819 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 11896
/* 11824 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11827 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11844
/* 11832 */   MCD::OPC_CheckField, 24, 4, 8, 101, 13, 0, // Skip to: 15268
/* 11839 */   MCD::OPC_Decode, 188, 10, 209, 1, // Opcode: SUB8df
/* 11844 */   MCD::OPC_FilterValue, 1, 91, 13, 0, // Skip to: 15268
/* 11849 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11852 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11862
/* 11857 */   MCD::OPC_Decode, 193, 10, 210, 1, // Opcode: SUB8dq
/* 11862 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11879
/* 11867 */   MCD::OPC_CheckField, 24, 4, 8, 66, 13, 0, // Skip to: 15268
/* 11874 */   MCD::OPC_Decode, 191, 10, 211, 1, // Opcode: SUB8dk
/* 11879 */   MCD::OPC_FilterValue, 4, 56, 13, 0, // Skip to: 15268
/* 11884 */   MCD::OPC_CheckField, 24, 8, 0, 49, 13, 0, // Skip to: 15268
/* 11891 */   MCD::OPC_Decode, 189, 10, 212, 1, // Opcode: SUB8di
/* 11896 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 11918
/* 11901 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11913
/* 11908 */   MCD::OPC_Decode, 151, 10, 213, 1, // Opcode: SUB16dd
/* 11913 */   MCD::OPC_Decode, 158, 10, 214, 1, // Opcode: SUB16dr
/* 11918 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11935
/* 11923 */   MCD::OPC_CheckField, 3, 1, 0, 10, 13, 0, // Skip to: 15268
/* 11930 */   MCD::OPC_Decode, 154, 10, 215, 1, // Opcode: SUB16dj
/* 11935 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11952
/* 11940 */   MCD::OPC_CheckField, 3, 1, 1, 249, 12, 0, // Skip to: 15268
/* 11947 */   MCD::OPC_Decode, 156, 10, 216, 1, // Opcode: SUB16dp
/* 11952 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 12022
/* 11957 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11960 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11977
/* 11965 */   MCD::OPC_CheckField, 24, 4, 8, 224, 12, 0, // Skip to: 15268
/* 11972 */   MCD::OPC_Decode, 152, 10, 217, 1, // Opcode: SUB16df
/* 11977 */   MCD::OPC_FilterValue, 1, 214, 12, 0, // Skip to: 15268
/* 11982 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11985 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11995
/* 11990 */   MCD::OPC_Decode, 157, 10, 218, 1, // Opcode: SUB16dq
/* 11995 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12012
/* 12000 */   MCD::OPC_CheckField, 24, 4, 8, 189, 12, 0, // Skip to: 15268
/* 12007 */   MCD::OPC_Decode, 155, 10, 219, 1, // Opcode: SUB16dk
/* 12012 */   MCD::OPC_FilterValue, 4, 179, 12, 0, // Skip to: 15268
/* 12017 */   MCD::OPC_Decode, 153, 10, 218, 1, // Opcode: SUB16di
/* 12022 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 12044
/* 12027 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12039
/* 12034 */   MCD::OPC_Decode, 173, 10, 220, 1, // Opcode: SUB32dd
/* 12039 */   MCD::OPC_Decode, 180, 10, 221, 1, // Opcode: SUB32dr
/* 12044 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 12061
/* 12049 */   MCD::OPC_CheckField, 3, 1, 0, 140, 12, 0, // Skip to: 15268
/* 12056 */   MCD::OPC_Decode, 176, 10, 222, 1, // Opcode: SUB32dj
/* 12061 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 12078
/* 12066 */   MCD::OPC_CheckField, 3, 1, 1, 123, 12, 0, // Skip to: 15268
/* 12073 */   MCD::OPC_Decode, 178, 10, 223, 1, // Opcode: SUB32dp
/* 12078 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 12148
/* 12083 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12086 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12103
/* 12091 */   MCD::OPC_CheckField, 24, 4, 8, 98, 12, 0, // Skip to: 15268
/* 12098 */   MCD::OPC_Decode, 174, 10, 224, 1, // Opcode: SUB32df
/* 12103 */   MCD::OPC_FilterValue, 1, 88, 12, 0, // Skip to: 15268
/* 12108 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12111 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12121
/* 12116 */   MCD::OPC_Decode, 179, 10, 225, 1, // Opcode: SUB32dq
/* 12121 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12138
/* 12126 */   MCD::OPC_CheckField, 24, 4, 8, 63, 12, 0, // Skip to: 15268
/* 12133 */   MCD::OPC_Decode, 177, 10, 226, 1, // Opcode: SUB32dk
/* 12138 */   MCD::OPC_FilterValue, 4, 53, 12, 0, // Skip to: 15268
/* 12143 */   MCD::OPC_Decode, 175, 10, 227, 1, // Opcode: SUB32di
/* 12148 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 12165
/* 12153 */   MCD::OPC_CheckField, 3, 1, 0, 36, 12, 0, // Skip to: 15268
/* 12160 */   MCD::OPC_Decode, 202, 10, 206, 1, // Opcode: SUBX8dd
/* 12165 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 12181
/* 12170 */   MCD::OPC_CheckField, 3, 1, 0, 19, 12, 0, // Skip to: 15268
/* 12177 */   MCD::OPC_Decode, 196, 10, 49, // Opcode: SUB8jd
/* 12181 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 12197
/* 12186 */   MCD::OPC_CheckField, 3, 1, 1, 3, 12, 0, // Skip to: 15268
/* 12193 */   MCD::OPC_Decode, 198, 10, 50, // Opcode: SUB8pd
/* 12197 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 12220
/* 12202 */   MCD::OPC_CheckField, 24, 4, 8, 243, 11, 0, // Skip to: 15268
/* 12209 */   MCD::OPC_CheckField, 3, 1, 0, 236, 11, 0, // Skip to: 15268
/* 12216 */   MCD::OPC_Decode, 194, 10, 51, // Opcode: SUB8fd
/* 12220 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 12237
/* 12225 */   MCD::OPC_CheckField, 3, 1, 0, 220, 11, 0, // Skip to: 15268
/* 12232 */   MCD::OPC_Decode, 200, 10, 213, 1, // Opcode: SUBX16dd
/* 12237 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 12254
/* 12242 */   MCD::OPC_CheckField, 3, 1, 0, 203, 11, 0, // Skip to: 15268
/* 12249 */   MCD::OPC_Decode, 161, 10, 229, 1, // Opcode: SUB16jd
/* 12254 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 12271
/* 12259 */   MCD::OPC_CheckField, 3, 1, 1, 186, 11, 0, // Skip to: 15268
/* 12266 */   MCD::OPC_Decode, 163, 10, 230, 1, // Opcode: SUB16pd
/* 12271 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 12295
/* 12276 */   MCD::OPC_CheckField, 24, 4, 8, 169, 11, 0, // Skip to: 15268
/* 12283 */   MCD::OPC_CheckField, 3, 1, 0, 162, 11, 0, // Skip to: 15268
/* 12290 */   MCD::OPC_Decode, 159, 10, 231, 1, // Opcode: SUB16fd
/* 12295 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 12312
/* 12300 */   MCD::OPC_CheckField, 3, 1, 0, 145, 11, 0, // Skip to: 15268
/* 12307 */   MCD::OPC_Decode, 201, 10, 220, 1, // Opcode: SUBX32dd
/* 12312 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 12329
/* 12317 */   MCD::OPC_CheckField, 3, 1, 0, 128, 11, 0, // Skip to: 15268
/* 12324 */   MCD::OPC_Decode, 183, 10, 232, 1, // Opcode: SUB32jd
/* 12329 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 12346
/* 12334 */   MCD::OPC_CheckField, 3, 1, 1, 111, 11, 0, // Skip to: 15268
/* 12341 */   MCD::OPC_Decode, 185, 10, 233, 1, // Opcode: SUB32pd
/* 12346 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 12370
/* 12351 */   MCD::OPC_CheckField, 24, 4, 8, 94, 11, 0, // Skip to: 15268
/* 12358 */   MCD::OPC_CheckField, 3, 1, 0, 87, 11, 0, // Skip to: 15268
/* 12365 */   MCD::OPC_Decode, 181, 10, 234, 1, // Opcode: SUB32fd
/* 12370 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 12380
/* 12375 */   MCD::OPC_Decode, 172, 10, 235, 1, // Opcode: SUB32ar
/* 12380 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 12397
/* 12385 */   MCD::OPC_CheckField, 3, 1, 0, 60, 11, 0, // Skip to: 15268
/* 12392 */   MCD::OPC_Decode, 168, 10, 236, 1, // Opcode: SUB32aj
/* 12397 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 12414
/* 12402 */   MCD::OPC_CheckField, 3, 1, 1, 43, 11, 0, // Skip to: 15268
/* 12409 */   MCD::OPC_Decode, 170, 10, 237, 1, // Opcode: SUB32ap
/* 12414 */   MCD::OPC_FilterValue, 31, 33, 11, 0, // Skip to: 15268
/* 12419 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12422 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12439
/* 12427 */   MCD::OPC_CheckField, 24, 4, 8, 18, 11, 0, // Skip to: 15268
/* 12434 */   MCD::OPC_Decode, 166, 10, 238, 1, // Opcode: SUB32af
/* 12439 */   MCD::OPC_FilterValue, 1, 8, 11, 0, // Skip to: 15268
/* 12444 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12447 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12457
/* 12452 */   MCD::OPC_Decode, 165, 10, 239, 1, // Opcode: SUB32ab
/* 12457 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12467
/* 12462 */   MCD::OPC_Decode, 171, 10, 240, 1, // Opcode: SUB32aq
/* 12467 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12484
/* 12472 */   MCD::OPC_CheckField, 24, 4, 8, 229, 10, 0, // Skip to: 15268
/* 12479 */   MCD::OPC_Decode, 169, 10, 241, 1, // Opcode: SUB32ak
/* 12484 */   MCD::OPC_FilterValue, 4, 219, 10, 0, // Skip to: 15268
/* 12489 */   MCD::OPC_Decode, 167, 10, 239, 1, // Opcode: SUB32ai
/* 12494 */   MCD::OPC_FilterValue, 11, 101, 1, 0, // Skip to: 12856
/* 12499 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 12502 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12512
/* 12507 */   MCD::OPC_Decode, 251, 4, 242, 1, // Opcode: CMP8dd
/* 12512 */   MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 12528
/* 12517 */   MCD::OPC_CheckField, 3, 1, 0, 184, 10, 0, // Skip to: 15268
/* 12524 */   MCD::OPC_Decode, 254, 4, 55, // Opcode: CMP8dj
/* 12528 */   MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 12544
/* 12533 */   MCD::OPC_CheckField, 3, 1, 1, 168, 10, 0, // Skip to: 15268
/* 12540 */   MCD::OPC_Decode, 128, 5, 56, // Opcode: CMP8dp
/* 12544 */   MCD::OPC_FilterValue, 3, 52, 0, 0, // Skip to: 12601
/* 12549 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12552 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 12568
/* 12557 */   MCD::OPC_CheckField, 24, 4, 8, 144, 10, 0, // Skip to: 15268
/* 12564 */   MCD::OPC_Decode, 252, 4, 57, // Opcode: CMP8df
/* 12568 */   MCD::OPC_FilterValue, 1, 135, 10, 0, // Skip to: 15268
/* 12573 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12576 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 12585
/* 12581 */   MCD::OPC_Decode, 129, 5, 59, // Opcode: CMP8dq
/* 12585 */   MCD::OPC_FilterValue, 3, 118, 10, 0, // Skip to: 15268
/* 12590 */   MCD::OPC_CheckField, 24, 4, 8, 111, 10, 0, // Skip to: 15268
/* 12597 */   MCD::OPC_Decode, 255, 4, 60, // Opcode: CMP8dk
/* 12601 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12611
/* 12606 */   MCD::OPC_Decode, 231, 4, 243, 1, // Opcode: CMP16dr
/* 12611 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 12628
/* 12616 */   MCD::OPC_CheckField, 3, 1, 0, 85, 10, 0, // Skip to: 15268
/* 12623 */   MCD::OPC_Decode, 227, 4, 153, 1, // Opcode: CMP16dj
/* 12628 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 12645
/* 12633 */   MCD::OPC_CheckField, 3, 1, 1, 68, 10, 0, // Skip to: 15268
/* 12640 */   MCD::OPC_Decode, 229, 4, 156, 1, // Opcode: CMP16dp
/* 12645 */   MCD::OPC_FilterValue, 7, 55, 0, 0, // Skip to: 12705
/* 12650 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12653 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12670
/* 12658 */   MCD::OPC_CheckField, 24, 4, 8, 43, 10, 0, // Skip to: 15268
/* 12665 */   MCD::OPC_Decode, 225, 4, 159, 1, // Opcode: CMP16df
/* 12670 */   MCD::OPC_FilterValue, 1, 33, 10, 0, // Skip to: 15268
/* 12675 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12678 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12688
/* 12683 */   MCD::OPC_Decode, 230, 4, 165, 1, // Opcode: CMP16dq
/* 12688 */   MCD::OPC_FilterValue, 3, 15, 10, 0, // Skip to: 15268
/* 12693 */   MCD::OPC_CheckField, 24, 4, 8, 8, 10, 0, // Skip to: 15268
/* 12700 */   MCD::OPC_Decode, 228, 4, 168, 1, // Opcode: CMP16dk
/* 12705 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 12715
/* 12710 */   MCD::OPC_Decode, 244, 4, 244, 1, // Opcode: CMP32dr
/* 12715 */   MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 12731
/* 12720 */   MCD::OPC_CheckField, 3, 1, 0, 237, 9, 0, // Skip to: 15268
/* 12727 */   MCD::OPC_Decode, 240, 4, 120, // Opcode: CMP32dj
/* 12731 */   MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 12747
/* 12736 */   MCD::OPC_CheckField, 3, 1, 1, 221, 9, 0, // Skip to: 15268
/* 12743 */   MCD::OPC_Decode, 242, 4, 121, // Opcode: CMP32dp
/* 12747 */   MCD::OPC_FilterValue, 11, 53, 0, 0, // Skip to: 12805
/* 12752 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12755 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 12771
/* 12760 */   MCD::OPC_CheckField, 24, 4, 8, 197, 9, 0, // Skip to: 15268
/* 12767 */   MCD::OPC_Decode, 238, 4, 123, // Opcode: CMP32df
/* 12771 */   MCD::OPC_FilterValue, 1, 188, 9, 0, // Skip to: 15268
/* 12776 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12779 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 12788
/* 12784 */   MCD::OPC_Decode, 243, 4, 127, // Opcode: CMP32dq
/* 12788 */   MCD::OPC_FilterValue, 3, 171, 9, 0, // Skip to: 15268
/* 12793 */   MCD::OPC_CheckField, 24, 4, 8, 164, 9, 0, // Skip to: 15268
/* 12800 */   MCD::OPC_Decode, 241, 4, 129, 1, // Opcode: CMP32dk
/* 12805 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 12822
/* 12810 */   MCD::OPC_CheckField, 3, 1, 0, 147, 9, 0, // Skip to: 15268
/* 12817 */   MCD::OPC_Decode, 216, 10, 245, 1, // Opcode: XOR8dd
/* 12822 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 12839
/* 12827 */   MCD::OPC_CheckField, 3, 1, 0, 130, 9, 0, // Skip to: 15268
/* 12834 */   MCD::OPC_Decode, 212, 10, 246, 1, // Opcode: XOR16dd
/* 12839 */   MCD::OPC_FilterValue, 24, 120, 9, 0, // Skip to: 15268
/* 12844 */   MCD::OPC_CheckField, 3, 1, 0, 113, 9, 0, // Skip to: 15268
/* 12851 */   MCD::OPC_Decode, 214, 10, 247, 1, // Opcode: XOR32dd
/* 12856 */   MCD::OPC_FilterValue, 12, 110, 2, 0, // Skip to: 13483
/* 12861 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 12864 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12881
/* 12869 */   MCD::OPC_CheckField, 3, 1, 0, 88, 9, 0, // Skip to: 15268
/* 12876 */   MCD::OPC_Decode, 216, 3, 206, 1, // Opcode: AND8dd
/* 12881 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 12898
/* 12886 */   MCD::OPC_CheckField, 3, 1, 0, 71, 9, 0, // Skip to: 15268
/* 12893 */   MCD::OPC_Decode, 219, 3, 207, 1, // Opcode: AND8dj
/* 12898 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 12915
/* 12903 */   MCD::OPC_CheckField, 3, 1, 1, 54, 9, 0, // Skip to: 15268
/* 12910 */   MCD::OPC_Decode, 221, 3, 208, 1, // Opcode: AND8dp
/* 12915 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 12992
/* 12920 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12923 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12940
/* 12928 */   MCD::OPC_CheckField, 24, 4, 8, 29, 9, 0, // Skip to: 15268
/* 12935 */   MCD::OPC_Decode, 217, 3, 209, 1, // Opcode: AND8df
/* 12940 */   MCD::OPC_FilterValue, 1, 19, 9, 0, // Skip to: 15268
/* 12945 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12948 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12958
/* 12953 */   MCD::OPC_Decode, 222, 3, 210, 1, // Opcode: AND8dq
/* 12958 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12975
/* 12963 */   MCD::OPC_CheckField, 24, 4, 8, 250, 8, 0, // Skip to: 15268
/* 12970 */   MCD::OPC_Decode, 220, 3, 211, 1, // Opcode: AND8dk
/* 12975 */   MCD::OPC_FilterValue, 4, 240, 8, 0, // Skip to: 15268
/* 12980 */   MCD::OPC_CheckField, 24, 8, 0, 233, 8, 0, // Skip to: 15268
/* 12987 */   MCD::OPC_Decode, 218, 3, 212, 1, // Opcode: AND8di
/* 12992 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 13014
/* 12997 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 13009
/* 13004 */   MCD::OPC_Decode, 188, 3, 213, 1, // Opcode: AND16dd
/* 13009 */   MCD::OPC_Decode, 195, 3, 214, 1, // Opcode: AND16dr
/* 13014 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 13031
/* 13019 */   MCD::OPC_CheckField, 3, 1, 0, 194, 8, 0, // Skip to: 15268
/* 13026 */   MCD::OPC_Decode, 191, 3, 215, 1, // Opcode: AND16dj
/* 13031 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 13048
/* 13036 */   MCD::OPC_CheckField, 3, 1, 1, 177, 8, 0, // Skip to: 15268
/* 13043 */   MCD::OPC_Decode, 193, 3, 216, 1, // Opcode: AND16dp
/* 13048 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 13118
/* 13053 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 13056 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13073
/* 13061 */   MCD::OPC_CheckField, 24, 4, 8, 152, 8, 0, // Skip to: 15268
/* 13068 */   MCD::OPC_Decode, 189, 3, 217, 1, // Opcode: AND16df
/* 13073 */   MCD::OPC_FilterValue, 1, 142, 8, 0, // Skip to: 15268
/* 13078 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 13081 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13091
/* 13086 */   MCD::OPC_Decode, 194, 3, 218, 1, // Opcode: AND16dq
/* 13091 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 13108
/* 13096 */   MCD::OPC_CheckField, 24, 4, 8, 117, 8, 0, // Skip to: 15268
/* 13103 */   MCD::OPC_Decode, 192, 3, 219, 1, // Opcode: AND16dk
/* 13108 */   MCD::OPC_FilterValue, 4, 107, 8, 0, // Skip to: 15268
/* 13113 */   MCD::OPC_Decode, 190, 3, 218, 1, // Opcode: AND16di
/* 13118 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 13140
/* 13123 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 13135
/* 13130 */   MCD::OPC_Decode, 202, 3, 220, 1, // Opcode: AND32dd
/* 13135 */   MCD::OPC_Decode, 209, 3, 221, 1, // Opcode: AND32dr
/* 13140 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 13157
/* 13145 */   MCD::OPC_CheckField, 3, 1, 0, 68, 8, 0, // Skip to: 15268
/* 13152 */   MCD::OPC_Decode, 205, 3, 222, 1, // Opcode: AND32dj
/* 13157 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 13174
/* 13162 */   MCD::OPC_CheckField, 3, 1, 1, 51, 8, 0, // Skip to: 15268
/* 13169 */   MCD::OPC_Decode, 207, 3, 223, 1, // Opcode: AND32dp
/* 13174 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 13244
/* 13179 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 13182 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13199
/* 13187 */   MCD::OPC_CheckField, 24, 4, 8, 26, 8, 0, // Skip to: 15268
/* 13194 */   MCD::OPC_Decode, 203, 3, 224, 1, // Opcode: AND32df
/* 13199 */   MCD::OPC_FilterValue, 1, 16, 8, 0, // Skip to: 15268
/* 13204 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 13207 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13217
/* 13212 */   MCD::OPC_Decode, 208, 3, 225, 1, // Opcode: AND32dq
/* 13217 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 13234
/* 13222 */   MCD::OPC_CheckField, 24, 4, 8, 247, 7, 0, // Skip to: 15268
/* 13229 */   MCD::OPC_Decode, 206, 3, 226, 1, // Opcode: AND32dk
/* 13234 */   MCD::OPC_FilterValue, 4, 237, 7, 0, // Skip to: 15268
/* 13239 */   MCD::OPC_Decode, 204, 3, 227, 1, // Opcode: AND32di
/* 13244 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 13261
/* 13249 */   MCD::OPC_CheckField, 3, 1, 0, 220, 7, 0, // Skip to: 15268
/* 13256 */   MCD::OPC_Decode, 208, 10, 228, 1, // Opcode: UMULd32d16
/* 13261 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 13278
/* 13266 */   MCD::OPC_CheckField, 0, 4, 12, 203, 7, 0, // Skip to: 15268
/* 13273 */   MCD::OPC_Decode, 210, 10, 225, 1, // Opcode: UMULd32i16
/* 13278 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 13294
/* 13283 */   MCD::OPC_CheckField, 3, 1, 0, 186, 7, 0, // Skip to: 15268
/* 13290 */   MCD::OPC_Decode, 225, 3, 49, // Opcode: AND8jd
/* 13294 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 13310
/* 13299 */   MCD::OPC_CheckField, 3, 1, 1, 170, 7, 0, // Skip to: 15268
/* 13306 */   MCD::OPC_Decode, 227, 3, 50, // Opcode: AND8pd
/* 13310 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 13333
/* 13315 */   MCD::OPC_CheckField, 24, 4, 8, 154, 7, 0, // Skip to: 15268
/* 13322 */   MCD::OPC_CheckField, 3, 1, 0, 147, 7, 0, // Skip to: 15268
/* 13329 */   MCD::OPC_Decode, 223, 3, 51, // Opcode: AND8fd
/* 13333 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 13350
/* 13338 */   MCD::OPC_CheckField, 3, 1, 0, 131, 7, 0, // Skip to: 15268
/* 13345 */   MCD::OPC_Decode, 198, 3, 229, 1, // Opcode: AND16jd
/* 13350 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 13367
/* 13355 */   MCD::OPC_CheckField, 3, 1, 1, 114, 7, 0, // Skip to: 15268
/* 13362 */   MCD::OPC_Decode, 200, 3, 230, 1, // Opcode: AND16pd
/* 13367 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 13391
/* 13372 */   MCD::OPC_CheckField, 24, 4, 8, 97, 7, 0, // Skip to: 15268
/* 13379 */   MCD::OPC_CheckField, 3, 1, 0, 90, 7, 0, // Skip to: 15268
/* 13386 */   MCD::OPC_Decode, 196, 3, 231, 1, // Opcode: AND16fd
/* 13391 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 13408
/* 13396 */   MCD::OPC_CheckField, 3, 1, 0, 73, 7, 0, // Skip to: 15268
/* 13403 */   MCD::OPC_Decode, 212, 3, 232, 1, // Opcode: AND32jd
/* 13408 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 13425
/* 13413 */   MCD::OPC_CheckField, 3, 1, 1, 56, 7, 0, // Skip to: 15268
/* 13420 */   MCD::OPC_Decode, 214, 3, 233, 1, // Opcode: AND32pd
/* 13425 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 13449
/* 13430 */   MCD::OPC_CheckField, 24, 4, 8, 39, 7, 0, // Skip to: 15268
/* 13437 */   MCD::OPC_CheckField, 3, 1, 0, 32, 7, 0, // Skip to: 15268
/* 13444 */   MCD::OPC_Decode, 210, 3, 234, 1, // Opcode: AND32fd
/* 13449 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 13466
/* 13454 */   MCD::OPC_CheckField, 3, 1, 0, 15, 7, 0, // Skip to: 15268
/* 13461 */   MCD::OPC_Decode, 148, 10, 228, 1, // Opcode: SMULd32d16
/* 13466 */   MCD::OPC_FilterValue, 31, 5, 7, 0, // Skip to: 15268
/* 13471 */   MCD::OPC_CheckField, 0, 4, 12, 254, 6, 0, // Skip to: 15268
/* 13478 */   MCD::OPC_Decode, 150, 10, 225, 1, // Opcode: SMULd32i16
/* 13483 */   MCD::OPC_FilterValue, 13, 217, 2, 0, // Skip to: 14217
/* 13488 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 13491 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13508
/* 13496 */   MCD::OPC_CheckField, 3, 1, 0, 229, 6, 0, // Skip to: 15268
/* 13503 */   MCD::OPC_Decode, 172, 3, 206, 1, // Opcode: ADD8dd
/* 13508 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 13525
/* 13513 */   MCD::OPC_CheckField, 3, 1, 0, 212, 6, 0, // Skip to: 15268
/* 13520 */   MCD::OPC_Decode, 175, 3, 207, 1, // Opcode: ADD8dj
/* 13525 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 13542
/* 13530 */   MCD::OPC_CheckField, 3, 1, 1, 195, 6, 0, // Skip to: 15268
/* 13537 */   MCD::OPC_Decode, 177, 3, 208, 1, // Opcode: ADD8dp
/* 13542 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 13619
/* 13547 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 13550 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13567
/* 13555 */   MCD::OPC_CheckField, 24, 4, 8, 170, 6, 0, // Skip to: 15268
/* 13562 */   MCD::OPC_Decode, 173, 3, 209, 1, // Opcode: ADD8df
/* 13567 */   MCD::OPC_FilterValue, 1, 160, 6, 0, // Skip to: 15268
/* 13572 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 13575 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13585
/* 13580 */   MCD::OPC_Decode, 178, 3, 210, 1, // Opcode: ADD8dq
/* 13585 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 13602
/* 13590 */   MCD::OPC_CheckField, 24, 4, 8, 135, 6, 0, // Skip to: 15268
/* 13597 */   MCD::OPC_Decode, 176, 3, 211, 1, // Opcode: ADD8dk
/* 13602 */   MCD::OPC_FilterValue, 4, 125, 6, 0, // Skip to: 15268
/* 13607 */   MCD::OPC_CheckField, 24, 8, 0, 118, 6, 0, // Skip to: 15268
/* 13614 */   MCD::OPC_Decode, 174, 3, 212, 1, // Opcode: ADD8di
/* 13619 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 13641
/* 13624 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 13636
/* 13631 */   MCD::OPC_Decode, 136, 3, 213, 1, // Opcode: ADD16dd
/* 13636 */   MCD::OPC_Decode, 143, 3, 214, 1, // Opcode: ADD16dr
/* 13641 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 13658
/* 13646 */   MCD::OPC_CheckField, 3, 1, 0, 79, 6, 0, // Skip to: 15268
/* 13653 */   MCD::OPC_Decode, 139, 3, 215, 1, // Opcode: ADD16dj
/* 13658 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 13675
/* 13663 */   MCD::OPC_CheckField, 3, 1, 1, 62, 6, 0, // Skip to: 15268
/* 13670 */   MCD::OPC_Decode, 141, 3, 216, 1, // Opcode: ADD16dp
/* 13675 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 13745
/* 13680 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 13683 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13700
/* 13688 */   MCD::OPC_CheckField, 24, 4, 8, 37, 6, 0, // Skip to: 15268
/* 13695 */   MCD::OPC_Decode, 137, 3, 217, 1, // Opcode: ADD16df
/* 13700 */   MCD::OPC_FilterValue, 1, 27, 6, 0, // Skip to: 15268
/* 13705 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 13708 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13718
/* 13713 */   MCD::OPC_Decode, 142, 3, 218, 1, // Opcode: ADD16dq
/* 13718 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 13735
/* 13723 */   MCD::OPC_CheckField, 24, 4, 8, 2, 6, 0, // Skip to: 15268
/* 13730 */   MCD::OPC_Decode, 140, 3, 219, 1, // Opcode: ADD16dk
/* 13735 */   MCD::OPC_FilterValue, 4, 248, 5, 0, // Skip to: 15268
/* 13740 */   MCD::OPC_Decode, 138, 3, 218, 1, // Opcode: ADD16di
/* 13745 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 13767
/* 13750 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 13762
/* 13757 */   MCD::OPC_Decode, 158, 3, 220, 1, // Opcode: ADD32dd
/* 13762 */   MCD::OPC_Decode, 165, 3, 221, 1, // Opcode: ADD32dr
/* 13767 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 13784
/* 13772 */   MCD::OPC_CheckField, 3, 1, 0, 209, 5, 0, // Skip to: 15268
/* 13779 */   MCD::OPC_Decode, 161, 3, 222, 1, // Opcode: ADD32dj
/* 13784 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 13801
/* 13789 */   MCD::OPC_CheckField, 3, 1, 1, 192, 5, 0, // Skip to: 15268
/* 13796 */   MCD::OPC_Decode, 163, 3, 223, 1, // Opcode: ADD32dp
/* 13801 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 13871
/* 13806 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 13809 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13826
/* 13814 */   MCD::OPC_CheckField, 24, 4, 8, 167, 5, 0, // Skip to: 15268
/* 13821 */   MCD::OPC_Decode, 159, 3, 224, 1, // Opcode: ADD32df
/* 13826 */   MCD::OPC_FilterValue, 1, 157, 5, 0, // Skip to: 15268
/* 13831 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 13834 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13844
/* 13839 */   MCD::OPC_Decode, 164, 3, 225, 1, // Opcode: ADD32dq
/* 13844 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 13861
/* 13849 */   MCD::OPC_CheckField, 24, 4, 8, 132, 5, 0, // Skip to: 15268
/* 13856 */   MCD::OPC_Decode, 162, 3, 226, 1, // Opcode: ADD32dk
/* 13861 */   MCD::OPC_FilterValue, 4, 122, 5, 0, // Skip to: 15268
/* 13866 */   MCD::OPC_Decode, 160, 3, 227, 1, // Opcode: ADD32di
/* 13871 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 13888
/* 13876 */   MCD::OPC_CheckField, 3, 1, 0, 105, 5, 0, // Skip to: 15268
/* 13883 */   MCD::OPC_Decode, 187, 3, 206, 1, // Opcode: ADDX8dd
/* 13888 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 13904
/* 13893 */   MCD::OPC_CheckField, 3, 1, 0, 88, 5, 0, // Skip to: 15268
/* 13900 */   MCD::OPC_Decode, 181, 3, 49, // Opcode: ADD8jd
/* 13904 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 13920
/* 13909 */   MCD::OPC_CheckField, 3, 1, 1, 72, 5, 0, // Skip to: 15268
/* 13916 */   MCD::OPC_Decode, 183, 3, 50, // Opcode: ADD8pd
/* 13920 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 13943
/* 13925 */   MCD::OPC_CheckField, 24, 4, 8, 56, 5, 0, // Skip to: 15268
/* 13932 */   MCD::OPC_CheckField, 3, 1, 0, 49, 5, 0, // Skip to: 15268
/* 13939 */   MCD::OPC_Decode, 179, 3, 51, // Opcode: ADD8fd
/* 13943 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 13960
/* 13948 */   MCD::OPC_CheckField, 3, 1, 0, 33, 5, 0, // Skip to: 15268
/* 13955 */   MCD::OPC_Decode, 185, 3, 213, 1, // Opcode: ADDX16dd
/* 13960 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 13977
/* 13965 */   MCD::OPC_CheckField, 3, 1, 0, 16, 5, 0, // Skip to: 15268
/* 13972 */   MCD::OPC_Decode, 146, 3, 229, 1, // Opcode: ADD16jd
/* 13977 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 13994
/* 13982 */   MCD::OPC_CheckField, 3, 1, 1, 255, 4, 0, // Skip to: 15268
/* 13989 */   MCD::OPC_Decode, 148, 3, 230, 1, // Opcode: ADD16pd
/* 13994 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 14018
/* 13999 */   MCD::OPC_CheckField, 24, 4, 8, 238, 4, 0, // Skip to: 15268
/* 14006 */   MCD::OPC_CheckField, 3, 1, 0, 231, 4, 0, // Skip to: 15268
/* 14013 */   MCD::OPC_Decode, 144, 3, 231, 1, // Opcode: ADD16fd
/* 14018 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 14035
/* 14023 */   MCD::OPC_CheckField, 3, 1, 0, 214, 4, 0, // Skip to: 15268
/* 14030 */   MCD::OPC_Decode, 186, 3, 220, 1, // Opcode: ADDX32dd
/* 14035 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 14052
/* 14040 */   MCD::OPC_CheckField, 3, 1, 0, 197, 4, 0, // Skip to: 15268
/* 14047 */   MCD::OPC_Decode, 168, 3, 232, 1, // Opcode: ADD32jd
/* 14052 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 14069
/* 14057 */   MCD::OPC_CheckField, 3, 1, 1, 180, 4, 0, // Skip to: 15268
/* 14064 */   MCD::OPC_Decode, 170, 3, 233, 1, // Opcode: ADD32pd
/* 14069 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 14093
/* 14074 */   MCD::OPC_CheckField, 24, 4, 8, 163, 4, 0, // Skip to: 15268
/* 14081 */   MCD::OPC_CheckField, 3, 1, 0, 156, 4, 0, // Skip to: 15268
/* 14088 */   MCD::OPC_Decode, 166, 3, 234, 1, // Opcode: ADD32fd
/* 14093 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 14103
/* 14098 */   MCD::OPC_Decode, 157, 3, 235, 1, // Opcode: ADD32ar
/* 14103 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 14120
/* 14108 */   MCD::OPC_CheckField, 3, 1, 0, 129, 4, 0, // Skip to: 15268
/* 14115 */   MCD::OPC_Decode, 153, 3, 236, 1, // Opcode: ADD32aj
/* 14120 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 14137
/* 14125 */   MCD::OPC_CheckField, 3, 1, 1, 112, 4, 0, // Skip to: 15268
/* 14132 */   MCD::OPC_Decode, 155, 3, 237, 1, // Opcode: ADD32ap
/* 14137 */   MCD::OPC_FilterValue, 31, 102, 4, 0, // Skip to: 15268
/* 14142 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 14145 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 14162
/* 14150 */   MCD::OPC_CheckField, 24, 4, 8, 87, 4, 0, // Skip to: 15268
/* 14157 */   MCD::OPC_Decode, 151, 3, 238, 1, // Opcode: ADD32af
/* 14162 */   MCD::OPC_FilterValue, 1, 77, 4, 0, // Skip to: 15268
/* 14167 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 14170 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14180
/* 14175 */   MCD::OPC_Decode, 150, 3, 239, 1, // Opcode: ADD32ab
/* 14180 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 14190
/* 14185 */   MCD::OPC_Decode, 156, 3, 240, 1, // Opcode: ADD32aq
/* 14190 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 14207
/* 14195 */   MCD::OPC_CheckField, 24, 4, 8, 42, 4, 0, // Skip to: 15268
/* 14202 */   MCD::OPC_Decode, 154, 3, 241, 1, // Opcode: ADD32ak
/* 14207 */   MCD::OPC_FilterValue, 4, 32, 4, 0, // Skip to: 15268
/* 14212 */   MCD::OPC_Decode, 152, 3, 239, 1, // Opcode: ADD32ai
/* 14217 */   MCD::OPC_FilterValue, 14, 47, 1, 0, // Skip to: 14525
/* 14222 */   MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 14225 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 14235
/* 14230 */   MCD::OPC_Decode, 234, 3, 248, 1, // Opcode: ASR8di
/* 14235 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 14245
/* 14240 */   MCD::OPC_Decode, 218, 5, 248, 1, // Opcode: LSR8di
/* 14245 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 14255
/* 14250 */   MCD::OPC_Decode, 216, 9, 248, 1, // Opcode: ROR8di
/* 14255 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 14265
/* 14260 */   MCD::OPC_Decode, 233, 3, 245, 1, // Opcode: ASR8dd
/* 14265 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 14275
/* 14270 */   MCD::OPC_Decode, 217, 5, 245, 1, // Opcode: LSR8dd
/* 14275 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 14285
/* 14280 */   MCD::OPC_Decode, 215, 9, 245, 1, // Opcode: ROR8dd
/* 14285 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 14295
/* 14290 */   MCD::OPC_Decode, 230, 3, 249, 1, // Opcode: ASR16di
/* 14295 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 14305
/* 14300 */   MCD::OPC_Decode, 214, 5, 249, 1, // Opcode: LSR16di
/* 14305 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 14315
/* 14310 */   MCD::OPC_Decode, 212, 9, 249, 1, // Opcode: ROR16di
/* 14315 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 14325
/* 14320 */   MCD::OPC_Decode, 229, 3, 246, 1, // Opcode: ASR16dd
/* 14325 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 14335
/* 14330 */   MCD::OPC_Decode, 213, 5, 246, 1, // Opcode: LSR16dd
/* 14335 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 14345
/* 14340 */   MCD::OPC_Decode, 211, 9, 246, 1, // Opcode: ROR16dd
/* 14345 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 14355
/* 14350 */   MCD::OPC_Decode, 232, 3, 250, 1, // Opcode: ASR32di
/* 14355 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 14365
/* 14360 */   MCD::OPC_Decode, 216, 5, 250, 1, // Opcode: LSR32di
/* 14365 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 14375
/* 14370 */   MCD::OPC_Decode, 214, 9, 250, 1, // Opcode: ROR32di
/* 14375 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 14385
/* 14380 */   MCD::OPC_Decode, 231, 3, 247, 1, // Opcode: ASR32dd
/* 14385 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 14395
/* 14390 */   MCD::OPC_Decode, 215, 5, 247, 1, // Opcode: LSR32dd
/* 14395 */   MCD::OPC_FilterValue, 23, 5, 0, 0, // Skip to: 14405
/* 14400 */   MCD::OPC_Decode, 213, 9, 247, 1, // Opcode: ROR32dd
/* 14405 */   MCD::OPC_FilterValue, 33, 5, 0, 0, // Skip to: 14415
/* 14410 */   MCD::OPC_Decode, 147, 10, 248, 1, // Opcode: SHL8di
/* 14415 */   MCD::OPC_FilterValue, 35, 5, 0, 0, // Skip to: 14425
/* 14420 */   MCD::OPC_Decode, 210, 9, 248, 1, // Opcode: ROL8di
/* 14425 */   MCD::OPC_FilterValue, 37, 5, 0, 0, // Skip to: 14435
/* 14430 */   MCD::OPC_Decode, 146, 10, 245, 1, // Opcode: SHL8dd
/* 14435 */   MCD::OPC_FilterValue, 39, 5, 0, 0, // Skip to: 14445
/* 14440 */   MCD::OPC_Decode, 209, 9, 245, 1, // Opcode: ROL8dd
/* 14445 */   MCD::OPC_FilterValue, 41, 5, 0, 0, // Skip to: 14455
/* 14450 */   MCD::OPC_Decode, 143, 10, 249, 1, // Opcode: SHL16di
/* 14455 */   MCD::OPC_FilterValue, 43, 5, 0, 0, // Skip to: 14465
/* 14460 */   MCD::OPC_Decode, 206, 9, 249, 1, // Opcode: ROL16di
/* 14465 */   MCD::OPC_FilterValue, 45, 5, 0, 0, // Skip to: 14475
/* 14470 */   MCD::OPC_Decode, 142, 10, 246, 1, // Opcode: SHL16dd
/* 14475 */   MCD::OPC_FilterValue, 47, 5, 0, 0, // Skip to: 14485
/* 14480 */   MCD::OPC_Decode, 205, 9, 246, 1, // Opcode: ROL16dd
/* 14485 */   MCD::OPC_FilterValue, 49, 5, 0, 0, // Skip to: 14495
/* 14490 */   MCD::OPC_Decode, 145, 10, 250, 1, // Opcode: SHL32di
/* 14495 */   MCD::OPC_FilterValue, 51, 5, 0, 0, // Skip to: 14505
/* 14500 */   MCD::OPC_Decode, 208, 9, 250, 1, // Opcode: ROL32di
/* 14505 */   MCD::OPC_FilterValue, 53, 5, 0, 0, // Skip to: 14515
/* 14510 */   MCD::OPC_Decode, 144, 10, 247, 1, // Opcode: SHL32dd
/* 14515 */   MCD::OPC_FilterValue, 55, 236, 2, 0, // Skip to: 15268
/* 14520 */   MCD::OPC_Decode, 207, 9, 247, 1, // Opcode: ROL32dd
/* 14525 */   MCD::OPC_FilterValue, 15, 226, 2, 0, // Skip to: 15268
/* 14530 */   MCD::OPC_ExtractField, 16, 7,  // Inst{22-16} ...
/* 14533 */   MCD::OPC_FilterValue, 0, 130, 0, 0, // Skip to: 14668
/* 14538 */   MCD::OPC_ExtractField, 29, 3,  // Inst{31-29} ...
/* 14541 */   MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 14564
/* 14546 */   MCD::OPC_CheckPredicate, 2, 205, 2, 0, // Skip to: 15268
/* 14551 */   MCD::OPC_CheckField, 0, 12, 128, 4, 197, 2, 0, // Skip to: 15268
/* 14559 */   MCD::OPC_Decode, 169, 5, 251, 1, // Opcode: FMOV80fp_fp
/* 14564 */   MCD::OPC_FilterValue, 4, 47, 0, 0, // Skip to: 14616
/* 14569 */   MCD::OPC_ExtractField, 3, 9,  // Inst{11-3} ...
/* 14572 */   MCD::OPC_FilterValue, 64, 17, 0, 0, // Skip to: 14594
/* 14577 */   MCD::OPC_CheckPredicate, 2, 174, 2, 0, // Skip to: 15268
/* 14582 */   MCD::OPC_CheckField, 23, 3, 0, 167, 2, 0, // Skip to: 15268
/* 14589 */   MCD::OPC_Decode, 172, 5, 252, 1, // Opcode: FMOVE32fpcs_d
/* 14594 */   MCD::OPC_FilterValue, 65, 157, 2, 0, // Skip to: 15268
/* 14599 */   MCD::OPC_CheckPredicate, 2, 152, 2, 0, // Skip to: 15268
/* 14604 */   MCD::OPC_CheckField, 23, 3, 0, 145, 2, 0, // Skip to: 15268
/* 14611 */   MCD::OPC_Decode, 173, 5, 253, 1, // Opcode: FMOVE32fpi_a
/* 14616 */   MCD::OPC_FilterValue, 5, 135, 2, 0, // Skip to: 15268
/* 14621 */   MCD::OPC_ExtractField, 3, 9,  // Inst{11-3} ...
/* 14624 */   MCD::OPC_FilterValue, 64, 17, 0, 0, // Skip to: 14646
/* 14629 */   MCD::OPC_CheckPredicate, 2, 122, 2, 0, // Skip to: 15268
/* 14634 */   MCD::OPC_CheckField, 23, 3, 0, 115, 2, 0, // Skip to: 15268
/* 14641 */   MCD::OPC_Decode, 171, 5, 254, 1, // Opcode: FMOVE32d_fpcs
/* 14646 */   MCD::OPC_FilterValue, 65, 105, 2, 0, // Skip to: 15268
/* 14651 */   MCD::OPC_CheckPredicate, 2, 100, 2, 0, // Skip to: 15268
/* 14656 */   MCD::OPC_CheckField, 23, 3, 0, 93, 2, 0, // Skip to: 15268
/* 14663 */   MCD::OPC_Decode, 170, 5, 255, 1, // Opcode: FMOVE32a_fpi
/* 14668 */   MCD::OPC_FilterValue, 24, 25, 0, 0, // Skip to: 14698
/* 14673 */   MCD::OPC_CheckPredicate, 2, 78, 2, 0, // Skip to: 15268
/* 14678 */   MCD::OPC_CheckField, 29, 3, 0, 71, 2, 0, // Skip to: 15268
/* 14685 */   MCD::OPC_CheckField, 0, 12, 128, 4, 63, 2, 0, // Skip to: 15268
/* 14693 */   MCD::OPC_Decode, 139, 5, 251, 1, // Opcode: FABS80fp_fp
/* 14698 */   MCD::OPC_FilterValue, 26, 25, 0, 0, // Skip to: 14728
/* 14703 */   MCD::OPC_CheckPredicate, 2, 48, 2, 0, // Skip to: 15268
/* 14708 */   MCD::OPC_CheckField, 29, 3, 0, 41, 2, 0, // Skip to: 15268
/* 14715 */   MCD::OPC_CheckField, 0, 12, 128, 4, 33, 2, 0, // Skip to: 15268
/* 14723 */   MCD::OPC_Decode, 179, 5, 251, 1, // Opcode: FNEG80fp_fp
/* 14728 */   MCD::OPC_FilterValue, 32, 25, 0, 0, // Skip to: 14758
/* 14733 */   MCD::OPC_CheckPredicate, 2, 18, 2, 0, // Skip to: 15268
/* 14738 */   MCD::OPC_CheckField, 29, 3, 0, 11, 2, 0, // Skip to: 15268
/* 14745 */   MCD::OPC_CheckField, 0, 12, 128, 4, 3, 2, 0, // Skip to: 15268
/* 14753 */   MCD::OPC_Decode, 154, 5, 128, 2, // Opcode: FDIV80fp_fp
/* 14758 */   MCD::OPC_FilterValue, 34, 25, 0, 0, // Skip to: 14788
/* 14763 */   MCD::OPC_CheckPredicate, 2, 244, 1, 0, // Skip to: 15268
/* 14768 */   MCD::OPC_CheckField, 29, 3, 0, 237, 1, 0, // Skip to: 15268
/* 14775 */   MCD::OPC_CheckField, 0, 12, 128, 4, 229, 1, 0, // Skip to: 15268
/* 14783 */   MCD::OPC_Decode, 142, 5, 128, 2, // Opcode: FADD80fp_fp
/* 14788 */   MCD::OPC_FilterValue, 35, 25, 0, 0, // Skip to: 14818
/* 14793 */   MCD::OPC_CheckPredicate, 2, 214, 1, 0, // Skip to: 15268
/* 14798 */   MCD::OPC_CheckField, 29, 3, 0, 207, 1, 0, // Skip to: 15268
/* 14805 */   MCD::OPC_CheckField, 0, 12, 128, 4, 199, 1, 0, // Skip to: 15268
/* 14813 */   MCD::OPC_Decode, 176, 5, 128, 2, // Opcode: FMUL80fp_fp
/* 14818 */   MCD::OPC_FilterValue, 40, 25, 0, 0, // Skip to: 14848
/* 14823 */   MCD::OPC_CheckPredicate, 2, 184, 1, 0, // Skip to: 15268
/* 14828 */   MCD::OPC_CheckField, 29, 3, 0, 177, 1, 0, // Skip to: 15268
/* 14835 */   MCD::OPC_CheckField, 0, 12, 128, 4, 169, 1, 0, // Skip to: 15268
/* 14843 */   MCD::OPC_Decode, 203, 5, 128, 2, // Opcode: FSUB80fp_fp
/* 14848 */   MCD::OPC_FilterValue, 64, 25, 0, 0, // Skip to: 14878
/* 14853 */   MCD::OPC_CheckPredicate, 3, 154, 1, 0, // Skip to: 15268
/* 14858 */   MCD::OPC_CheckField, 29, 3, 0, 147, 1, 0, // Skip to: 15268
/* 14865 */   MCD::OPC_CheckField, 0, 12, 128, 4, 139, 1, 0, // Skip to: 15268
/* 14873 */   MCD::OPC_Decode, 191, 5, 251, 1, // Opcode: FSMOV80fp_fp
/* 14878 */   MCD::OPC_FilterValue, 68, 25, 0, 0, // Skip to: 14908
/* 14883 */   MCD::OPC_CheckPredicate, 3, 124, 1, 0, // Skip to: 15268
/* 14888 */   MCD::OPC_CheckField, 29, 3, 0, 117, 1, 0, // Skip to: 15268
/* 14895 */   MCD::OPC_CheckField, 0, 12, 128, 4, 109, 1, 0, // Skip to: 15268
/* 14903 */   MCD::OPC_Decode, 157, 5, 251, 1, // Opcode: FDMOV80fp_fp
/* 14908 */   MCD::OPC_FilterValue, 88, 25, 0, 0, // Skip to: 14938
/* 14913 */   MCD::OPC_CheckPredicate, 3, 94, 1, 0, // Skip to: 15268
/* 14918 */   MCD::OPC_CheckField, 29, 3, 0, 87, 1, 0, // Skip to: 15268
/* 14925 */   MCD::OPC_CheckField, 0, 12, 128, 4, 79, 1, 0, // Skip to: 15268
/* 14933 */   MCD::OPC_Decode, 182, 5, 251, 1, // Opcode: FSABS80fp_fp
/* 14938 */   MCD::OPC_FilterValue, 90, 25, 0, 0, // Skip to: 14968
/* 14943 */   MCD::OPC_CheckPredicate, 3, 64, 1, 0, // Skip to: 15268
/* 14948 */   MCD::OPC_CheckField, 29, 3, 0, 57, 1, 0, // Skip to: 15268
/* 14955 */   MCD::OPC_CheckField, 0, 12, 128, 4, 49, 1, 0, // Skip to: 15268
/* 14963 */   MCD::OPC_Decode, 197, 5, 251, 1, // Opcode: FSNEG80fp_fp
/* 14968 */   MCD::OPC_FilterValue, 92, 25, 0, 0, // Skip to: 14998
/* 14973 */   MCD::OPC_CheckPredicate, 3, 34, 1, 0, // Skip to: 15268
/* 14978 */   MCD::OPC_CheckField, 29, 3, 0, 27, 1, 0, // Skip to: 15268
/* 14985 */   MCD::OPC_CheckField, 0, 12, 128, 4, 19, 1, 0, // Skip to: 15268
/* 14993 */   MCD::OPC_Decode, 145, 5, 251, 1, // Opcode: FDABS80fp_fp
/* 14998 */   MCD::OPC_FilterValue, 94, 25, 0, 0, // Skip to: 15028
/* 15003 */   MCD::OPC_CheckPredicate, 3, 4, 1, 0, // Skip to: 15268
/* 15008 */   MCD::OPC_CheckField, 29, 3, 0, 253, 0, 0, // Skip to: 15268
/* 15015 */   MCD::OPC_CheckField, 0, 12, 128, 4, 245, 0, 0, // Skip to: 15268
/* 15023 */   MCD::OPC_Decode, 163, 5, 251, 1, // Opcode: FDNEG80fp_fp
/* 15028 */   MCD::OPC_FilterValue, 96, 25, 0, 0, // Skip to: 15058
/* 15033 */   MCD::OPC_CheckPredicate, 3, 230, 0, 0, // Skip to: 15268
/* 15038 */   MCD::OPC_CheckField, 29, 3, 0, 223, 0, 0, // Skip to: 15268
/* 15045 */   MCD::OPC_CheckField, 0, 12, 128, 4, 215, 0, 0, // Skip to: 15268
/* 15053 */   MCD::OPC_Decode, 188, 5, 128, 2, // Opcode: FSDIV80fp_fp
/* 15058 */   MCD::OPC_FilterValue, 98, 25, 0, 0, // Skip to: 15088
/* 15063 */   MCD::OPC_CheckPredicate, 3, 200, 0, 0, // Skip to: 15268
/* 15068 */   MCD::OPC_CheckField, 29, 3, 0, 193, 0, 0, // Skip to: 15268
/* 15075 */   MCD::OPC_CheckField, 0, 12, 128, 4, 185, 0, 0, // Skip to: 15268
/* 15083 */   MCD::OPC_Decode, 185, 5, 128, 2, // Opcode: FSADD80fp_fp
/* 15088 */   MCD::OPC_FilterValue, 99, 25, 0, 0, // Skip to: 15118
/* 15093 */   MCD::OPC_CheckPredicate, 3, 170, 0, 0, // Skip to: 15268
/* 15098 */   MCD::OPC_CheckField, 29, 3, 0, 163, 0, 0, // Skip to: 15268
/* 15105 */   MCD::OPC_CheckField, 0, 12, 128, 4, 155, 0, 0, // Skip to: 15268
/* 15113 */   MCD::OPC_Decode, 194, 5, 128, 2, // Opcode: FSMUL80fp_fp
/* 15118 */   MCD::OPC_FilterValue, 100, 25, 0, 0, // Skip to: 15148
/* 15123 */   MCD::OPC_CheckPredicate, 3, 140, 0, 0, // Skip to: 15268
/* 15128 */   MCD::OPC_CheckField, 29, 3, 0, 133, 0, 0, // Skip to: 15268
/* 15135 */   MCD::OPC_CheckField, 0, 12, 128, 4, 125, 0, 0, // Skip to: 15268
/* 15143 */   MCD::OPC_Decode, 151, 5, 128, 2, // Opcode: FDDIV80fp_fp
/* 15148 */   MCD::OPC_FilterValue, 102, 25, 0, 0, // Skip to: 15178
/* 15153 */   MCD::OPC_CheckPredicate, 3, 110, 0, 0, // Skip to: 15268
/* 15158 */   MCD::OPC_CheckField, 29, 3, 0, 103, 0, 0, // Skip to: 15268
/* 15165 */   MCD::OPC_CheckField, 0, 12, 128, 4, 95, 0, 0, // Skip to: 15268
/* 15173 */   MCD::OPC_Decode, 148, 5, 128, 2, // Opcode: FDADD80fp_fp
/* 15178 */   MCD::OPC_FilterValue, 103, 25, 0, 0, // Skip to: 15208
/* 15183 */   MCD::OPC_CheckPredicate, 3, 80, 0, 0, // Skip to: 15268
/* 15188 */   MCD::OPC_CheckField, 29, 3, 0, 73, 0, 0, // Skip to: 15268
/* 15195 */   MCD::OPC_CheckField, 0, 12, 128, 4, 65, 0, 0, // Skip to: 15268
/* 15203 */   MCD::OPC_Decode, 160, 5, 128, 2, // Opcode: FDMUL80fp_fp
/* 15208 */   MCD::OPC_FilterValue, 104, 25, 0, 0, // Skip to: 15238
/* 15213 */   MCD::OPC_CheckPredicate, 3, 50, 0, 0, // Skip to: 15268
/* 15218 */   MCD::OPC_CheckField, 29, 3, 0, 43, 0, 0, // Skip to: 15268
/* 15225 */   MCD::OPC_CheckField, 0, 12, 128, 4, 35, 0, 0, // Skip to: 15268
/* 15233 */   MCD::OPC_Decode, 200, 5, 128, 2, // Opcode: FSSUB80fp_fp
/* 15238 */   MCD::OPC_FilterValue, 108, 25, 0, 0, // Skip to: 15268
/* 15243 */   MCD::OPC_CheckPredicate, 3, 20, 0, 0, // Skip to: 15268
/* 15248 */   MCD::OPC_CheckField, 29, 3, 0, 13, 0, 0, // Skip to: 15268
/* 15255 */   MCD::OPC_CheckField, 0, 12, 128, 4, 5, 0, 0, // Skip to: 15268
/* 15263 */   MCD::OPC_Decode, 166, 5, 128, 2, // Opcode: FDSUB80fp_fp
/* 15268 */   MCD::OPC_Fail,
  0
};

static const uint8_t InstrLenTable[] = {
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
48,
16,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
32,
48,
16,
16,
32,
16,
32,
32,
48,
16,
32,
32,
48,
16,
32,
32,
48,
32,
48,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
32,
48,
16,
48,
16,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
64,
32,
32,
16,
32,
32,
32,
16,
48,
32,
48,
48,
48,
80,
32,
48,
16,
32,
32,
32,
16,
64,
48,
64,
64,
64,
64,
16,
32,
32,
16,
32,
32,
32,
48,
32,
48,
48,
48,
16,
16,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
32,
32,
32,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
16,
16,
48,
32,
32,
32,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
48,
48,
16,
16,
32,
16,
32,
16,
32,
32,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
16,
16,
32,
16,
32,
16,
32,
32,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
64,
80,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
80,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
16,
32,
16,
48,
16,
32,
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[M68k::FeatureISA20]);
  case 1:
    return (Bits[M68k::FeatureISA10]);
  case 2:
    return (Bits[M68k::FeatureISA881]);
  case 3:
    return (Bits[M68k::FeatureISA40]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeXR32RegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeXR32RegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeXR32RegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 128:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 130:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 133:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 135:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 146:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 147:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 149:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 150:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 152:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 153:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 154:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 155:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 158:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 159:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 160:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 161:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 162:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 163:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 164:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 165:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 166:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 167:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 168:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 169:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 170:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 171:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 174:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 0, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 177:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 179:
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 186:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 187:
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 188:
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeSRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 16, 32);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 226:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 227:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 229:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 230:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 231:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 232:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 233:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 234:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 235:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 236:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 237:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 238:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 239:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 240:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 241:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 242:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 243:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 244:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 245:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 246:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 247:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 248:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 249:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 250:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 251:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 252:
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPCSCRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 253:
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPICRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 254:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPCSCRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 255:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPICRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 256:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI,
                                      llvm::function_ref<void(APInt &, uint64_t)> makeUp) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned Len = *Ptr++;
      makeUp(insn, Start + Len);
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(++Ptr);
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned Len = *Ptr;
      makeUp(insn, Start + Len);
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(++Ptr);
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      unsigned Len = InstrLenTable[Opc];
      makeUp(insn, Len);
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(++Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
