/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the M68k target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(M68kInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(M68kInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static M68kInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static M68kInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_IsPICBit = 0,
  Feature_IsNotPICBit = 1,
  Feature_AtLeastM68020Bit = 2,
};

PredicateBitset M68kInstructionSelector::
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (TM.isPositionIndependent())
    Features.set(Feature_IsPICBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->atLeastM68020())
    Features.set(Feature_AtLeastM68020Bit);
  return Features;
}

void M68kInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const M68kSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset M68kInstructionSelector::
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

M68kInstructionSelector::ComplexMatcherMemFn
M68kInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool M68kInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Mximm8_1to8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Mximm16_1to8,
  GICXXPred_I64_Predicate_Mximm32_1to8,
};
bool M68kInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Mximm8_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm16_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm32_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("M68kInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
M68kInstructionSelector::CustomRendererFn
M68kInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool M68kInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool M68kInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("M68kInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *M68kInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(164), /*)*//*default:*//*Label 23*/ GIMT_Encode4(5835),
    /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(454),
    /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(673),
    /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(955),
    /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(1176),
    /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(1472),
    /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(1768),
    /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(2202), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(2636),
    /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(2855),
    /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(3074), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ANYEXT*//*Label 10*/ GIMT_Encode4(3356),
    /*TargetOpcode::G_TRUNC*//*Label 11*/ GIMT_Encode4(3484),
    /*TargetOpcode::G_CONSTANT*//*Label 12*/ GIMT_Encode4(3522), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SEXT*//*Label 13*/ GIMT_Encode4(3615),
    /*TargetOpcode::G_SEXT_INREG*//*Label 14*/ GIMT_Encode4(3743),
    /*TargetOpcode::G_ZEXT*//*Label 15*/ GIMT_Encode4(4018),
    /*TargetOpcode::G_SHL*//*Label 16*/ GIMT_Encode4(4146),
    /*TargetOpcode::G_LSHR*//*Label 17*/ GIMT_Encode4(4377),
    /*TargetOpcode::G_ASHR*//*Label 18*/ GIMT_Encode4(4608), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ROTR*//*Label 19*/ GIMT_Encode4(4839),
    /*TargetOpcode::G_ROTL*//*Label 20*/ GIMT_Encode4(5070), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_UMULH*//*Label 21*/ GIMT_Encode4(5301),
    /*TargetOpcode::G_SMULH*//*Label 22*/ GIMT_Encode4(5568),
    // Label 0: @454
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 27*/ GIMT_Encode4(672),
    /*GILLT_s8*//*Label 24*/ GIMT_Encode4(477),
    /*GILLT_s16*//*Label 25*/ GIMT_Encode4(542),
    /*GILLT_s32*//*Label 26*/ GIMT_Encode4(607),
    // Label 24: @477
    GIM_Try, /*On fail goto*//*Label 28*/ GIMT_Encode4(541),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29*/ GIMT_Encode4(522), // Rule ID 691 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (ADD8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ADD8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 691,
        GIR_EraseRootFromParent_Done,
      // Label 29: @522
      GIM_Try, /*On fail goto*//*Label 30*/ GIMT_Encode4(540), // Rule ID 679 //
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ADD8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 679,
        GIR_Done,
      // Label 30: @540
      GIM_Reject,
    // Label 28: @541
    GIM_Reject,
    // Label 25: @542
    GIM_Try, /*On fail goto*//*Label 31*/ GIMT_Encode4(606),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 32*/ GIMT_Encode4(587), // Rule ID 692 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (ADD16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ADD16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 692,
        GIR_EraseRootFromParent_Done,
      // Label 32: @587
      GIM_Try, /*On fail goto*//*Label 33*/ GIMT_Encode4(605), // Rule ID 680 //
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ADD16dr:{ *:[i16] }:{ *:[i8] } MxXRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD16dr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 680,
        GIR_Done,
      // Label 33: @605
      GIM_Reject,
    // Label 31: @606
    GIM_Reject,
    // Label 26: @607
    GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(671),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(652), // Rule ID 693 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (ADD32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ADD32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 693,
        GIR_EraseRootFromParent_Done,
      // Label 35: @652
      GIM_Try, /*On fail goto*//*Label 36*/ GIMT_Encode4(670), // Rule ID 681 //
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ADD32dr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD32dr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 681,
        GIR_Done,
      // Label 36: @670
      GIM_Reject,
    // Label 34: @671
    GIM_Reject,
    // Label 27: @672
    GIM_Reject,
    // Label 1: @673
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 40*/ GIMT_Encode4(954),
    /*GILLT_s8*//*Label 37*/ GIMT_Encode4(696),
    /*GILLT_s16*//*Label 38*/ GIMT_Encode4(782),
    /*GILLT_s32*//*Label 39*/ GIMT_Encode4(868),
    // Label 37: @696
    GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(781),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 42*/ GIMT_Encode4(732), // Rule ID 513 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i8] } 0:{ *:[i8] }, i8:{ *:[i8] }:$src)  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG8d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 513,
        GIR_EraseRootFromParent_Done,
      // Label 42: @732
      GIM_Try, /*On fail goto*//*Label 43*/ GIMT_Encode4(762), // Rule ID 730 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (SUB8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SUB8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 730,
        GIR_EraseRootFromParent_Done,
      // Label 43: @762
      GIM_Try, /*On fail goto*//*Label 44*/ GIMT_Encode4(780), // Rule ID 718 //
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SUB8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 718,
        GIR_Done,
      // Label 44: @780
      GIM_Reject,
    // Label 41: @781
    GIM_Reject,
    // Label 38: @782
    GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(867),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(818), // Rule ID 516 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i16] } 0:{ *:[i16] }, i16:{ *:[i16] }:$src)  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG16d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 516,
        GIR_EraseRootFromParent_Done,
      // Label 46: @818
      GIM_Try, /*On fail goto*//*Label 47*/ GIMT_Encode4(848), // Rule ID 731 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (SUB16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SUB16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 731,
        GIR_EraseRootFromParent_Done,
      // Label 47: @848
      GIM_Try, /*On fail goto*//*Label 48*/ GIMT_Encode4(866), // Rule ID 719 //
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SUB16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 719,
        GIR_Done,
      // Label 48: @866
      GIM_Reject,
    // Label 45: @867
    GIM_Reject,
    // Label 39: @868
    GIM_Try, /*On fail goto*//*Label 49*/ GIMT_Encode4(953),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 50*/ GIMT_Encode4(904), // Rule ID 519 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG32d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 519,
        GIR_EraseRootFromParent_Done,
      // Label 50: @904
      GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(934), // Rule ID 732 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (SUB32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SUB32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 732,
        GIR_EraseRootFromParent_Done,
      // Label 51: @934
      GIM_Try, /*On fail goto*//*Label 52*/ GIMT_Encode4(952), // Rule ID 720 //
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SUB32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 720,
        GIR_Done,
      // Label 52: @952
      GIM_Reject,
    // Label 49: @953
    GIM_Reject,
    // Label 40: @954
    GIM_Reject,
    // Label 2: @955
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 55*/ GIMT_Encode4(1175),
    /*GILLT_s16*//*Label 53*/ GIMT_Encode4(974),
    /*GILLT_s32*//*Label 54*/ GIMT_Encode4(1146),
    // Label 53: @974
    GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(1145),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(1071), // Rule ID 670 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SMULd32i16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SMULd32i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 670,
        GIR_EraseRootFromParent_Done,
      // Label 57: @1071
      GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(1144), // Rule ID 666 //
        // (mul:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SMULd32d16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SMULd32d16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 666,
        GIR_EraseRootFromParent_Done,
      // Label 58: @1144
      GIM_Reject,
    // Label 56: @1145
    GIM_Reject,
    // Label 54: @1146
    GIM_Try, /*On fail goto*//*Label 59*/ GIMT_Encode4(1174), // Rule ID 669 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (mul:{ *:[i32] } i32:{ *:[i32] }:$dst, i32:{ *:[i32] }:$opd)  =>  (SMULd32d32:{ *:[i32] }:{ *:[i8] } ?:{ *:[i32] }:$dst, ?:{ *:[i32] }:$opd)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SMULd32d32),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 669,
      GIR_Done,
    // Label 59: @1174
    GIM_Reject,
    // Label 55: @1175
    GIM_Reject,
    // Label 3: @1176
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 62*/ GIMT_Encode4(1471),
    /*GILLT_s8*//*Label 60*/ GIMT_Encode4(1195),
    /*GILLT_s16*//*Label 61*/ GIMT_Encode4(1299),
    // Label 60: @1195
    GIM_Try, /*On fail goto*//*Label 63*/ GIMT_Encode4(1298), // Rule ID 650 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // (sdiv:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVSXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::MOVSXd16d8),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 650,
      GIR_EraseRootFromParent_Done,
    // Label 63: @1298
    GIM_Reject,
    // Label 61: @1299
    GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(1470),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(1396), // Rule ID 662 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sdiv:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 662,
        GIR_EraseRootFromParent_Done,
      // Label 65: @1396
      GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(1469), // Rule ID 654 //
        // (sdiv:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 654,
        GIR_EraseRootFromParent_Done,
      // Label 66: @1469
      GIM_Reject,
    // Label 64: @1470
    GIM_Reject,
    // Label 62: @1471
    GIM_Reject,
    // Label 4: @1472
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 69*/ GIMT_Encode4(1767),
    /*GILLT_s8*//*Label 67*/ GIMT_Encode4(1491),
    /*GILLT_s16*//*Label 68*/ GIMT_Encode4(1595),
    // Label 67: @1491
    GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(1594), // Rule ID 651 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // (udiv:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVZXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::MOVZXd16d8),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 651,
      GIR_EraseRootFromParent_Done,
    // Label 70: @1594
    GIM_Reject,
    // Label 68: @1595
    GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(1766),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1692), // Rule ID 663 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (udiv:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (UDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::UDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 663,
        GIR_EraseRootFromParent_Done,
      // Label 72: @1692
      GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1765), // Rule ID 655 //
        // (udiv:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 655,
        GIR_EraseRootFromParent_Done,
      // Label 73: @1765
      GIM_Reject,
    // Label 71: @1766
    GIM_Reject,
    // Label 69: @1767
    GIM_Reject,
    // Label 5: @1768
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 76*/ GIMT_Encode4(2201),
    /*GILLT_s8*//*Label 74*/ GIMT_Encode4(1787),
    /*GILLT_s16*//*Label 75*/ GIMT_Encode4(1937),
    // Label 74: @1787
    GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1936), // Rule ID 652 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // (srem:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVSXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(M68k::MOVSXd16d8),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/5, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 652,
      GIR_EraseRootFromParent_Done,
    // Label 77: @1936
    GIM_Reject,
    // Label 75: @1937
    GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(2200),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(2080), // Rule ID 664 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srem:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 664,
        GIR_EraseRootFromParent_Done,
      // Label 79: @2080
      GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(2199), // Rule ID 656 //
        // (srem:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 656,
        GIR_EraseRootFromParent_Done,
      // Label 80: @2199
      GIM_Reject,
    // Label 78: @2200
    GIM_Reject,
    // Label 76: @2201
    GIM_Reject,
    // Label 6: @2202
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 83*/ GIMT_Encode4(2635),
    /*GILLT_s8*//*Label 81*/ GIMT_Encode4(2221),
    /*GILLT_s16*//*Label 82*/ GIMT_Encode4(2371),
    // Label 81: @2221
    GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(2370), // Rule ID 653 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // (urem:{ *:[i8] } i8:{ *:[i8] }:$dst, i8:{ *:[i8] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } ?:{ *:[i8] }:$dst), (MOVZXd16d8:{ *:[i16] }:{ *:[i8] } ?:{ *:[i8] }:$opd)), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex8Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(M68k::MOVZXd16d8),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_SetImplicitDefDead, /*InsnID*/5, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex8Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR8RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 653,
      GIR_EraseRootFromParent_Done,
    // Label 84: @2370
    GIM_Reject,
    // Label 82: @2371
    GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(2634),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(2514), // Rule ID 665 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (urem:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UDIVd32i16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UDIVd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 665,
        GIR_EraseRootFromParent_Done,
      // Label 86: @2514
      GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(2633), // Rule ID 657 //
        // (urem:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UDIVd32d16:{ *:[i32] }:{ *:[i8] } (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UDIVd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 657,
        GIR_EraseRootFromParent_Done,
      // Label 87: @2633
      GIM_Reject,
    // Label 85: @2634
    GIM_Reject,
    // Label 83: @2635
    GIM_Reject,
    // Label 7: @2636
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 91*/ GIMT_Encode4(2854),
    /*GILLT_s8*//*Label 88*/ GIMT_Encode4(2659),
    /*GILLT_s16*//*Label 89*/ GIMT_Encode4(2724),
    /*GILLT_s32*//*Label 90*/ GIMT_Encode4(2789),
    // Label 88: @2659
    GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(2723),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(2704), // Rule ID 760 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::AND8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 760,
        GIR_EraseRootFromParent_Done,
      // Label 93: @2704
      GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(2722), // Rule ID 757 //
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (AND8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 757,
        GIR_Done,
      // Label 94: @2722
      GIM_Reject,
    // Label 92: @2723
    GIM_Reject,
    // Label 89: @2724
    GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(2788),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(2769), // Rule ID 761 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::AND16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 761,
        GIR_EraseRootFromParent_Done,
      // Label 96: @2769
      GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(2787), // Rule ID 758 //
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (AND16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 97: @2787
      GIM_Reject,
    // Label 95: @2788
    GIM_Reject,
    // Label 90: @2789
    GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(2853),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(2834), // Rule ID 762 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::AND32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 762,
        GIR_EraseRootFromParent_Done,
      // Label 99: @2834
      GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2852), // Rule ID 759 //
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (AND32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 759,
        GIR_Done,
      // Label 100: @2852
      GIM_Reject,
    // Label 98: @2853
    GIM_Reject,
    // Label 91: @2854
    GIM_Reject,
    // Label 8: @2855
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 104*/ GIMT_Encode4(3073),
    /*GILLT_s8*//*Label 101*/ GIMT_Encode4(2878),
    /*GILLT_s16*//*Label 102*/ GIMT_Encode4(2943),
    /*GILLT_s32*//*Label 103*/ GIMT_Encode4(3008),
    // Label 101: @2878
    GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2942),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2923), // Rule ID 766 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (OR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::OR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 766,
        GIR_EraseRootFromParent_Done,
      // Label 106: @2923
      GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2941), // Rule ID 763 //
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (OR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 763,
        GIR_Done,
      // Label 107: @2941
      GIM_Reject,
    // Label 105: @2942
    GIM_Reject,
    // Label 102: @2943
    GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(3007),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(2988), // Rule ID 767 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (OR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::OR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 767,
        GIR_EraseRootFromParent_Done,
      // Label 109: @2988
      GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3006), // Rule ID 764 //
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (OR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 764,
        GIR_Done,
      // Label 110: @3006
      GIM_Reject,
    // Label 108: @3007
    GIM_Reject,
    // Label 103: @3008
    GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3072),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3053), // Rule ID 768 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (OR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::OR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 768,
        GIR_EraseRootFromParent_Done,
      // Label 112: @3053
      GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3071), // Rule ID 765 //
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (OR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 765,
        GIR_Done,
      // Label 113: @3071
      GIM_Reject,
    // Label 111: @3072
    GIM_Reject,
    // Label 104: @3073
    GIM_Reject,
    // Label 9: @3074
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 117*/ GIMT_Encode4(3355),
    /*GILLT_s8*//*Label 114*/ GIMT_Encode4(3097),
    /*GILLT_s16*//*Label 115*/ GIMT_Encode4(3183),
    /*GILLT_s32*//*Label 116*/ GIMT_Encode4(3269),
    // Label 114: @3097
    GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3182),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(3133), // Rule ID 515 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (NOT8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NOT8d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 515,
        GIR_EraseRootFromParent_Done,
      // Label 119: @3133
      GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(3163), // Rule ID 772 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (XOR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::XOR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 772,
        GIR_EraseRootFromParent_Done,
      // Label 120: @3163
      GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(3181), // Rule ID 769 //
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (XOR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 769,
        GIR_Done,
      // Label 121: @3181
      GIM_Reject,
    // Label 118: @3182
    GIM_Reject,
    // Label 115: @3183
    GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(3268),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(3219), // Rule ID 518 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (NOT16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NOT16d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 518,
        GIR_EraseRootFromParent_Done,
      // Label 123: @3219
      GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(3249), // Rule ID 773 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (XOR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::XOR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 773,
        GIR_EraseRootFromParent_Done,
      // Label 124: @3249
      GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(3267), // Rule ID 770 //
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (XOR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 770,
        GIR_Done,
      // Label 125: @3267
      GIM_Reject,
    // Label 122: @3268
    GIM_Reject,
    // Label 116: @3269
    GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(3354),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(3305), // Rule ID 521 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (NOT32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NOT32d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 521,
        GIR_EraseRootFromParent_Done,
      // Label 127: @3305
      GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(3335), // Rule ID 774 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (XOR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::XOR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 774,
        GIR_EraseRootFromParent_Done,
      // Label 128: @3335
      GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(3353), // Rule ID 771 //
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (XOR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 771,
        GIR_Done,
      // Label 129: @3353
      GIM_Reject,
    // Label 126: @3354
    GIM_Reject,
    // Label 117: @3355
    GIM_Reject,
    // Label 10: @3356
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 132*/ GIMT_Encode4(3483),
    /*GILLT_s16*//*Label 130*/ GIMT_Encode4(3375),
    /*GILLT_s32*//*Label 131*/ GIMT_Encode4(3432),
    // Label 130: @3375
    GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(3431), // Rule ID 615 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      // (anyext:{ *:[i16] } i8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src), MxSubRegIndex16Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 615,
      GIR_EraseRootFromParent_Done,
    // Label 133: @3431
    GIM_Reject,
    // Label 131: @3432
    GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(3457), // Rule ID 619 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (anyext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 619,
      GIR_Done,
    // Label 134: @3457
    GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(3482), // Rule ID 623 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 623,
      GIR_Done,
    // Label 135: @3482
    GIM_Reject,
    // Label 132: @3483
    GIM_Reject,
    // Label 11: @3484
    GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(3521), // Rule ID 627 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR16RegClassID),
      // (trunc:{ *:[i16] } i32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } MxXRD32:{ *:[i32] }:$src, MxSubRegIndex16Lo:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::XR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::XR32RegClassID),
      // GIR_Coverage, 627,
      GIR_EraseRootFromParent_Done,
    // Label 136: @3521
    GIM_Reject,
    // Label 12: @3522
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 140*/ GIMT_Encode4(3614),
    /*GILLT_s8*//*Label 137*/ GIMT_Encode4(3545),
    /*GILLT_s16*//*Label 138*/ GIMT_Encode4(3568),
    /*GILLT_s32*//*Label 139*/ GIMT_Encode4(3591),
    // Label 137: @3545
    GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(3567), // Rule ID 333 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i8] }):$src  =>  (MOVI8di:{ *:[i8] }:{ *:[i8] } (imm:{ *:[i8] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::MOVI8di),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 333,
      GIR_EraseRootFromParent_Done,
    // Label 141: @3567
    GIM_Reject,
    // Label 138: @3568
    GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3590), // Rule ID 334 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOVI16ri:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::MOVI16ri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 334,
      GIR_EraseRootFromParent_Done,
    // Label 142: @3590
    GIM_Reject,
    // Label 139: @3591
    GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(3613), // Rule ID 335 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOVI32ri:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::MOVI32ri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 335,
      GIR_EraseRootFromParent_Done,
    // Label 143: @3613
    GIM_Reject,
    // Label 140: @3614
    GIM_Reject,
    // Label 13: @3615
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 146*/ GIMT_Encode4(3742),
    /*GILLT_s16*//*Label 144*/ GIMT_Encode4(3634),
    /*GILLT_s32*//*Label 145*/ GIMT_Encode4(3691),
    // Label 144: @3634
    GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3690), // Rule ID 585 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      // (sext:{ *:[i16] } i8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src), MxSubRegIndex16Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 585,
      GIR_EraseRootFromParent_Done,
    // Label 147: @3690
    GIM_Reject,
    // Label 145: @3691
    GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3716), // Rule ID 590 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (sext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 590,
      GIR_Done,
    // Label 148: @3716
    GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(3741), // Rule ID 595 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 595,
      GIR_Done,
    // Label 149: @3741
    GIM_Reject,
    // Label 146: @3742
    GIM_Reject,
    // Label 14: @3743
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 153*/ GIMT_Encode4(4017),
    /*GILLT_s8*//*Label 150*/ GIMT_Encode4(3766),
    /*GILLT_s16*//*Label 151*/ GIMT_Encode4(3827),
    /*GILLT_s32*//*Label 152*/ GIMT_Encode4(3922),
    // Label 150: @3766
    GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3826), // Rule ID 676 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (sext_inreg:{ *:[i8] } i8:{ *:[i8] }:$src, i1:{ *:[Other] })  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, 1:{ *:[i8] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::AND8di),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG8d),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 676,
      GIR_EraseRootFromParent_Done,
    // Label 154: @3826
    GIM_Reject,
    // Label 151: @3827
    GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3921),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3867), // Rule ID 647 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i16] } i16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXT16:{ *:[i16] }:{ *:[i8] } ?:{ *:[i16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::EXT16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 647,
        GIR_EraseRootFromParent_Done,
      // Label 156: @3867
      GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3920), // Rule ID 677 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i16] } i16:{ *:[i16] }:$src, i1:{ *:[Other] })  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, 1:{ *:[i16] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::AND16di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG16d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 677,
        GIR_EraseRootFromParent_Done,
      // Label 157: @3920
      GIM_Reject,
    // Label 155: @3921
    GIM_Reject,
    // Label 152: @3922
    GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(4016),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3962), // Rule ID 648 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (EXT32:{ *:[i32] }:{ *:[i8] } ?:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::EXT32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 648,
        GIR_EraseRootFromParent_Done,
      // Label 159: @3962
      GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(4015), // Rule ID 678 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, 1:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::AND32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::NEG32d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 678,
        GIR_EraseRootFromParent_Done,
      // Label 160: @4015
      GIM_Reject,
    // Label 158: @4016
    GIM_Reject,
    // Label 153: @4017
    GIM_Reject,
    // Label 15: @4018
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 163*/ GIMT_Encode4(4145),
    /*GILLT_s16*//*Label 161*/ GIMT_Encode4(4037),
    /*GILLT_s32*//*Label 162*/ GIMT_Encode4(4094),
    // Label 161: @4037
    GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(4093), // Rule ID 600 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      // (zext:{ *:[i16] } i8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src), MxSubRegIndex16Lo:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
      // GIR_Coverage, 600,
      GIR_EraseRootFromParent_Done,
    // Label 164: @4093
    GIM_Reject,
    // Label 162: @4094
    GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(4119), // Rule ID 605 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (zext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 605,
      GIR_Done,
    // Label 165: @4119
    GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4144), // Rule ID 610 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 610,
      GIR_Done,
    // Label 166: @4144
    GIM_Reject,
    // Label 163: @4145
    GIM_Reject,
    // Label 16: @4146
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 170*/ GIMT_Encode4(4376),
    /*GILLT_s8*//*Label 167*/ GIMT_Encode4(4169),
    /*GILLT_s16*//*Label 168*/ GIMT_Encode4(4238),
    /*GILLT_s32*//*Label 169*/ GIMT_Encode4(4307),
    // Label 167: @4169
    GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(4237),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4218), // Rule ID 339 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (SHL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SHL8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 339,
        GIR_EraseRootFromParent_Done,
      // Label 172: @4218
      GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4236), // Rule ID 336 //
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SHL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 336,
        GIR_Done,
      // Label 173: @4236
      GIM_Reject,
    // Label 171: @4237
    GIM_Reject,
    // Label 168: @4238
    GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4306),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4287), // Rule ID 340 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (SHL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SHL16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 340,
        GIR_EraseRootFromParent_Done,
      // Label 175: @4287
      GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4305), // Rule ID 337 //
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SHL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 337,
        GIR_Done,
      // Label 176: @4305
      GIM_Reject,
    // Label 174: @4306
    GIM_Reject,
    // Label 169: @4307
    GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4375),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4356), // Rule ID 341 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (SHL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::SHL32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 341,
        GIR_EraseRootFromParent_Done,
      // Label 178: @4356
      GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4374), // Rule ID 338 //
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SHL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 338,
        GIR_Done,
      // Label 179: @4374
      GIM_Reject,
    // Label 177: @4375
    GIM_Reject,
    // Label 170: @4376
    GIM_Reject,
    // Label 17: @4377
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 183*/ GIMT_Encode4(4607),
    /*GILLT_s8*//*Label 180*/ GIMT_Encode4(4400),
    /*GILLT_s16*//*Label 181*/ GIMT_Encode4(4469),
    /*GILLT_s32*//*Label 182*/ GIMT_Encode4(4538),
    // Label 180: @4400
    GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4468),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4449), // Rule ID 345 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (LSR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::LSR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 345,
        GIR_EraseRootFromParent_Done,
      // Label 185: @4449
      GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4467), // Rule ID 342 //
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (LSR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 342,
        GIR_Done,
      // Label 186: @4467
      GIM_Reject,
    // Label 184: @4468
    GIM_Reject,
    // Label 181: @4469
    GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(4537),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4518), // Rule ID 346 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (LSR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::LSR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 346,
        GIR_EraseRootFromParent_Done,
      // Label 188: @4518
      GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(4536), // Rule ID 343 //
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (LSR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 343,
        GIR_Done,
      // Label 189: @4536
      GIM_Reject,
    // Label 187: @4537
    GIM_Reject,
    // Label 182: @4538
    GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(4606),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(4587), // Rule ID 347 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (LSR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 347,
        GIR_EraseRootFromParent_Done,
      // Label 191: @4587
      GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(4605), // Rule ID 344 //
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (LSR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 344,
        GIR_Done,
      // Label 192: @4605
      GIM_Reject,
    // Label 190: @4606
    GIM_Reject,
    // Label 183: @4607
    GIM_Reject,
    // Label 18: @4608
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 196*/ GIMT_Encode4(4838),
    /*GILLT_s8*//*Label 193*/ GIMT_Encode4(4631),
    /*GILLT_s16*//*Label 194*/ GIMT_Encode4(4700),
    /*GILLT_s32*//*Label 195*/ GIMT_Encode4(4769),
    // Label 193: @4631
    GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4699),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4680), // Rule ID 351 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ASR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ASR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 351,
        GIR_EraseRootFromParent_Done,
      // Label 198: @4680
      GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4698), // Rule ID 348 //
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ASR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 348,
        GIR_Done,
      // Label 199: @4698
      GIM_Reject,
    // Label 197: @4699
    GIM_Reject,
    // Label 194: @4700
    GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4768),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4749), // Rule ID 352 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ASR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ASR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 352,
        GIR_EraseRootFromParent_Done,
      // Label 201: @4749
      GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4767), // Rule ID 349 //
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ASR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 349,
        GIR_Done,
      // Label 202: @4767
      GIM_Reject,
    // Label 200: @4768
    GIM_Reject,
    // Label 195: @4769
    GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4837),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4818), // Rule ID 353 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ASR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 353,
        GIR_EraseRootFromParent_Done,
      // Label 204: @4818
      GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4836), // Rule ID 350 //
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ASR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 350,
        GIR_Done,
      // Label 205: @4836
      GIM_Reject,
    // Label 203: @4837
    GIM_Reject,
    // Label 196: @4838
    GIM_Reject,
    // Label 19: @4839
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 209*/ GIMT_Encode4(5069),
    /*GILLT_s8*//*Label 206*/ GIMT_Encode4(4862),
    /*GILLT_s16*//*Label 207*/ GIMT_Encode4(4931),
    /*GILLT_s32*//*Label 208*/ GIMT_Encode4(5000),
    // Label 206: @4862
    GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(4930),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(4911), // Rule ID 363 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROR8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 363,
        GIR_EraseRootFromParent_Done,
      // Label 211: @4911
      GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4929), // Rule ID 360 //
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 360,
        GIR_Done,
      // Label 212: @4929
      GIM_Reject,
    // Label 210: @4930
    GIM_Reject,
    // Label 207: @4931
    GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4999),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4980), // Rule ID 364 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROR16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 364,
        GIR_EraseRootFromParent_Done,
      // Label 214: @4980
      GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4998), // Rule ID 361 //
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 361,
        GIR_Done,
      // Label 215: @4998
      GIM_Reject,
    // Label 213: @4999
    GIM_Reject,
    // Label 208: @5000
    GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5068),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5049), // Rule ID 365 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROR32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 365,
        GIR_EraseRootFromParent_Done,
      // Label 217: @5049
      GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5067), // Rule ID 362 //
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 362,
        GIR_Done,
      // Label 218: @5067
      GIM_Reject,
    // Label 216: @5068
    GIM_Reject,
    // Label 209: @5069
    GIM_Reject,
    // Label 20: @5070
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 222*/ GIMT_Encode4(5300),
    /*GILLT_s8*//*Label 219*/ GIMT_Encode4(5093),
    /*GILLT_s16*//*Label 220*/ GIMT_Encode4(5162),
    /*GILLT_s32*//*Label 221*/ GIMT_Encode4(5231),
    // Label 219: @5093
    GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(5161),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(5142), // Rule ID 357 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROL8di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 357,
        GIR_EraseRootFromParent_Done,
      // Label 224: @5142
      GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(5160), // Rule ID 354 //
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 354,
        GIR_Done,
      // Label 225: @5160
      GIM_Reject,
    // Label 223: @5161
    GIM_Reject,
    // Label 220: @5162
    GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(5230),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(5211), // Rule ID 358 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROL16di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 358,
        GIR_EraseRootFromParent_Done,
      // Label 227: @5211
      GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(5229), // Rule ID 355 //
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 355,
        GIR_Done,
      // Label 228: @5229
      GIM_Reject,
    // Label 226: @5230
    GIM_Reject,
    // Label 221: @5231
    GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(5299),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(5280), // Rule ID 359 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(M68k::ROL32di),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 359,
        GIR_EraseRootFromParent_Done,
      // Label 230: @5280
      GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(5298), // Rule ID 356 //
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 356,
        GIR_Done,
      // Label 231: @5298
      GIM_Reject,
    // Label 229: @5299
    GIM_Reject,
    // Label 222: @5300
    GIM_Reject,
    // Label 21: @5301
    GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(5567),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(5447), // Rule ID 672 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mulhu:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UMULd32i16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UMULd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 672,
        GIR_EraseRootFromParent_Done,
      // Label 233: @5447
      GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(5566), // Rule ID 668 //
        // (mulhu:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (LSR32di:{ *:[i32] }:{ *:[i8] } (LSR32di:{ *:[i32] }:{ *:[i8] } (UMULd32d16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::UMULd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 668,
        GIR_EraseRootFromParent_Done,
      // Label 234: @5566
      GIM_Reject,
    // Label 232: @5567
    GIM_Reject,
    // Label 22: @5568
    GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(5834),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(5714), // Rule ID 671 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mulhs:{ *:[i16] } i16:{ *:[i16] }:$dst, (imm:{ *:[i16] }):$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SMULd32i16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), (imm:{ *:[i16] }):$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SMULd32i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_CopyConstantAsSImm, /*NewInsnID*/3, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 671,
        GIR_EraseRootFromParent_Done,
      // Label 236: @5714
      GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(5833), // Rule ID 667 //
        // (mulhs:{ *:[i16] } i16:{ *:[i16] }:$dst, i16:{ *:[i16] }:$opd)  =>  (EXTRACT_SUBREG:{ *:[i16] } (ASR32di:{ *:[i32] }:{ *:[i8] } (ASR32di:{ *:[i32] }:{ *:[i8] } (SMULd32d16:{ *:[i32] }:{ *:[i8] } (MOVXd32d16:{ *:[i32] }:{ *:[i8] } ?:{ *:[i16] }:$dst), ?:{ *:[i16] }:$opd), 8:{ *:[i32] }), 8:{ *:[i32] }), MxSubRegIndex16Lo:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(M68k::MOVXd32d16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // dst
        GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(M68k::SMULd32d16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // opd
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(M68k::MxSubRegIndex16Lo),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::DR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::DR32RegClassID),
        // GIR_Coverage, 667,
        GIR_EraseRootFromParent_Done,
      // Label 237: @5833
      GIM_Reject,
    // Label 235: @5834
    GIM_Reject,
    // Label 23: @5835
    GIM_Reject,
    }; // Size: 5836 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
